jQuery(document).ready(function ($) {
  // Parse the Google API Console State JSON string into a JavaScript object
  var GSCAOauthStateObject = typeof my_dpc_google_console_connection_state !== 'undefined' ? JSON.parse(my_dpc_google_console_connection_state) : null;
  
  // Check if the Google API Console auth_state property is defined
  if (GSCAOauthStateObject && GSCAOauthStateObject.auth_state === '1') {
      // Change the state to green
      $('#authorizeGscOverApiBtn a').removeClass('btn-danger').addClass('btn-success');
  }

  var client;
  var parsedClient;
  var parsedRedirectUri;

  function initClient() {
    try {
      parsedClient = JSON.parse(my_client_id);
      parsedRedirectUri = JSON.parse(my_redirect_uris);

      // Get the current URL of the site
      var currentUrl = window.location.href;

      // Check if the current URL matches any redirect URI
      var matchedRedirectUri = parsedRedirectUri.redirect_uris.find(function (uri) {
        return currentUrl.indexOf(uri) !== -1;
      });

      // If a matching redirect URI is found, use it
      if (matchedRedirectUri) {
        // Redirect to the matched URI
        console.log("matchedRedirectUri: ", matchedRedirectUri);
      } else {
        console.log("No matching redirect URI found for the current URL.");
      }

      if (!parsedClient || !parsedClient.client_id) {
        throw new Error("Error: client_id is not defined");
      }

      client = google.accounts.oauth2.initCodeClient({
        client_id: parsedClient.client_id,
        scope: "https://www.googleapis.com/auth/webmasters.readonly",
        access_type: "offline",
        ux_mode: "redirect",
        redirect_uri: matchedRedirectUri,
      });
    } catch (error) {
      console.error("Error:", error);
      // Handle the error, show a warning, or return as needed
    }
  }

  function getToken() {
    if (client) {
      try {
        client.requestCode();
      } catch (error) {
        console.error("Error requesting code:", error);
        // Handle the error, show a warning, or return as needed
      }
    } else {
      console.error("Error: Client not initialized");
    }
  }

  $("#authorizeGscOverApiBtn a").click(function (e) {
    e.preventDefault();

    // Check if my_client_id and my_redirect_uris are defined before calling initClient and getToken
    if (typeof my_client_id !== "undefined" && typeof my_redirect_uris !== "undefined") {
      initClient();
      getToken();
    } else {
      console.error("Error: my_client_id or my_redirect_uris is not defined");
      // Handle the error, show a warning, or return as needed
    }
  });
});
