
/**
 * Adding custom button(s) to gutenberg post header toolbar
 * 
 * @param {Object} window
 * @param {Object} wp
 */
( function( window, wp ){
    var link_id = 'dpc_gutenberg_link';
	
    var link_html = '<a id="' + link_id + '" class="components-button has-icon" href="'+dpc_gutenberg_functions.dpc_button_url+'" ><svg width="24" height="24" enable-background="new 0 0 512 512" viewBox="0 0 512 512" xmlns="http://www.w3.org/2000/svg"><path d="m81 102.5h183.8c97.9 0 166.2 62.8 166.2 152.6 0 91-68.4 154.5-166.2 154.5h-183.8l95.5-109.9h67.7l-44.5 51h65.1c55.9 0 98-41.1 98-95.6 0-52.6-43-93.8-98-93.8h-65.1l44.5 50.8h-67.7z"/></svg></a>';

    var editorElem = document.getElementById( 'editor' );
    if( !editorElem ){ return; }

    var append = wp.data.subscribe( function () {
        setTimeout( function () {
            if ( !document.getElementById( link_id ) ) {
                var toolbarElem = editorElem.querySelector( '.edit-post-header__settings .interface-pinned-items' );
                if( toolbarElem instanceof HTMLElement ){
                    toolbarElem.insertAdjacentHTML( 'afterbegin', link_html );
                }
            }
        }, 1 )
    } );

} )( window, wp )

jQuery(document).ready(function ($) {	
	
	$(document).on('click','#dpc_gutenberg_link', function(event){
	    event.preventDefault();
		
		var modaltrigger 	= new $.ModalTrigger();
				
		modaltrigger.load_modal(jQuery(this).attr('href'), true);
	});
	
});