window.modalBeforeSubmitCallbacks 	= [];
window.modalSuccessSubmitCallbacks 	= [];
window.modalSubmittedData 			= [];
window.modalTimeouts	 			= [];
window.modalOnTabEnterCallbacks		= [];
window.modalOnTabLeaveCallbacks		= [];
window.modalCurrentId 				= false;
window.modalSubmitAllowed			= true;
window.wpListTableEntry 			= '';
window.onunload 					= null;
window.onbeforeunload 				= null;

jQuery(document).ready(function($){
	"use strict";

	if(typeof(modalLoaded) == 'undefined'){

		function transformFormDataArray(arr){
			var newArr = [];
			$.each(arr, function(k, v){
				newArr[v.name] = v;
			});
			return newArr;
		}

		function search(nameKey, prop, myArray, getIndex){
		    for (var i=0; i < myArray.length; i++) {
		        if (myArray[i][prop]=== nameKey) {
		        	if(getIndex == true){
		        		return i;
		        	}
		            return myArray[i];
		        }
		    }
		}

		function countInput(){ }

		$('#dpc-seo-popover-check-in-google-button').css('display', 'none').attr('href','https://www.google.com/search?q=site%3A'+ encodeURI($('form[name="dpc_modal_data"] input[name="dpc_permalink"]').val()));
		
		$('#toggle_modal_position').on('click', function(ev){
			ev.preventDefault();
			$('body').toggleClass('dpc-modal-position-bottom');
		})
		
		$('.dpc-input-counter .has-counter').on('keyup', function(){
			var $this		= $(this);
			var maximum 	= $this.attr('data-maximum');
			var current		= $this.val().length;
			var range 		= current/maximum;
			var alert		= '';
			var parent		= $this.parents().closest('.dpc-input-counter');

			$(parent).children().find('.current-count').html(current);

			if(range >= 0.75 && range <= 0.99){
				$this.attr('data-status','alert');
			} else if(range >= 1.00){
				$this.attr('data-status','danger');
			} else {
				$this.attr('data-status','green');
			}
		});

		/*
		 * Apply jquery.form to the modal form
		 **/
		$('form[name="dpc_modal_data"]').on('submit', function(){
			$(this).ajaxSubmit({
				dataType: 'json',
				success: function(response, statusText, xhr, form) {
					dpcModalSuccess(response, statusText, xhr, form, transformFormDataArray(window.modalSubmittedData));
					$.each(window.modalSuccessSubmitCallbacks, function(k, callback){
						callback(response, statusText, xhr, form, transformFormDataArray(window.modalSubmittedData));
					});
				},
				beforeSubmit: function(arr, $form, options) {
					$.each(window.modalBeforeSubmitCallbacks, function(k, callback){
						callback(arr, $form, options);
					});

					var jsErrorIndex = search('dpc_js_error', 'name', arr, true);
					if(typeof(jsErrorIndex) !== 'undefined'){
						arr.splice(jsErrorIndex, 1);
					}

					window.modalSubmittedData = arr;
					if(!window.modalSubmitAllowed){
						return false;
					}
				}
			});
			return false;
		});

		/**
		 * Modal save button triggers the modal form submit event
		 */
		$('#dpc-seo-popover-save-button').on('click', function(ev){
			window.onunload = null;
			window.onbeforeunload = null;
			ev.preventDefault();

			$('form[name="dpc_modal_data"]').ajaxSubmit({
				dataType: 'json',
				success: function(response, statusText, xhr, form) {
					window.onunload = null;
					window.onbeforeunload = null;

					dpcModalSuccess(response, statusText, xhr, form, transformFormDataArray(window.modalSubmittedData));
					$.each(window.modalSuccessSubmitCallbacks, function(k, callback){
						callback(response, statusText, xhr, form, transformFormDataArray(window.modalSubmittedData));
					});
				},
				beforeSubmit: function(arr, $form, options) {
					$.each(window.modalBeforeSubmitCallbacks, function(k, callback){
						callback(arr, $form, options);
					});

					var jsErrorIndex = search('dpc_js_error', 'name', arr, true);
					if(typeof(jsErrorIndex) !== 'undefined'){
						arr.splice(jsErrorIndex, 1);
					}

					window.onbeforeunload = null;
					window.modalSubmittedData = arr;
					if(!window.modalSubmitAllowed){
						return false;
					}
				}
			});
		});

		/**
		 * Modal close button
		 */
		$('#dpc-seo-popover-close-button').bind('click', function(ev){
			ev.preventDefault();
			$('#dpc_post_seo_popover').removeClass('active dpc-no-animation');
			$('body').removeClass('dpc-popover-active');
			$('#dpc_post_seo_popover > .dpc-seo-popover-content').removeClass('content-appended').html('<span class="dpc-seo-popover-loader"><img id="dpc_seo_popover_loader_img" src=""/></span>');
		});

		function dpcModalSuccess(response, statusText, xhr, form, data){
			window.modalCurrentId	= data['dpc_current_id'].value;
			window.wpListTableEntry = $('.wp-list-table #post-'+window.modalCurrentId);

			//change status
			if(typeof(response.status) !== 'undefined'){
				//within listing table
				$.each(response.status, function(module, value){
					$('td.column-dpc-seo-modal .delucks-seo-status-' + module , window.wpListTableEntry).attr('status', value);
					if(typeof(dpc_seo_status_text['status_' + value]) !== 'undefined'){
						$('td.column-dpc-seo-modal .delucks-seo-status-' + module , window.wpListTableEntry).attr('title', dpc_seo_status_text['status_' + value]);
					}
				});

				//within admin bar
				$.each(response.status, function(module, value){
					$('#wpadminbar #wp-admin-bar-delucks-seo-' + module + ' .delucks-seo-status-' + module).attr('status', value);
					if(typeof(dpc_seo_status_text['status_' + value]) !== 'undefined'){
						$('#wpadminbar #wp-admin-bar-delucks-seo-' + module + ' .delucks-seo-status-' + module).attr('title', dpc_seo_status_text['status_' + value]);
					}
				});
			}

			//set recheck timestamp
			if(typeof(response.recheck) !== 'undefined'){
				$('td.column-dpc-seo-modal .recheckTimestamp', window.wpListTableEntry).val(response.recheck);
				$('td.column-dpc-seo-modal .delucks-seo-recheck-icon', window.wpListTableEntry).removeClass('active');
			}

			//show messages
			$('.dpc_modal_message', form).removeClass('error', 'success').addClass(response.type).html(response.message);
			modalAddMessages(response);
			showResponseMessage(response);
		}

		var modalLoaded = true;
	}

	/***************************************************************************************************************/

	function modalAddMessages(response){
		$.each(response.messages, function(k, v){
			$('#content-dpc-notices .messages').append('<div class="notice notice-'+v['type']+' dpc-notice-entry unread '+v['type']+'">'+v['icon']+' <span class="time">'+v['timestamp']+'</span> <span class="user">'+v['user']+'</span> <span class="message">'+v['message']+'</span> </div>');
		});

		if($('#tab-dpc-notices').hasClass('active')){
			modalMarkMessagesAsRead();
		} else {
			checkMessageCount();
		}
	}

	function showResponseMessage(response){
		$.each(response.messages, function(k, v){

			if(v['type'] == 'success'){
				$('#dpc-seo-popover-save-button').attr('disabled', true).addClass('dpc-btn-status-success').html('<i class="icon dashicons dashicons-yes"></i>' + dpc_seo_status_text.saved);
			}else{
				$('#dpc-seo-popover-save-button').attr('disabled', true).addClass('dpc-btn-status-error').html('<i class="icon dashicons dashicons-no"></i>' + dpc_seo_status_text.error);
				$('.dpc-modal-tabs').after('<div id="dpc_response_message_'+k+'" class="notice notice-'+v['type']+' dpc-notice-entry"><p>'+v['message']+'</p></div>');
			}

			setTimeout(function(){
				$('#dpc_response_message_'+k).remove();
				$('#dpc-seo-popover-save-button').attr('disabled', false).attr('class', 'button button-primary button-large').html(dpc_seo_status_text.save);
			}, 3000);
		});
	}

	function modalMarkMessagesAsRead(){
		window.modalTimeouts['markMessagesAsReadTimeout'] = setTimeout(function(){
			if($('#content-dpc-notices .messages .dpc-notice-entry.unread').length){
				var id = $('form[name="dpc_modal_data"] input[name="dpc_current_id"]').val();
				$.ajax({url: ajaxurl, data: {action: 'dpc_post_messages_mark_all_as_read', id: id}}).done(function(){
					$('#content-dpc-notices .messages .dpc-notice-entry.unread').removeClass('unread');
					checkMessageCount();
				});
			}
		}, 3000);
	}

	function modalClearMessages(){
		var id = $('form[name="dpc_modal_data"] input[name="dpc_current_id"]').val();
		$.ajax({url: ajaxurl, data: {action: 'dpc_post_messages_clear', id: id}}).done(function(){
			$('#content-dpc-notices .messages').html('');
			$('#dpc-notices-count').text(0);
			checkMessageCount();
		});
	}

	function checkMessageCount(){
		$('#tab-dpc-notices .dpc-indicator-count').text($('#content-dpc-notices .messages .dpc-notice-entry.unread').length);
		if($('#content-dpc-notices .messages .dpc-notice-entry.unread').length > 0){
			$('#tab-dpc-notices').addClass('has-indications');
		} else {
			$('#tab-dpc-notices').removeClass('has-indications');
		}
	}

	/**
	 *
	 * Tasks
	 *
	 **/
	$('#content-dpc-tasks .clearTasks').on('click', function(){
		modalClearTasks();
	});

	$('body').delegate('#content-dpc-tasks .remove-task', 'click', function(){
		var id 		= $('form[name="dpc_modal_data"] input[name="dpc_current_id"]').val(),
			taskid 	= $(this).parents('.dpc-tasks-entry').attr('data-taskid');

		$.ajax({url: ajaxurl, data: {action: 'dpc_tasks_remove_task', id: id, taskid: taskid}}).done(function(){
			$('#content-dpc-tasks .tasks [data-taskid="'+taskid+'"]').remove();
			checkTaskCount();
		});
	});

	$('body').delegate('#content-dpc-tasks .dpc-tasks-entry', 'click', function(){
		var id 			= $('form[name="dpc_modal_data"] input[name="dpc_current_id"]').val(),
			taskid 		= $(this).attr('data-taskid'),
			status 		= $(this).attr('data-status'),
			nextState	= $(this).attr('data-next-status');

		if(status == 'undone'){
			status = 'done';
			nextState = 'hold';
		} else if(status == 'done'){
			status = 'hold';
			nextState = 'undone';
		} else {
			status = 'undone';
			nextState = 'done';
		}

		$.ajax({url: ajaxurl, dataType: 'json', data: {action: 'dpc_tasks_change_task_status', id: id, taskid: taskid, status: status}}).done(function(task){
			$('#content-dpc-tasks .dpc-tasks-entry[data-taskid="'+task['taskid']+'"]').attr({
				'data-status': task['status'],
				'data-next-status': nextState
			});
			$('#content-dpc-tasks .dpc-tasks-entry[data-taskid="'+task['taskid']+'"] .dpc-notice-list-content').attr({'dpc-tooltip': 'Mark task as '+nextState});
			$('#content-dpc-tasks .dpc-tasks-entry[data-taskid="'+task['taskid']+'"] .dpc-notice-list-status .status').text( task['status'] );
			checkTaskCount();
		});

	});

	$('body').delegate('#content-dpc-tasks .addTask', 'click', function(){
		var id 		= $('form[name="dpc_modal_data"] input[name="dpc_current_id"]').val();
		var task 	= $('form[name="dpc_modal_data"] input[name="task"]').val();

		if(task.length == 0){
			return;
		}

		$.ajax({url: ajaxurl, dataType: 'json', data: {action: 'dpc_tasks_add_task', id: id, task: task}}).done(function(task){
			var taskTemplate = '	<div data-taskid="'+task['taskid']+'" data-status="'+task['status']+'" class="notice notice-info dpc-tasks-entry dpc-notice-list-entry">'+
				'<div class="dpc-notice-list-content dpc-task-content">'+
					'<div class="dpc-notice-list-title dpc-task-title" dpc-tooltip="Mark task as done">'+
						'<span class="time">'+task['timestamp']+' - </span>'+
						'<span class="user">'+task['user']+'</span>'+
					'</div>'+
					'<div class="dpc-notice-list-status">'+
						'<strong>Status:</strong> <span class="status">'+task['status']+'</span>'+
					'</div>'+
					'<span class="message">'+task['task']+'</span>'+
				'</div>'+
				'<div class="dpc-notice-list-actions dpc-task-actions">'+
					'<span class="dashicons dashicons-no-alt remove-task"></span>'+
				'</div>'+
			'</div>';
			$('#content-dpc-tasks .tasks').append(taskTemplate);
			checkTaskCount();
		});

		$('form[name="dpc_modal_data"] input[name="task"]').val('').focus();
	});

	$('form[name="dpc_modal_data"] input[name="task"]').on('keypress', function(e){
		if(e.which == 13) {
			$('#content-dpc-tasks .addTask').trigger('click');
		}
	});

	function modalClearTasks(){
		var id = $('form[name="dpc_modal_data"] input[name="dpc_current_id"]').val();
		$.ajax({url: ajaxurl, data: {action: 'dpc_tasks_clear_tasks', id: id}}).done(function(){
			$('#content-dpc-tasks .tasks').html('');
			$('#dpc-tasks-count').text(0);
			checkTaskCount();
		});
	}

	function checkTaskCount(){
		$('#tab-dpc-tasks .dpc-indicator-count').text($('#content-dpc-tasks .tasks .dpc-tasks-entry[data-status="undone"]').length);
		if($('#content-dpc-tasks .tasks .dpc-tasks-entry[data-status="undone"]').length > 0){
			$('#tab-dpc-tasks').addClass('has-indications');
		} else {
			$('#tab-dpc-tasks').removeClass('has-indications');
		}
	}

	/**
	 *
	 * Tabs
	 *
	 **/
	$('.dpc-modal-tabs > span').on('click', function(){
		clearTimeout(window.modalTimeouts['markMessagesAsReadTimeout']);

		var parentTabId		= $('.active', $(this).parent()).attr('id');
		var currentTabId	= $(this).attr('id');

		if(currentTabId == parentTabId){
			return false;
		}

		if(typeof(window.modalOnTabLeaveCallbacks[parentTabId]) !== 'undefined'){
			$.each(window.modalOnTabLeaveCallbacks[parentTabId], function(k, callback){
				callback();
			});
		}

		if(typeof(window.modalOnTabEnterCallbacks[currentTabId]) !== 'undefined'){
			$.each(window.modalOnTabEnterCallbacks[currentTabId], function(k, callback){
				callback();
			});
		}

		$(this).addClass('active').siblings().removeClass('active');
		$('.dpc-modal-contents > div:eq('+$(this).index()+')').addClass('active').siblings().removeClass('active');
		if($(this).is($('#tab-dpc-notices'))){
			modalMarkMessagesAsRead();
		}
	});

	$('#content-dpc-notices .clearMessages').on('click', function(){
		modalClearMessages();
	});

	checkMessageCount();

	/**
	 * Image file input
	 */
	/*
	if(jQuery('.dpc-fileinput').length > 0){

		if(jQuery('.dpc-fileinput').hasClass('has-alt-input')){
			var wrapper 	= jQuery('.dpc-fileinput.has-alt-input'),
				holder		= jQuery(wrapper).find('img.dpc-file-holder'),
				input 		= jQuery('input#' + jQuery(wrapper).attr('data-input-id'));

			jQuery(holder).attr('src', jQuery(input).val());
		}

		jQuery('.dpc-fileinput').each(function(){
			if(jQuery(this).children().find('.dpc-fileinput-input').val()){
				jQuery(this).removeClass('fileinput-new');
			}
		});

		jQuery('.dpc-file-upload-button').on('click', function( event ){
			event.preventDefault();
			startMediaBrowser(jQuery(this));
		});
		jQuery('.upload-dpc-file').on('click', function( event ){
			event.preventDefault();
			startMediaBrowser(jQuery(this));
		});
		jQuery('.remove-dpc-file').on('click', function( event ){
			event.preventDefault();
			var name 	= jQuery(this).data('name'),
				wrapper = jQuery(this).parents().closest('.dpc-fileinput'),
				holder	= jQuery(wrapper).find('img.dpc-file-holder');
				input 	= (jQuery(wrapper).hasClass('has-alt-input') ? jQuery('input#' + jQuery(wrapper).attr('data-input-id')) : jQuery('.dpc-media-uploader > input#'+name));

			jQuery(input).val('');
         	jQuery(holder).attr('src', '');
         	jQuery(wrapper).addClass('fileinput-new');
		});

		function startMediaBrowser(data){
			var name 	= jQuery(data).data('name'),
				wrapper = jQuery(data).parents().closest('.dpc-fileinput'),
				holder	= jQuery(wrapper).find('img.dpc-file-holder'),
				input 	= (jQuery(wrapper).hasClass('has-alt-input') ? jQuery('#' + jQuery(wrapper).attr('data-input-id')) : jQuery('.dpc-media-uploader > input#'+name));


			jQuery(input).val('');

	      	//If the frame already exists, reopen it
			if (typeof(custom_file_frame)!=="undefined") {
		      	custom_file_frame.close();
			}

	      	var custom_file_frame = wp.media.frames.customHeader = wp.media({
	         	title: 		jQuery(data).data('frame-title'),
	        	library: 	{ type: 'image' },
	         	button: 	{ text: dpc_seo_status_text.save },
				multiple: 	false
			});

	      	//callback for selected image
			custom_file_frame.on('select', function() {
				var attachment = custom_file_frame.state().get('selection').first().toJSON();

	         	jQuery(input).val(attachment.url);
	         	jQuery(holder).attr('src', attachment.url).show();
	         	jQuery(wrapper).removeClass('fileinput-new');
			});

			custom_file_frame.open();
		}
	}
	*/
});