<?php

if(!class_exists('DPC_Admin_Tax_Metaboxes')){
	class DPC_Admin_Tax_Metaboxes extends DPC_Admin_Settings {
	
	
		protected $title = '';
	
		protected $slug = '';
	
	
		protected $term_id = 0;
	  
	
	  	public function __construct( $title = '', $slug = '', $taxonomy = 'category') {
			if( $slug == '' )  {
				return;
			}
		
			if( $title == '' ) {
				$this->title = ucfirst( $slug );
			}
		
			$this->title = $title; 
			$this->slug = $slug;
			$this->settings_id = $this->slug; 
		
			add_action( 'edit_term', array( $this, 'save_meta_settings' ) );
			add_action( 'create_term', array( $this, 'save_meta_settings' ) );
			add_action( $taxonomy.'_add_form_fields', array( $this, 'render' ) );
			add_action( $taxonomy.'_edit_form_fields', array( $this, 'render' ) );
		}
				
		public function render( $taxonomy ) {
			
			$this->term_id = $taxonomy->term_id;
			$this->init_settings(); 
		
			wp_nonce_field( 'metabox_' . $this->slug, 'metabox_' . $this->slug . '_nonce' );
			echo '<table class="form-table">';
			  $this->render_fields( 'general' ); 
			echo '</table>';
		}
		
		 /**
		 * Get the settings from the database
		 * @return void 
		 */
		public function init_settings() {
			
			$term_id = $this->term_id;
			if ('' !== get_term_meta( $term_id, $this->settings_id, true ) ) {
				$this->settings = (array) get_term_meta( $term_id, $this->settings_id, true );
			}
			//$this->settings = (array) get_post_meta( $term_id, $this->settings_id, true );
		 
			foreach ( $this->fields as $tab_key => $tab ) {
				
				foreach ( $tab as $name => $field ) {
					
					if( isset( $this->settings[ $name ] ) ) {
						$this->fields[ $tab_key ][ $name ]['default'] = $this->settings[ $name ];
					}	
				
				}
			}
		}
		
		public function save_meta_settings( $term_id ) {			
			// Check if our nonce is set.
			if ( ! isset( $_POST['metabox_' . $this->slug . '_nonce'] ) ) {
				return $term_id;
			}
			
			$nonce = $_POST['metabox_' . $this->slug . '_nonce'];
			
			// Verify that the nonce is valid.
			if ( ! wp_verify_nonce( $nonce, 'metabox_' . $this->slug ) ) {
				return $term_id;
			}
			
			/*
			* If this is an autosave, our form has not been submitted,
			* so we don't want to do anything.
			*/
			if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) {
				return $term_id;
			}
									
			// Check the user's permissions.
			if ( !current_user_can( 'manage_categories' ) ) {
				return $term_id;
			}
			
			$this->term_id = $term_id;
			$this->save_term_settings();
			
		}
	
		/**
		 * Save settings from POST
		 * @return [type] [description]
		 */
		public function save_term_settings(){
		 	$this->posted_data = $_POST;
		 	if( empty( $this->settings ) ) {
		 		$this->init_settings();
		 	}
			
		 	foreach ($this->fields as $tab => $tab_data ) {
		 		foreach ($tab_data as $name => $field) {
		 			$this->settings[ $name ] = $this->{ 'validate_' . $field['type'] }( $name );	 					
		 		}
		 	}
			
			if ( get_term_meta( $this->term_id, $this->settings_id, false ) ) {
				update_term_meta( $this->term_id, $this->settings_id, $this->settings );
			} else {
				add_term_meta( $this->term_id, $this->settings_id, $this->settings );
			}
	
			
		}
		
	}	
}