<?php

class DPC_Functions {

	var $dpc = null;

	function __construct(DPC &$dpc){
		$this->dpc = $dpc;
	}

	function getObejctId(){
		return $this->dpc->objectId;
	}

	function isFrontpage($postId = false){
	    $id = $this->dpc->objectId;
	    if(is_numeric($postId)){
	        $id = $postId;
	    }

	    if($id == get_option( 'page_on_front' )){
	        return true;
	    }

	    return false;
	}

	function getEditId(){
		global $post;
		return $post->ID;
	}

	function settingsSectionExists($sectionName = ''){
		return $this->dpc->parseSettingsByXml($this->dpc->lastSettingsFile, $sectionName, false, false, true);
	}

	function getPostDate($postID = null){
	    return get_the_date('Y-m-d', $postID);
	}

	function getRealPostTypes(){
		$posttypes = get_post_types(array('public' => true));
		foreach($posttypes as $k => $v){
			if(in_array($k, array('attachment', 'revision', 'avia_framework', 'avia_framework_post', 'wysijap', 'nav_menu_item'))){
				unset($posttypes[$k]);
			}
		}
		return $posttypes;
	}

	function getObejctType(){
		return $this->dpc->objectType;
	}

	function getPostHits($postId, $average = false){
		$count	= get_post_meta($postId, '_dpc-hits', true);
		if($average){
			if(is_object($post = get_post($postId))){
				$days = round(abs(time()-strtotime($post->post_date))/86400);
				$count = ($count / ($days > 0 ? $days : 1));
				return round($count, 2);

			}
			return 0;
		}

		return ($count ? $count : 0);
	}

	function getCustomPostTypes($skip = ''){
		$skip = explode(',', $skip);
		$skip = array_merge($skip, array('wysijap', 'avia_framework_post'));
		$data = array();
		foreach(get_post_types(array('public' => true))  as $postType){
			if(in_array($postType, $skip)){ continue; }
			$data[] = array('name' => $postType, 'label' => get_post_type_object($postType)->label, 'value' => $postType);
		}
		return $data;
	}

	function getCustomPostTypesByList($list = ''){
	    $data = array();
	    foreach(explode(',', $list)  as $postType){
	        $data[] = array('name' => $postType, 'label' => get_post_type_object($postType)->label, 'value' => $postType);
	    }
	    return $data;
	}

	function plist($list){
		$data = array();
		foreach(explode(',',$list) as $v){
			$data[] = array('label' => trim($v), 'name' => trim(strtolower($v)));
		}
		return $data;
	}


	function getCountries(){
		$data = array();
		$countries = array ('AF'=> 'Afghanistan','AL'=> 'Albania','DZ'=> 'Algeria','AD'=> 'Andorra','AO'=> 'Angola','AI'=> 'Anguilla','AQ'=> 'Antarctica','AR'=> 'Argentina','AM'=> 'Armenia','AW'=> 'Aruba','AU'=> 'Australia','AT'=> 'Austria','AZ'=> 'Azerbaijan','BS'=> 'Bahamas','BH'=> 'Bahrain','BD'=> 'Bangladesh','BB'=> 'Barbados','BY'=> 'Belarus','BE'=> 'Belgium','BZ'=> 'Belize','BJ'=> 'Benin','BM'=> 'Bermuda','BT'=> 'Bhutan','BO'=> 'Bolivia','BA'=> 'Bosnia and Herzegovina','BW'=> 'Botswana','BV'=> 'Bouvet Island','BR'=> 'Brazil','BQ'=> 'British Antarctic Territory','IO'=> 'British Indian Ocean Territory','VG'=> 'British Virgin Islands','BN'=> 'Brunei','BG'=> 'Bulgaria','BF'=> 'Burkina Faso','BI'=> 'Burundi','KH'=> 'Cambodia','CM'=> 'Cameroon','CA'=> 'Canada','CT'=> 'Canton and Enderbury Islands','CV'=> 'Cape Verde','KY'=> 'Cayman Islands','CF'=> 'Central African Republic','TD'=> 'Chad','CL'=> 'Chile','CN'=> 'China','CX'=> 'Christmas Island','CC'=> 'Cocos [Keeling] Islands','CO'=> 'Colombia','KM'=> 'Comoros','CG'=> 'Congo - Brazzaville','CD'=> 'Congo - Kinshasa','CK'=> 'Cook Islands','CR'=> 'Costa Rica','HR'=> 'Croatia','CU'=> 'Cuba','CY'=> 'Cyprus','CZ'=> 'Czech Republic','CI'=> 'Côte d’Ivoire','DK'=> 'Denmark','DJ'=> 'Djibouti','DM'=> 'Dominica','DO'=> 'Dominican Republic','NQ'=> 'Dronning Maud Land','DD'=> 'East Germany','EC'=> 'Ecuador','EG'=> 'Egypt','SV'=> 'El Salvador','GQ'=> 'Equatorial Guinea','ER'=> 'Eritrea','EE'=> 'Estonia','ET'=> 'Ethiopia','FK'=> 'Falkland Islands','FO'=> 'Faroe Islands','FJ'=> 'Fiji','FI'=> 'Finland','FR'=> 'France','GF'=> 'French Guiana','PF'=> 'French Polynesia','TF'=> 'French Southern Territories','FQ'=> 'French Southern and Antarctic Territories','GA'=> 'Gabon','GM'=> 'Gambia','GE'=> 'Georgia','DE'=> 'Germany','GH'=> 'Ghana','GI'=> 'Gibraltar','GR'=> 'Greece','GL'=> 'Greenland','GD'=> 'Grenada','GP'=> 'Guadeloupe','GU'=> 'Guam','GT'=> 'Guatemala','GG'=> 'Guernsey','GN'=> 'Guinea','GW'=> 'Guinea-Bissau','GY'=> 'Guyana','HT'=> 'Haiti','HM'=> 'Heard Island and McDonald Islands','HN'=> 'Honduras','HK'=> 'Hong Kong SAR China','HU'=> 'Hungary','IS'=> 'Iceland','IN'=> 'India','ID'=> 'Indonesia','IR'=> 'Iran','IQ'=> 'Iraq','IE'=> 'Ireland','IM'=> 'Isle of Man','IL'=> 'Israel','IT'=> 'Italy','JM'=> 'Jamaica','JP'=> 'Japan','JE'=> 'Jersey','JT'=> 'Johnston Island','JO'=> 'Jordan','KZ'=> 'Kazakhstan','KE'=> 'Kenya','KI'=> 'Kiribati','KW'=> 'Kuwait','KG'=> 'Kyrgyzstan','LA'=> 'Laos','LV'=> 'Latvia','LB'=> 'Lebanon','LS'=> 'Lesotho','LR'=> 'Liberia','LY'=> 'Libya','LI'=> 'Liechtenstein','LT'=> 'Lithuania','LU'=> 'Luxembourg','MO'=> 'Macau SAR China','MK'=> 'Macedonia','MG'=> 'Madagascar','MW'=> 'Malawi','MY'=> 'Malaysia','MV'=> 'Maldives','ML'=> 'Mali','MT'=> 'Malta','MH'=> 'Marshall Islands','MQ'=> 'Martinique','MR'=> 'Mauritania','MU'=> 'Mauritius','YT'=> 'Mayotte','FX'=> 'Metropolitan France','MX'=> 'Mexico','FM'=> 'Micronesia','MI'=> 'Midway Islands','MD'=> 'Moldova','MC'=> 'Monaco','MN'=> 'Mongolia','ME'=> 'Montenegro','MS'=> 'Montserrat','MA'=> 'Morocco','MZ'=> 'Mozambique','MM'=> 'Myanmar [Burma]','NA'=> 'Namibia','NR'=> 'Nauru','NP'=> 'Nepal','NL'=> 'Netherlands','AN'=> 'Netherlands Antilles','NT'=> 'Neutral Zone','NC'=> 'New Caledonia','NZ'=> 'New Zealand','NI'=> 'Nicaragua','NE'=> 'Niger','NG'=> 'Nigeria','NU'=> 'Niue','NF'=> 'Norfolk Island','KP'=> 'North Korea','VD'=> 'North Vietnam','MP'=> 'Northern Mariana Islands','NO'=> 'Norway','OM'=> 'Oman','PC'=> 'Pacific Islands Trust Territory','PK'=> 'Pakistan','PW'=> 'Palau','PS'=> 'Palestinian Territories','PA'=> 'Panama','PZ'=> 'Panama Canal Zone','PG'=> 'Papua New Guinea','PY'=> 'Paraguay','YD'=> 'People\'s Democratic Republic of Yemen','PE'=> 'Peru','PH'=> 'Philippines','PN'=> 'Pitcairn Islands','PL'=> 'Poland','PT'=> 'Portugal','PR'=> 'Puerto Rico','QA'=> 'Qatar','RO'=> 'Romania','RU'=> 'Russia','RW'=> 'Rwanda','RE'=> 'Réunion','BL'=> 'Saint Barthélemy','SH'=> 'Saint Helena','KN'=> 'Saint Kitts and Nevis','LC'=> 'Saint Lucia','MF'=> 'Saint Martin','PM'=> 'Saint Pierre and Miquelon','VC'=> 'Saint Vincent and the Grenadines','WS'=> 'Samoa','SM'=> 'San Marino','SA'=> 'Saudi Arabia','SN'=> 'Senegal','RS'=> 'Serbia','CS'=> 'Serbia and Montenegro','SC'=> 'Seychelles','SL'=> 'Sierra Leone','SG'=> 'Singapore','SK'=> 'Slovakia','SI'=> 'Slovenia','SB'=> 'Solomon Islands','SO'=> 'Somalia','ZA'=> 'South Africa','GS'=> 'South Georgia and the South Sandwich Islands','KR'=> 'South Korea','ES'=> 'Spain','LK'=> 'Sri Lanka','SD'=> 'Sudan','SR'=> 'Suriname','SJ'=> 'Svalbard and Jan Mayen','SZ'=> 'Swaziland','SE'=> 'Sweden','CH'=> 'Switzerland','SY'=> 'Syria','ST'=> 'São Tomé and Príncipe','TW'=> 'Taiwan','TJ'=> 'Tajikistan','TZ'=> 'Tanzania','TH'=> 'Thailand','TL'=> 'Timor-Leste','TG'=> 'Togo','TK'=> 'Tokelau','TO'=> 'Tonga','TT'=> 'Trinidad and Tobago','TN'=> 'Tunisia','TR'=> 'Turkey','TM'=> 'Turkmenistan','TC'=> 'Turks and Caicos Islands','TV'=> 'Tuvalu','UM'=> 'U.S. Minor Outlying Islands','PU'=> 'U.S. Miscellaneous Pacific Islands','VI'=> 'U.S. Virgin Islands','UG'=> 'Uganda','UA'=> 'Ukraine','SU'=> 'Union of Soviet Socialist Republics','AE'=> 'United Arab Emirates','GB'=> 'United Kingdom','US'=> 'United States','UY'=> 'Uruguay','UZ'=> 'Uzbekistan','VA'=> 'Vatican City','VE'=> 'Venezuela','VN'=> 'Vietnam','WK'=> 'Wake Island','WF'=> 'Wallis and Futuna','EH'=> 'Western Sahara','YE'=> 'Yemen','ZM'=> 'Zambia','ZW'=> 'Zimbabwe','AX'=> 'Åland Islands');

		foreach($countries as $k => $v){
			$data[] = array('name' => $v, 'label' => $v, 'value' => $k);
		}
		return $data;
	}

	function getUserLang(){
		if(defined('ICL_LANGUAGE_CODE')){
			return ICL_LANGUAGE_CODE;
		} else{
			$lang = get_locale();
		}
		$lang = substr($lang, 0, (strpos($lang, '_') ? strpos($lang, '_') : 2));

		return $lang;
	}

	function getMultilanguageHomeUrl(){
		if(function_exists('icl_get_home_url')){
			return icl_get_home_url();
		}
		return get_home_url(null, '/');
	}

	function wpmlActive(){
		if(!function_exists('is_plugin_active')){
			include_once(ABSPATH.'wp-admin/includes/plugin.php');
		}
		if(is_plugin_active('sitepress-multilingual-cms/sitepress.php')){
			return true;
		}
		return false;
	}

	function polylangActive(){
		if(!function_exists('is_plugin_active')){
			include_once(ABSPATH.'wp-admin/includes/plugin.php');
		}
		if(is_plugin_active('polylang/polylang.php') || is_plugin_active('polylang-pro/polylang.php')){
			return true;
		}
		return false;
	}

	function pluginExists($pluginDirectory){
		if(is_readable(ABSPATH.'wp-content/plugins/'.$pluginDirectory.'/')){
			return true;
		}
		return false;
	}

	function getDefaultLanguage($type = 'locale'){
		$lang = get_locale();
		switch($type){
			case 'slug':
				return substr($lang, 0, (strpos($lang, '_') ? strpos($lang, '_') : 2));
				break;
			default:
				return $lang;
				break;
		}
	}

	function getLanguages($skip = ''){
		$skip = explode(',', $skip);
		$data = array();

		if(($this->wpmlActive() || $this->polylangActive()) && function_exists('icl_get_languages')){
			if($this->wpmlActive()){
				$langs = icl_get_languages();
				if(is_array($langs)){
					foreach($langs as $lang){
					    $data[] = array('label' => strtoupper($lang['code']), 'lang_key' => $lang['code'], 'name' => $lang['native_name'], 'english_name' => (isset($lang['english_name']) ? $lang['english_name'] : ''), 'icon_url' => $lang['country_flag_url'], 'url' => $lang['url']);
					}
				}
			} elseif($this->polylangActive()){
				$langs = pll_languages_list();
				if(is_array($langs)){
					foreach($langs as $lang){
						$data[] = array('label' => strtoupper($lang), 'lang_key' => $lang, 'name' => strtoupper($lang), 'icon_url' => 'assets/img/' . substr(get_bloginfo ( 'language' ), 0, 2).'.jpg', 'url' => '');
					}
				}
			}
		}

		if(!count($data)){
			//get default
			$data[] = array('label' => strtoupper(substr(get_locale(), 0, 2)), 'lang_key' => strtolower(substr(get_locale(), 0, 2)), 'name' => strtoupper(substr(get_locale(), 0, 2)), 'icon_url' => 'assets/img/' . strtolower(substr(get_locale(), 0, 2)).'.jpg', 'url' => '');
		}

		return $data;
	}

	function getPostLang($post_id = 0, $array = true){
	    if(!$post_id) { $post_id = get_the_ID(); }
	    if(!$post_id && isset($_GET['post']) && isset($_GET['action']) && $_GET['action'] == 'edit'){ $post_id = $_GET['post']; } // edit page
	    if(!$post_id && isset($_GET['id']) && isset($_GET['action']) && $_GET['action'] == 'dpc_modal_show'){ $post_id = $_GET['id']; } // seo modal

	    if($this->wpmlActive()){
	        if (function_exists('wpml_get_language_information') && intval($post_id) > 0){
	            $lang = apply_filters( 'wpml_post_language_details', NULL, $post_id );
	            if(!is_array($lang)){
	                $lang = wpml_get_language_information($post_id);
	            }

	            if($array == true){
	                return $lang;
	            } else {
	                return $lang['locale'];
	            }
	        } else {
	            return get_locale();
	        }
	    } elseif($this->polylangActive() && function_exists('pll_get_post_language') && function_exists('pll_current_language')){
	        #return get_locale(); //we dont support polylang at this moment
	        if(pll_get_post_language($post_id, 'locale') !== false){
	            return pll_get_post_language($post_id, 'locale');
	        } else {
	            return pll_current_language('locale');
	        }
	    }else{
	        return get_locale();
	    }
	}

	function getModulesIncSubmodules($skip = '', $moduleGroup = false, $ignoreInstances = false){
		$skip = explode(',', $skip);
		$data = array();
		foreach($this->dpc->moduleList as $moduleName => $subModules){
			if(strpos($moduleName,'_') === 0 || in_array($moduleName, array('dpc','suite'))){ continue; }
			foreach($subModules as $subModuleName){
				$moduleKey = $moduleName.'_'.$subModuleName;
				if(strpos($subModuleName,'_') === 0 || in_array($moduleKey, array())){ continue; }

				if(!is_object($this->dpc->moduleInstances[$moduleKey])){
				    switch($subModuleName){
				        case 'breadcrumbs':
				            $moduleTitle = esc_html__('Breadcrumbs', 'delucks-seo');
				            break;
				        case 'externallinks':
				            $moduleTitle = esc_html__('Links', 'delucks-seo');
				            break;
				        case 'microdata':
				            $moduleTitle = esc_html__('Microdata', 'delucks-seo');
				            break;
				        case 'rating':
				            $moduleTitle = esc_html__('Rating', 'delucks-seo');
				            break;
				        case 'sharing':
				            $moduleTitle = esc_html__('Social sharing', 'delucks-seo');
				            break;
				        case 'textopt':
				            $moduleTitle = esc_html__('Text optimization', 'delucks-seo');
				            break;
				    }

				    $moduleTitleShort   = $moduleTitle;
				    $moduleTitle        = esc_html__('Premium', 'delucks-seo') . ': ' . $moduleTitle;
				    $status             = -1;
				} else {
				    $moduleTitleShort   = $this->dpc->moduleInstances[$moduleKey]->moduleTitle;
				    $moduleTitle        = $this->dpc->moduleInstances[$moduleName]->moduleTitle . ': ' . $this->dpc->moduleInstances[$moduleKey]->moduleTitle;
				    $status             = $this->dpc->moduleIsActive($moduleKey);
				}

			    if((is_string($moduleGroup) && $moduleGroup == $moduleName) || $moduleGroup === false){
				    $data[] = array('key'           => $moduleKey,
				                    'keyShort'      => $subModuleName,
            				        'label'         => $moduleTitle,
            				        'labelShort'    => $moduleTitleShort,
				                    'status'        => $status,
				                    'license'       => $moduleName
				              );
			    }
			}
		}
		return $data;
	}

	function getPages($excludeFrontpage = false){
	    $frontpage_id = get_option( 'page_on_front' );
		$data = array();
		$args = array(
			'sort_order' => 'ASC',
			'sort_column' => 'post_title',
			'post_type' => 'page',
			'post_status' => 'publish',
			'posts_per_page' => -1
		);

		$pages = get_pages($args);
		foreach($pages as $page){
		    if($excludeFrontpage !== false && $page->ID == $frontpage_id){
		        continue;
		    }
			$data[] = array('name' => (!empty($page->post_title) ? $page->post_title : 'Post #'. $page->ID), 'label' => (!empty($page->post_title) ? $page->post_title : 'Post #'. $page->ID), 'value' => $page->ID);
		}
		return $data;
	}

	function getPosts($excludeFrontpage = false){
	    $frontpage_id = get_option( 'page_on_front' );
		$data = array();
		$args = array(
			'orderby'          => 'post_title',
			'order'            => 'ASC',
			'post_type'        => 'post',
			'post_status'      => 'publish',
			'suppress_filters' => true,
			'posts_per_page' => 200
		);
		$posts = get_posts($args);
		foreach($posts as $post){
		    if($excludeFrontpage !== false && $post->ID == $frontpage_id){
		        continue;
		    }
			$data[] = array('name' => (!empty($post->post_title) ? $post->post_title : 'Post #'. $post->ID), 'label' => (!empty($post->post_title) ? $post->post_title : 'Post #'. $post->ID), 'value' => $post->ID, 'uniqid' => md5($post->post_title.$post->ID));
		}
		return $data;
	}

	function pluginActive($pluginName){
		if(!is_admin()){ include_once( ABSPATH . 'wp-admin/includes/plugin.php' ); }
		switch(strtolower($pluginName)){
			case 'woocommerce':
				if(is_plugin_active('woocommerce/woocommerce.php')) return true;
				break;
			case 'contact-form-7':
				if(is_plugin_active('contact-form-7/wp-contact-form-7.php')) return true;
				break;
		}
		return false;
	}

	function wooGetCategories(){
		$args = array(
			'orderby' 		=> 'name',
			'order' 		=> 'ASC',
			'taxonomy'		=> 'product_cat',
			'hide_empty'	=> 0
		);

		$categories = get_categories( $args );
		foreach($categories as $category){
			$catData	= array('term_id' => $category->term_id, 'name' => $category->slug, 'label' => trim($category->name, ' &#187; '), 'value' => $category->slug, 'uniqid' => md5($category->name));
			$parentcats	= get_ancestors($category->term_id, 'product_cat');
			if(count($parentcats)){
				foreach($parentcats as $parentcat){
					if( $term = get_term_by( 'id', $parentcat, 'product_cat' ) ){
						$catData['label'] = $term->name . ' &#187; ' . $catData['label'];
					}
				}
			}

			$data[] = $catData;
		}

		$this->sort_key = 'label';
		usort($data, array($this, 'sort_by_key'));
		return $data;
	}

	function getPostCategories(){
	    global $sitepress;
	    $data = array();
	    $args = array(
	        'orderby' 		=> 'name',
	        'order' 		=> 'ASC',
	        'type'			=> 'post',
	        'hide_empty'	=> 0
	    );
	    

	    if(is_object($sitepress)){ $current_lang = $sitepress->get_current_language(); }
	    
	    foreach($this->getLanguages() as $lang){
	        if(is_object($sitepress)){ $sitepress->switch_lang($lang['lang_key']); }
	        $data[$lang['lang_key']]   = array();
	        $categories                = get_categories( $args );

	        foreach($categories as $category){
	            $data[$lang['lang_key']][] = array('term_id' => $category->term_id, 'name' => $category->slug, 'label' => preg_replace('/ &#187; $/', '', get_category_parents( $category->term_id, false, ' &#187; ')) . (is_object($sitepress) ? ' ('.$lang['lang_key'].')' : ''), 'value' => $category->slug, 'uniqid' => md5($category->name), 'lang_key' => $lang['lang_key']);
	        }

	        $this->sort_key = 'label';
	        usort($data[$lang['lang_key']], array($this, 'sort_by_key'));
	        $data = array_merge($data, $data[$lang['lang_key']]);
	        unset($data[$lang['lang_key']]);
	        
			//Switch back to current language
	        if(is_object($sitepress)){ $sitepress->switch_lang($current_lang); }
	    }

	    return $data;
	}

	function getPostsForCpt($cpt, $excludeFrontpage = false){
	    $frontpage_id = get_option( 'page_on_front' );
		$data = array();
		$args = array(
			'orderby'          => 'post_title',
			'order'            => 'ASC',
			'post_type'        => $cpt,
			'post_status'      => 'publish',
			'suppress_filters' => true,
			'posts_per_page' => -1
		);

		$posts = get_posts($args);
		foreach($posts as $post){
		    if($excludeFrontpage !== false && $post->ID == $frontpage_id){
		        continue;
		    }

			$data[] = array('name' => $post->post_title, 'label' => $post->post_title, 'value' => $post->ID, 'uniqid' => md5($post->post_title.$post->ID));
		}
		return $data;
	}

	function getUserGroups($skip = ''){
		global $wp_roles;
		$skip = explode(',', $skip);
		$data = array();

		foreach($wp_roles->roles as $k => $v){
			if(in_array($v['name'], $skip)){ continue; }
			$data[] = array('name' => $v['name'], 'label' => $v['name'], 'value' => $k);
		}
		return $data;
	}

	function getPurchaseStatus($getType = ''){
		$data 		= array();
		$types 		= array('basic', 'professional', 'suite');
		$key		= $this->dpc->oLicense->getLicense();

		if(is_object($this->dpc->oLicense->details)){
			$expires = new DateTime($this->dpc->oLicense->details->expires);
		} else {
			$expires = '';
		}

		foreach($types as $type){
			switch($type){
				case 'basic':
				    $product = array('label' => 'Basic', 'name' => 'basic', 'status' => 'active', 'premium_status' => 'inactive');
				    if($getType == 'basic') { return $product; }
				    $data[] = $product;
					break;
				case 'professional':
				    $product = array('label' => 'Professional', 'name' => 'professional', 'status' => (isset($this->dpc->oLicense->products['professional']['status']) && $this->dpc->oLicense->products['professional']['status'] == 1 ? 'active' : 'inactive'), 'key' => $key, 'expires' => (is_object($expires) ? $expires->format('d.m.Y') : ''), 'premium_status' => 'active');
				    if($getType == 'professional') { return $product; }
				    $data[] = $product;
					break;
				case 'suite':
				    $product = array('label' => 'Suite', 'name' => 'suite', 'status' => (isset($this->dpc->oLicense->products['suite']['status']) && $this->dpc->oLicense->products['suite']['status'] == 1 ? 'active' : 'inactive'), 'key' => $key, 'expires' => (is_object($expires) ? $expires->format('d.m.Y') : ''), 'premium_status' => 'active');
				    if($getType == 'suite') { return $product; }
				    $data[] = $product;
					break;
			}
		}
		return $data;
	}

	function getActiveLicense(){
		$license = $this->dpc->oLicense->products;

		if((isset($license['suite']['status']) && $license['suite']['status'] == true) && (isset($license['professional']['status']) && $license['professional']['status'] == true)){
			$activeLicense = 'suite';
		}elseif((!isset($license['suite']['status']) || $license['suite']['status'] != true) && (isset($license['professional']['status']) && $license['professional']['status'] == true)){
			$activeLicense = 'professional';
		}else{
			$activeLicense = 'basic';
		}

		return $activeLicense;
	}

	function getActiveLicenseData(){
	    $licenseData = $this->getPurchaseStatus($this->getActiveLicense());
	    if(!isset($licenseData['key'])){
	        $licenseData['key'] = $this->dpc->oLicense->getLicense();
	    }

	    return $licenseData;
	}

	function isNewInstallation(){
	    return (int) $this->dpc->isNewInstallation();
	}

	function isWizardDone(){
	    return (int) get_option('dpc_wizard_done', false);
	}

	function object2array($obj) {
		if(is_object($obj)) $obj = (array) $obj;
		if(is_array($obj)) {
			$new = array();
			foreach($obj as $key => $val) {
				$new[$key] = $this->object2array($val);
			}
		} else {
			$new = $obj;
		}
		return $new;
	}

	function getPostData($postId, $key, $isMeta = false){
		if($isMeta){
			return get_post_meta($postId, $key, true);
		}

		if(is_array($post = get_post($postId, ARRAY_A))){
			if(isset($post[$key])){
				return $post[$key];
			} else {
				return '';
			}
		}
	}

	function checkPrivacy(){
		$setting = get_option('blog_public');
		$privacy = '';

		if($setting == 1){
			$privacy = 'index';
		}else if($setting == 0){
			$privacy = 'noindex';
		}
		return $privacy;
	}

	function checkGutenberg(){
		$status = '';

		 if(function_exists('register_block_type')){
            $status = 'active';
        }

		return $status;
	}

	function getWordpressVersion(){
		return bloginfo('version');
	}

	function sort_by_key($a, $b){
		$key = $this->sort_key;
		return strcmp($a[$key], $b[$key]);
	}

	function printRegisteredStyles($handles = array(), $loaded = array()) {
	    global $wp_styles;

	    foreach($handles as $handle){
	        if(in_array($handle, array_values($loaded))){
	            continue;
	        }

	        if(isset($wp_styles->registered[$handle])){
	            if(isset($wp_styles->registered[$handle]->deps) && count($wp_styles->registered[$handle]->deps)){
	                $loaded = array_unique(array_merge($this->printRegisteredStyles($wp_styles->registered[$handle]->deps, $loaded), $loaded));
	            }

	            $loaded[] = $handle;

	            if(isset($wp_styles->registered[$handle]->src) && strlen($wp_styles->registered[$handle]->src)){
	                echo '<link type="text/css" id="'.esc_attr($handle).'" media="all" rel="stylesheet" href="'.esc_url(str_replace(get_site_url(), '', $wp_styles->registered[$handle]->src)).'" />' . "\r\n";
	            }
	        }

	    }

	    return $loaded;
	}

	function debugActions($hook){
	    global $wp_filter;
	    echo '<pre>';
	    print_r( $wp_filter[$hook] );
	    echo '</pre>';
	}

	function removeActions($hook, $exceptions = array()){
	    global $wp_filter;

	    if(count($exceptions)){
	        foreach($wp_filter[$hook]->callbacks as $order => $callbacks){
	            foreach($callbacks as $callback => $data){
    	            if(!in_array($callback, $exceptions)){
    	                remove_action($hook, $callback, $order);
    	            }
	            }

	            if(isset($wp_filter[$hook]->callbacks[$order]) && is_array($wp_filter[$hook]->callbacks[$order]) && !count($wp_filter[$hook]->callbacks[$order])){
	                unset($wp_filter[$hook]->callbacks[$order]);
	            }
	        }
	    } else {
	        $wp_filter[$hook]->callbacks = array();
	    }
	}

	function callShortcode($shortcode, $atts = array()){
	    if(shortcode_exists($shortcode)){
	        $attString = '';
	        if(count($atts)){
	            foreach($atts as $k => $v){
	                $attString .= ' ' . $k . '="'. $v .'"';
	            }
	        }

	        return do_shortcode('[' . $shortcode . (strlen($attString) ? $attString : '') .']');
	    }
	    return false;
	}

	function aksort(&$array,$valrev=false,$keyrev=false) {
	    if($valrev){
	        arsort($array);
	    } else {
	        asort($array);
	    }
	}

}

?>