<?php

class DPC_Helper_Gui {

	var $dpc 				= null;
	var $module				= null;
	var $settings 			= null;
	var $defaults 			= null;
	var $field				= null;
	var $sectionAttributes 	= null;
	var $attributes 		= null;
	var $value 				= null;
	var $possibleValues		= null;
	var $childs				= null;
	var $isDraftLoop		= false;
	var $inLoop				= false;
	var $loopIndex			= 0;
	var $namespace			= array();
	var $namespaceLoopIndex	= array();
	var $vars				= array();
    var $text_allowed_html  = '';

	function __construct(&$dpc){
		$this->dpc = $dpc;
	}

	function getInput($attributes){
		$this->attributes 	= $attributes;
		$this->field 		= $this->replaceXmlAttributes($this->field);
		$input = '';

		if(isset($this->attributes['debug']) && $this->attributes['debug'] == 'true'){
			echo "<pre>";
			print_r($this->field);
			echo "</pre>";
		}

		if((bool)$this->getAttr('hide', false)){
			return $this->getHide(true);
		}

		switch($this->getAttr('type')){
			case 'wrap':
				return $this->getWrap();
				break;
			case 'wrapper':
				$this->getWrapper();
				break;
			case 'section':
				$this->getSection();
				break;
			case 'collection':
				$this->getCollection();
				break;
			case 'tabs':
				$this->getTabs();
				break;
			case 'selectall':
				return $this->getSelectAll();
				break;
			case 'wizard':
				return $this->getWizard();
				break;
			case 'dpcOption':
				$this->getDpcOption();
				break;
			case 'var':
				$this->setVar($this->field);
				break;
			case 'method':
				return $this->getMethod();
				break;
			case 'knob':
				return $this->getKnob();
				break;
			case 'donut':
				return $this->getDonut();
				break;
			case 'horizontalbar':
				return $this->getHorizontalBar();
				break;
			case 'each':
				$this->getEach();
				break;
			case 'heading':
				return $this->getHeading();
				break;
			case "modal":
				return $this->getModal();
				break;
			case 'image':
				return $this->getImage();
				break;
			case 'iframe':
				return $this->getIFrame();
				break;
			//Table
			case 'table':
				return $this->getTable();
				break;
			case 'th':
				return $this->getTh();
				break;
			case 'td':
				return $this->getTd();
				break;
			case 'tr':
				return $this->getTr();
				break;
			case 'trStart':
				return $this->getTrStart();
				break;
			case 'trEnd':
				return $this->getTrEnd();
				break;
			case 'thead':
				return $this->getThead();
				break;
			case 'tbody':
				return $this->getTbody();
				break;
			case 'tfoot':
				return $this->getTfoot();
				break;
			case 'tdStart':
				return $this->getTdStart();
				break;
			case 'tdEnd':
				return $this->getTdEnd();
				break;
			case 'trNext':
				return $this->getTrNext();
				break;
			// Table END
			case 'hidden':
				return $this->getHidden();
				break;
			case 'postAction':
				return $this->getPostAction();
				break;
			case 'button':
				return $this->getButton();
				break;
			case 'fab':
				return $this->getFabButton();
				break;
			case 'deleteButton':
				return $this->getDeleteButton();
				break;
			case 'toggleButton':
				return $this->getToggleButton();
				break;
			case 'hide':
				return $this->getHide();
				break;
			case 'text':
				return $this->getText();
				break;
			case 'number':
				return $this->getNumber();
				break;
			case 'spinner':
				return $this->getSpinner();
				break;
			case 'sortable':
				return $this->getSortable();
				break;
			case 'colorpicker':
				return $this->getColorpicker();
				break;
			case 'timepicker':
				return $this->getTimepicker();
				break;
			case 'datepicker':
				return $this->getDatepicker();
				break;
			case 'copycode':
				return $this->getCopyCode();
				break;
			case 'checkbox':
				return $this->getCheckbox();
				break;
			case 'radio':
				return $this->getRadio();
				break;
			case 'multiRadio':
				return $this->getMultiRadio();
				break;
			case 'radioSwitch':
				return $this->getRadioSwitch();
				break;
			case 'select':
				return $this->getSelect();
				break;
			case 'selectImg':
				return $this->getSelectImg();
				break;
			case 'selectToggle':
				return $this->getSelectToggle();
				break;
			case 'textarea':
				return $this->getTextarea();
				break;
			case 'nextRow':
			    return $this->getNextRow();
			    break;
			case 'html':
				return $this->getHtml();
				break;
			case 'debug':
				return $this->debug();
				break;
			case 'mediaUploader':
				return $this->getMediaUploader();
				break;
			case 'file':
				return $this->getFile();
				break;
			case 'status':
				return $this->getStatus();
				break;
			case 'taglist':
				return $this->getTaglist();
				break;
			case 'htmlelement':
				return $this->getHtmlElements();
				break;
			case 'hinweis':
				return $this->getHinweis();
				break;
			case 'alert':
				return $this->getAlert();
				break;
			case 'paragraph':
			    return $this->getParagraph();
			    break;
			case 'label':
			    return $this->getLabel();
			    break;
			case 'icon':
				return $this->getIcon();
				break;
			case 'link':
				return $this->getLink();
				break;
			case 'accordion':
			    return $this->getAccordion();
			    break;
			case 'info':
				return $this->getInfo();
				break;
			case 'if':
				return $this->getIf();
				break;
			case 'form':
				return $this->getForm();
				break;
		}
		return $input;
	}

	function resetProperties(){
		$this->module	 	= null;
		$this->settings 	= null;
		$this->value 		= null;
		$this->attributes 	= null;
	}

	function getValuesBySource($field){
		$field 	= $this->replaceXmlAttributes($field);
		$values = array();

		if(isset($field['source'])){
			$sourceArray = explode(':', $field['source']);
			switch($sourceArray[0]){
				case '@method':
					$isModule 		= (count($sourceArray) == 3) ? true : false;
					$isSubModule 	= (count($sourceArray) == 4) ? true : false;

					if($isSubModule){
						$values = $this->dpc->triggerModuleMethod($sourceArray[1].'_'.$sourceArray[2], $sourceArray[3], strlen($field['sourceParams']) ? explode('|', $field['sourceParams']) : null);
					} elseif($isModule){
						$values = $this->dpc->triggerModuleMethod($sourceArray[1], $sourceArray[2], strlen($field['sourceParams']) ? explode('|', $field['sourceParams']) : null);
					}
					break;
				case '@function':
					if($this->dpc->oFunctions == null){
						require_once('functions.php');
						$this->dpc->oFunctions = new DPC_Functions($this->dpc);
					}
					if(is_object($this->dpc->oFunctions)){
						if(method_exists($this->dpc->oFunctions, $sourceArray[1])){
						    $values = call_user_func_array(array($this->dpc->oFunctions, $sourceArray[1]), strlen($field['sourceParams']) ? (array)explode('|', $field['sourceParams']) : array());
							#$values = call_user_method($sourceArray[1], $this->dpc->oFunctions, strlen($field['sourceParams']) ? explode('|', $field['sourceParams']) : null);
						}
					}
					break;
				case '@list':
				    $params = array();
				    if(strlen($field['sourceParams'])){
				        $values = explode(',', $field['sourceParams']);
				    }
				    break;
			}
		}

		return $values;
	}

	function setVar($field){
		$field 	= $this->replaceXmlAttributes($field);

		if(isset($field['value'])){
			$sourceArray = explode(':', $field['value']);
			switch($sourceArray[0]){
				case '@method':
					$isModule 		= (count($sourceArray) == 3) ? true : false;
					$isSubModule 	= (count($sourceArray) == 4) ? true : false;

					if($isSubModule){
						$this->vars[(string)$field['key']] = $this->dpc->triggerModuleMethod($sourceArray[1].'_'.$sourceArray[2], $sourceArray[3], strlen($field['params']) ? explode('|', $field['params']) : null);
					} elseif($isModule){
						$this->vars[(string)$field['key']] = $this->dpc->triggerModuleMethod($sourceArray[1], $sourceArray[2], strlen($field['params']) ? explode('|', $field['params']) : null);
					}
					break;
				case '@function':
					if($this->dpc->oFunctions == null){
						require_once('functions.php');
						$this->dpc->oFunctions = new DPC_Functions($this->dpc);
					}
					if(is_object($this->dpc->oFunctions)){
						if(method_exists($this->dpc->oFunctions, $sourceArray[1])){
							$this->vars[(string)$field['key']] = call_user_func_array(array($this->dpc->oFunctions, $sourceArray[1]), strlen($field['params']) ? explode('|', $field['params']) : array());
						}
					}
					break;
			}
		}
	}

	function getValueRecursive($array, $parts = array()){
		if(count($parts)){
			$currentElement = array_shift($parts);
			if(isset($array[$currentElement])){
				if(is_array($array[$currentElement])){
					if(count($parts)){
						return $this->getValueRecursive($array[$currentElement], $parts);
					}
					return $array[$currentElement];
				} else {

					return $array[$currentElement];
				}
			}
		}
	}

	function prepareValueForInput($value = '', $type = 'text'){
	    switch($type){
	        case 'textarea':
	            return stripslashes(wp_kses($value, $this->text_allowed_html));
	    }

	    return stripslashes(wp_kses($value, array()));
	}

	function getValue($inputType = 'text'){
		if($this->getAttr('forceValue', false)){
		    return $this->prepareValueForInput($this->value);
		}

		$realname = (string) $this->getAttr('realname');
		if(strlen($realname)){
		    return $this->prepareValueForInput(get_option($realname), $inputType);
		}

		if($this->getAttr('postMeta', false)){
			global $post;
			$attributeName = (string)$this->attributes['name'];
			if(strpos($attributeName, '[') !== false){
				$attributeName = substr($attributeName, 0, strpos($attributeName, '['));
				$attributeParts = trim(str_replace($attributeName, '', (string)$this->attributes['name']), '[]');
				$attributeParts = explode('][', $attributeParts);
				$valueArray = get_post_meta($post->ID,'_'.$attributeName,true);
				$this->value = $this->prepareValueForInput($this->getValueRecursive($valueArray, $attributeParts), $inputType);
				return $this->value;
			} else {
			    return $this->prepareValueForInput(get_post_meta($post->ID, (string)'_'.$this->getName(), true),$inputType);
			}
		}

		$attributeName = (string)$this->attributes['name'];
		if(strpos($attributeName, '][') !== false){
		    $this->value = $this->prepareValueForInput($this->getValueRecursive($this->settings, explode('][', $attributeName)), $inputType);
		}

		if($this->inLoop != true){
			if(isset($this->settings[$attributeName])){
				return $this->settings[$attributeName];
			} elseif($this->getAttr('type') == "checkbox" && !count($this->settings)){
				return '';
			} else {
				return (!is_array($this->value) ? (string)$this->value : $this->value);
			}
		} elseif($this->isDraftLoop == false){
			if(isset($this->settings[(string)$this->sectionAttributes['name']][$this->loopIndex][$attributeName])){
				return $this->settings[(string)$this->sectionAttributes['name']][$this->loopIndex][$attributeName];
			} elseif($this->getAttr('type') == "checkbox" && isset($this->settings[(string)$this->sectionAttributes['name']])){
				return '';
			} else {
				return (!is_array($this->value) ? (string)$this->value : $this->value);
			}
		} else {
			return (!is_array($this->value) ? (string)$this->value : $this->value);
		}
	}

	function getAttr($key, $default = null){
		if(isset($this->attributes[$key])){
			return $this->attributes[$key];
		}
		if($default !== null){
			return $default;
		}
	}

	function getHtmlAttr($skip = array(), $attributes = array()){
		$htmlAttr = '';
		$attr     = count($attributes) ? $attributes: $this->attributes;

		if(isset($attr['addToDom'])){
			foreach(explode(',', $attr['addToDom']) as $useAttr){
				if(isset($attr[$useAttr]) && !in_array($useAttr, $skip)){
				    $htmlAttr .= ' ' . $useAttr . '="' . esc_attr($attr[$useAttr]) .  '"';
				}
			}
		}
		return '' . $htmlAttr;
	}

	function getName($name = false, $realname = false){
		if($this->getAttr('forceName', false) || $this->getAttr('postMeta', false)){
			return $this->getAttr('name');
		}

		$name 		= ($name ? $name : $this->getAttr('name'));
		$realname 	= ($realname ? $realname : $this->getAttr('realname'));
		if($realname){
			return 'dpc[realnames][' . $realname . ']';
		}

		if($this->inLoop == true){
			return 'dpc[' . $this->module . '][' . $this->sectionAttributes['name'] . '][' . $this->loopIndex . '][' . $name . ']';
		} else {
			return 'dpc[' . $this->module . '][' . $name . ']';
		}
	}

	function getWrap(){
		$html = '';
		$this->initChilds();
		$html .= '<div'.($this->getAttr('id', false) ? ' id="'.esc_attr($this->getAttr('id')).'"' : '' ).' class="'.($this->getAttr('hasWrap', 'yes') == 'yes' ? 'haswrap' : '').' '.(strlen($this->getAttr('width')) ? 'col-md-'.esc_attr($this->getAttr('width')) : '').($this->getAttr('class', false) ? ' '.esc_attr($this->getAttr('class')) : '').'" '.esc_attr($this->getAttr('data-toggle')).' '.$this->getHtmlAttr().'>';
		if($this->childs !== null){
			$html .= $this->showFields($this->childs, true);
		}

		$html .= '</div>';
		return $html;
	}

	function getWrapper(){
		$this->initChilds();

		/* look for nested wrappers to set the row class for flex grid: start */
		$class = '';
		if($this->childs !== null && $this->getAttr('row', 'yes') == 'yes'){
		    foreach($this->childs as $child){
		        $attr = $child->attributes();
		        if((string)$attr['type'] == 'wrapper'){
		            $class = 'row ';
		        }
		    }
		}
		/* look for nested wrappers to set the row class for flex grid: end */

		echo '<div'.($this->getAttr('id', false) ? ' id="'.esc_attr($this->getAttr('id')).'"' : '' ).' class="'.esc_attr($class).($this->getAttr('hasWrap', 'yes') == 'yes' ? 'haswrap' : '').' '.(strlen($this->getAttr('width')) ? 'col-md-'.esc_attr($this->getAttr('width')) : '').($this->getAttr('class', false) ? ' '.esc_attr($this->getAttr('class')) : '').'" '.esc_attr($this->getAttr('data-toggle')).' '.$this->getHtmlAttr().'>';
		if($this->childs !== null){
			$this->showFields($this->childs);
		}
		echo '</div>';
	}

	function getDpcOption(){
		$this->initChilds();
		echo '<div '.($this->getAttr('id', false) ? ' id="'.esc_attr($this->getAttr('id')).'"' : '' ).' class="jumbotron dpc-option '.esc_attr($this->getAttr('class')).' '.esc_attr($this->getAttr('name')).' " '.$this->getHtmlAttr().'>';
		if($this->childs !== null){
			$this->showFields($this->childs);
		}
		echo '</div>';
	}

	function getMethod(){
		if(!$this->getAttr('module') || !$this->getAttr('function')){
			return false;
		}

		if(!is_null($params = $this->getAttr('params', null))){
			$params = explode(',', $params);
		}

		return $this->dpc->triggerModuleMethod((string)$this->getAttr('module'), (string)$this->getAttr('function'), $params);
	}

	function getDonut(){
		echo 	'<div class="chart-donut">
					<div id="donut"></div>
				</div>
				';
		echo '<script>
		jQuery(document).ready(function($) {
			Morris.Donut({
			  element: "donut",
			  data: [
			    {label: "'.esc_attr(__('Warnings', 'delucks-seo')).'", value: '.esc_attr($this->dpc->log->count('warning')).'},
			    {label: "'.esc_attr(__('Optimal', 'delucks-seo')).'", value: '.esc_attr($this->dpc->log->getOptimus(true)).'},
			    {label: "'.esc_attr(__('Errors', 'delucks-seo')).'", value: '.esc_attr($this->dpc->log->count('error')).'}
			  ],
			  resize: true,
			  colors: [
				"#EAB631",
				"#60B660",
				"#E44D42"
			   ],
			   backgroundColor: "#2F3033",
			   labelColor: "'.($this->dpc->oLicense->products['suite']['status'] == true ? '#efefef' : '#2F3033').'",
			   width: "140px"
			});
		});
	</script>';
	}

	function getIf(){
		$this->initChilds();
		if($this->childs !== null){
			$success	= false;
			$condition	= (string)trim($this->getAttr('condition'));
			$operator	= (string)trim($this->getAttr('operator'));
			$value		= (string)trim($this->getAttr('value'));
			if(strlen($operator)){
				switch($operator){
					case '==':
						if($condition == $value){
							$success = true;
						}
						break;
					case '!=':
						if($condition != $value){
							$success = true;
						}
						break;
				}
			}

			if($success == true){
				$this->showFields($this->childs);
			}
		}
	}

	function getForm(){
	    echo '<form name="'. esc_attr($this->getAttr('name')) .'" method="'. esc_attr($this->getAttr('method')) .'"' . ($this->getAttr('action', false) ? ' action="'.esc_attr($this->getAttr('action')).'"' : '') . ' '.$this->getHtmlAttr().'/>';
		$this->initChilds();
		if($this->childs !== null){
			$this->showFields($this->childs);
		}
		echo '</form>';
	}
	
	/**
	 *
	 * Bar colors:
	 * danger, warning, success
	 */
	function getHorizontalBar(){
	    
	    if($this->getAttr('mode') == 'min_max'){
	        $max 	= (int)$this->getAttr('max');
	        $value	= (int)$this->getValue();
	        
	        $percentage 		= ($value > 0 ? ($value/$max)*100 : $value);
	        $display_value 	= ($this->getAttr('displayValue') ? $this->getAttr('displayValue') : $value . ' / ' . $max);
	    }else{
	        $percentage 		= $this->getValue();
	        $display_value 	= $this->getAttr('displayValue');
	    }
	    
	    $output  = '<div class="dpc-bar-wrapper '. esc_attr($this->getAttr('class')) .'">';
	    $output .= '		<div class="dpc-bar-label">';
	    $output .= '			<span class="dpc-bar-label-text">'. esc_attr($this->getAttr('text')) .'</span>';
	    $output .= '			<span class="dpc-bar-label-value">'. $display_value . '</span>';
	    $output .= '		</div>';
	    $output .= '		<div class="dpc-bar"><span class="dpc-bar-background success" style="width: '. $percentage .'%"></span></div>';
	    $output .= '	</div>';
	    
	    return $output;
	}
	
	
	function getCollection(){
	    $this->initChilds();
	    echo '<div class="collection'.($this->getAttr('class', false) ? ' '.esc_attr($this->getAttr('class')) : '').'" '.$this->getHtmlAttr().'>';
	    
	    $newChilds = array();
	    if($this->childs !== null){
	        $ci = 0;
	        
	        $value = $this->getValueRecursive($this->settings, explode('][', esc_attr($this->getAttr('name'))));
	        $value = $value ? $value : false;
	        
	        if($value){
	            foreach($this->childs as $child){
	                $vi = 0;
	                foreach($value as $vk => $vv){
	                    if(strpos($child['name'], $vk) !== false){
	                        $newChilds[$vi] = $child;
	                        $vi++;
	                        break;
	                    }
	                    $vi++;
	                }
	                $ci++;
	            }
	            
	            ksort($newChilds);
	            $this->showFields($newChilds);
	        } else {
	            $this->showFields($this->childs);
	        }
	    }
	    echo '</div>';
	}

	function getSection($section = '', $file = false){
		$section = (strlen($section) ? $section : (string)$this->getAttr('section'));

		if(!$file){
			if($this->getAttr('file', false)){
				$file = DPC_PLUGIN_MODULES_DIR . (string)$this->getAttr('file');
			}
		}

		if(!strlen($section)){
			return '';
		}
		$this->dpc->parseSettingsByXml(($file ? $file : $this->dpc->lastSettingsFile), $section, $this->getAttr('inEach', false), ($this->getAttr('skipWrapper', false) ? true : false));
	}

	function getTabs(){
	    $navigation    = $this->getAttr('navigation', false);
	    $index         = $this->getAttr('index', 0);
	    $textBack      = $this->getAttr('textback', esc_html__('Back', 'delucks-seo'));
	    $textNext      = $this->getAttr('textnext', esc_html__('Next', 'delucks-seo'));
	    $textLast      = $this->getAttr('textlast', false);
	    $lastClass     = $this->getAttr('lastclass', 'submit');
	    $uniqueId      = md5('tabs'.wp_rand());

		$this->initChilds();

		if($this->childs !== null){

		    echo '<div class="col-md-12">';
		    echo '<div class="dpc-tabs-wrapper'.($this->getAttr('class', false) ? ' '.esc_attr($this->getAttr('class')) : '').'" data-unique="'.esc_attr($uniqueId).'">';

		    echo '<ul class="'. esc_attr($this->getAttr('menu-class', 'nav nav-tabs')) .' dpc-tabs" role="tablist" id="tab_'.esc_attr($this->module).'">';
			$i = 0;
			foreach($this->childs as $tab){
			    echo '<li class="nav-item">';
			    echo '	<a class="nav-link small text-uppercase '.($i == 0 ? ' active' : '').'" href="#tab-'. esc_attr($this->module) .'_'.esc_attr(str_replace(array(' '), array('_'), $tab['title'])).'" data-toggle="tab">'.esc_html($tab['title']).'</a>';
				echo '</li>';
			$i++;
			}
			echo '</ul>';

			echo '<div id="tabsJustifiedContent" class="tab-content">';
			$i = 0;

			foreach($this->childs as $tab){
				echo '<div class="tab-pane '.($i == 0 ? 'active' : '').'" id="tab-'. esc_attr($this->module) .'_'.esc_attr(str_replace(array(' '), array('_'), $tab['title'])).'">';
				if($tab['section']){
				    $this->getSection($tab['section']);
				} else {
				    $this->showFields($tab->children());
				}

				echo '</div>';
				$i++;
			}
			echo '</div>';

			if($navigation){
			    echo '<div class="tab-navigation">';
			    echo '  <a target="" href="#" class="btn btn-danger tabs-back" onclick="javascript: return false;" style="display: none">'.esc_html($textBack).'</a>';
			    echo '  <a target="" href="#" class="btn btn-success tabs-next" onclick="javascript: return false;" data-lastclass="'.esc_attr($lastClass).'" data-textnext="'.esc_attr($textNext).'" '.($textLast ? ' data-textlast="'.esc_attr($textLast).'"' : '').'>'.esc_html($textNext).'</a>';
                echo '  <br style="clear:both" />';
			    echo '</div>';
			}

			echo '</div>';
			echo '</div>';
		}
	}

	function getSelectAll(){
	    $output  = '<button id="'.esc_attr($this->getAttr('id')).'" class="btn '.esc_attr($this->getAttr('btn-type')).' btn-select-all" data-selector="'.esc_attr($this->getAttr('selector')).'" '.$this->getHtmlAttr('class,id').' data-unclicked="'.esc_attr($this->getAttr('unclicked')).'" data-clicked="'.esc_attr($this->getAttr('clicked')).'">'.esc_attr($this->getAttr('unclicked')).'</button>';
		$output .= '<script type="text/javascript">
					jQuery(document).ready(function($) {
						var checkAll 	= $("#'.esc_js($this->getAttr('id')).'.btn-select-all"),
							checkboxes 	= checkAll.parents().closest("#'.esc_js($this->getAttr('selector')).'").find(".icheck-checkbox");

						checkAll.on("click", function(ev){
							ev.preventDefault();

					        if ($(this).hasClass("clicked")) {
					            checkboxes.iCheck("uncheck");
								$(this).html($(this).data("unclicked")).removeClass("clicked");
					        }else{
					            checkboxes.iCheck("check");
								$(this).html($(this).data("clicked")).addClass("clicked");
					        }
						});

						checkboxes.on("ifChanged", function(event){
					        if(checkboxes.filter(":checked").length == checkboxes.length) {
					           	checkAll.html(checkAll.data("clicked")).addClass("clicked");
					        } else {
					            checkAll.html(checkAll.data("unclicked")).removeClass("clicked");
					        }
					    });
					});
					</script>';

		return $output;
	}

	function getWizard(){
		$this->initChilds();
		if($this->childs !== null){

			echo '<div class="form-horizontal form-wizard" id="rootwizard">';
				echo '<div class="steps-progress"> <div class="progress-indicator"></div> </div>';

				echo '<ul>';
				$i = 0;
				foreach($this->childs as $step){
					echo '<li '.($i == 0 ? 'class="completed active"' : '').'>';
					echo '	<a href="#tab-'. esc_attr($this->module) .'_'.esc_attr(str_replace(array(' '), array('_'), $step['title'])).'" role="tab" data-toggle="tab"><span>'.esc_html(($i + 1)).'</span>'.esc_html($step['title']).'</a>';
					echo '</li>';
				$i++;
				}
				echo '</ul>';

				echo '<div class="tab-content">';
				$i = 0;
				foreach($this->childs as $step){
				    echo '<div class="tab-pane '.($i == 0 ? 'active' : '').'" id="tab-'. esc_attr($this->module) .'_'.esc_attr(str_replace(array(' '), array('_'), $step['title'])).'">';
					if(isset($step['section'])){
						$this->getSection($step['section']);
					} else {
						$this->showFields($step->children());
					}
					echo '</div>';
					$i++;
				}
				echo '<div class="dl-wizard-footer">';
					echo '<div class="alert alert-warning migrate-error" role="alert" style="display:none;width:100%;"></div><div class="clear"></div>';
					echo '<div class="pull-left"> <div class="btn btn-default dl-previous disabled"><i class="fa fa-chevron-left"></i> '.esc_html__('Back', 'delucks-seo').'</div> </div>';
					echo '<div class="pull-right"> <div class="btn btn-primary dl-next">'.esc_html__('Next', 'delucks-seo').' <i class="fa fa-chevron-right"></i></div> </div>';
					echo '<div class="pull-right"> <div class="btn btn-success dl-finish disabled" style="display:none;"><i class="fa fa-check"></i> '.esc_html__('Finish', 'delucks-seo').'</div> </div>';
					echo '<div class="alert alert-warning wizard-warning double-opt" role="alert" style="display:none;"><div class="row"> </div></div>';
				echo '</div>';
				echo '</div>';
			echo '</div>';
		}
	}

	function replaceXmlAttributes($xmlObject, $data = array(), $type = false){
		if($type){
			if(method_exists($xmlObject->{$type}, 'count')){
				for($i=0; $i<$xmlObject->{$type}->count(); $i++){
					foreach($xmlObject->{$type}[$i]->attributes() as $ak => $av){
						if(preg_match_all('/\{(@LANG|@TEXT):(.*)\}/Ui', $av, $matches)){
							$xmlObject[$ak] = (string)str_replace($matches[0][0], $this->dpc->getText($matches[2][0]), $av);
						} elseif(preg_match_all('/\{@VAR:(.*)\}/Ui', $av, $matches)){
							$parts 		= explode('|', $matches[1][0]);
							if(count($parts) && isset($this->vars[$parts[0]])){
							    // is multi-array
							    if((count($multiArrayKeys = explode('|', $matches[1][0])) > 1) && is_array($this->vars[$parts[0]])){
							        $finalValue = $this->vars[$parts[0]];
							        unset($multiArrayKeys[0]);

							        foreach($multiArrayKeys as $multiArrayKey){
							            if(is_array($finalValue) && isset($finalValue[$multiArrayKey])){
							                $finalValue = $finalValue[$multiArrayKey];
							            }
							        }

							        $xmlObject[$ak] = (string)str_replace($matches[0][0], $finalValue, $av);
							    } else {
							        $xmlObject[$ak] = (string)str_replace($matches[0][0], $this->vars[$parts[0]], $av);
							    }
							}
						} elseif (preg_match_all('/\{@NS:(.*)\}/Ui', $av, $matches)){
							$parts 		= explode('|', $matches[1][0]);
							$namespace 	= array_shift($parts);
							$key	 	= array_shift($parts);
							if(isset($this->namespace[$namespace]) && isset($this->namespace[$namespace][$this->namespaceLoopIndex[$namespace]])){
								$xmlObject[$ak] = (string)str_replace($matches[0][0], $this->namespace[$namespace][$this->namespaceLoopIndex[$namespace]][$key], $av);
							}
						} elseif (preg_match_all('/\{(.*)\}/U', $av, $matches)){
							foreach($matches[1] as $mk => $mv){
								if(key_exists($mv, $data)){
									$string		=	(string)$xmlObject->{$type}[$i]->attributes()->$ak;
									$search		=	(string)$matches[0][$mk];
									$replace	=	(string)$data[$mv];
									$newString	=	(string)str_replace($search, $replace, $string);
									$xmlObject->{$type}[$i][$ak] = $newString;
								}
							}
						}
					}
				}
			}
		} else {
			foreach($xmlObject->attributes() as $ak => $av){
				if(preg_match_all('/\{(@LANG|@TEXT):(.*)\}/Ui', $av, $matches)){
					$xmlObject[$ak] = (string)str_replace($matches[0][0], $this->dpc->getText($matches[2][0]), $av);
				} elseif(preg_match_all('/\{@VAR:(.*)\}/Ui', $av, $matches)){
					$parts 		= explode('|', $matches[1][0]);
					if(count($parts) && isset($this->vars[$parts[0]])){
					    // is multi-array
					    if((count($multiArrayKeys = explode('|', $matches[1][0])) > 1) && is_array($this->vars[$parts[0]])){
					        $finalValue = $this->vars[$parts[0]];
					        unset($multiArrayKeys[0]);

					        foreach($multiArrayKeys as $multiArrayKey){
					            if(is_array($finalValue) && isset($finalValue[$multiArrayKey])){
					                $finalValue = $finalValue[$multiArrayKey];
					            }
					        }

					        $xmlObject[$ak] = (string)str_replace($matches[0][0], $finalValue, $av);
					    } else {
					        $xmlObject[$ak] = (string)str_replace($matches[0][0], $this->vars[$parts[0]], $av);
					    }
					}
				} elseif (preg_match_all('/\{@NS:(.*)\}/Ui', $av, $matches)){
					$parts 		= explode('|', $matches[1][0]);
					$namespace 	= array_shift($parts);
					$key	 	= array_shift($parts);
					if(isset($this->namespace[$namespace]) && isset($this->namespaceLoopIndex[$namespace]) && isset($this->namespace[$namespace][$this->namespaceLoopIndex[$namespace]])){
						$xmlObject[$ak] = (string)str_replace($matches[0][0], (isset($this->namespace[$namespace][$this->namespaceLoopIndex[$namespace]][$key]) ? $this->namespace[$namespace][$this->namespaceLoopIndex[$namespace]][$key] : ''), $av);
					}
				} elseif(preg_match_all('/\{(.*)\}/U', $av, $matches)){
					foreach($matches[1] as $mk => $mv){
						if(key_exists($mv, $data)){
							$string		=	(string)$xmlObject->attributes()->$ak;
							$search		=	(string)$matches[0][$mk];
							$replace	=	(string)$data[$mv];
							$newString	=	(string)str_replace($search, $replace, $string);
							$xmlObject[$ak] = $newString;
						}
					}
				}
			}
		}
		return $xmlObject;
	}

	function getEach(){
		$this->initChilds();
		$loopFields = $this->childs;
		$source 	= $this->getValuesBySource($this->field);

		$namespace	= false;
		if($this->getAttr('namespace', false) !== false){
			$namespace = (string)$this->getAttr('namespace');
			$this->namespace[$namespace] = $source;
		}
		if($loopFields !== null && count($source)){
			if(is_array($source)){
				foreach($source as $sk => $sv){
					if($namespace !== false){
						$this->namespaceLoopIndex[$namespace] = $sk;
					}
					$childFields = new SimpleXMLElement($loopFields->asXML());
					$childFields = $this->replaceXmlAttributes($childFields, $sv, 'option');
					$this->showFields($childFields);
				}
			}
		}
	}

	function getStatus(){
		/**
		 * Multiselect
		 */

		wp_enqueue_script('bootstrap-multiselect', plugins_url( 'assets/bootstrap-multiselect/js/bootstrap-multiselect.js', DPC_FILE), array('jquery'), null, true);
		wp_enqueue_style('bootstrap-multiselect', plugins_url( 'assets/bootstrap-multiselect/css/bootstrap-multiselect.css', DPC_FILE));

		if($this->dpc->oFunctions->getUserLang() == 'de'){
			$helpLink = isset($this->attributes['helplink-de']) ? $this->attributes['helplink-de'] : (isset($this->attributes['helplink-en']) ? $this->attributes['helplink-en'] : '');
		} else {
			$helpLink = isset($this->attributes['helplink-en']) ? $this->attributes['helplink-en'] : '';
		}

		$input = '<a name="'.esc_attr(str_replace(array('basic_', 'professional_'), '', $this->module)).'"></a>';
		$input .= '<span id="anchor-dpc-'.esc_attr(str_replace('_', '-', $this->module)).'" class=""></span>';


		$input .= '<div class="no-gutters row status '.($this->attributes['allowdisable'] == "false" ? 'dpc-visible' : '').' '.($this->dpc->moduleIsActive($this->module) ? 'module-active' : 'module-inactive').'" data-status="'.(($this->dpc->moduleIsActive($this->module) && get_user_meta(get_current_user_id(), 'dpc_toggle_state_'.$this->module, true)) || $this->attributes['allowdisable'] == "false" ? 'active' : 'inactive').'">';
			$input .= '<div class="col-8">';
			$input .= '<h2 class="module-title toggle-section '.(($this->dpc->moduleIsActive($this->module) && get_user_meta(get_current_user_id(), 'dpc_toggle_state_'.$this->module, true)) ? 'toggle-hide' : 'toggle-show').'" data-module="'.$this->module.'">' .esc_html($this->getAttr('title')). '</h2>';
				if(isset($this->attributes['description-intro'])){
					$input .= '<div class="status description">';
					$input .= '    <span class="description-intro">' .esc_html($this->attributes['description-intro']). ' </span>';
					$input .= '</div>';
				}
			$input .= '</div><div class="col-4 text-right">';
			$input .= '  <a href="'.esc_url($helpLink).'" target="_blank"><span class="btn btn-link help"><i class="fa fa-question-circle"></i></span></a>';



				if($this->attributes['allowdisable'] != "false"){
				    $input  .= '<select id="'.esc_attr($this->getName()).'" name="'.esc_attr($this->getName()).'">';

					if(is_array($this->possibleValues)){
						foreach($this->possibleValues as $val){
							$selected = false;
							if($this->getAttr('multiple') == 'multiple'){
								$selected = (in_array($val['value'], $this->getValue()) ? true : false);
							} else {
								$selected = ($val['value'] == $this->getValue() ? true : false);
							}
							$input .= '<option value="'.esc_attr($val['value']).'"'.($selected ? ' selected="selected"' : '').'>'.esc_html($val['label']).'</option>';
						}
					}
					$input .= '</select>';
				}else{
				    $input  .= '<select id="'.esc_attr($this->getName()).'" name="'.esc_attr($this->getName()).'" style="display: none;">';
					$input  .= '<option selected="selected" value="1">'.esc_html__('Activated', 'delucks-seo').'</option>';
					$input  .= '</select>';
				}

				if((is_object($this->defaults) || is_array($this->defaults)) && count($this->defaults)){
				    $input .=  '<button class="btn btn-info install-defaults" name="dpc[install_defaults]['.$this->module.']" value="'.$this->dpc->lastSettingsFile.'" data-module="'.$this->module.'" data-module_status="'.($this->dpc->moduleIsActive($this->module) ? '1' : '0').'">Reset</button>';
				}

				$input .= '<button name="toggle-'.esc_attr($this->getName()).'" type="button" class="btn btn-default btn-sm fa toggle-section '.(($this->dpc->moduleIsActive($this->module) && get_user_meta(get_current_user_id(), 'dpc_toggle_state_'.$this->module, true)) || $this->attributes['allowdisable'] == "false" ? 'toggle-hide' : 'toggle-show').'" data-module="'.$this->module.'"></button>';
			$input .= '</div>';
		$input .= '</div>';
		$input .= 	'<script type="text/javascript">
					jQuery(document).ready(function($) {
						$(\'[name^="popover-'.esc_js($this->getName()).'"]\').popover();';
		if($this->attributes['allowdisable'] != "false"){
		    $input .=	'	$(\'select[name^="'.esc_js($this->getName()).'"]\').multiselect(
		    						{
		    							buttonClass: \'btn btn-sm btn-blue\',
									onChange: function(option, checked) {
										//console.log($(\'select[name^="'.esc_js($this->getName()).'"]\').parents().closest(".row.status"));
										//if(option.val() == "1"){
											$(\'select[name^="'.esc_js($this->getName()).'"]\').parents().closest(".row.status").toggleClass("module-active");
											$(\'select[name^="'.esc_js($this->getName()).'"]\').parents().closest(".row.status").toggleClass("module-inactive");
																					//}
						            }
								}
							);';
		}
		$input .=	'	$(\'[name^="more-'.esc_js($this->getName()).'"]\').click(function(){
							$(\'[name^="description-'.esc_js($this->getName()).'"]\').toggleClass("active");
							$(this).toggleClass("active");
							if($(this).hasClass("active")){
								$(this).text($(this).data("text-active"));
							} else {
								$(this).text($(this).data("text-inactive"));
							}
						});
					});
					</script>';

		return $input;
	}


	function sectionStart($class = '', $skipRowClass = false){
		if($this->sectionAttributes['hasWrap'] != 'yes'){
		    return '<div class="no-gutters '.($this->sectionAttributes['several'] == 'yes' ? '' : 'row').'"><div class="no-gutters row '.($this->sectionAttributes['several'] == 'yes' ? '' : 'col').' dpc-section '.$this->module . ' ' . esc_attr($this->sectionAttributes['name']).' ' . esc_attr($class) .' '. esc_attr($this->sectionAttributes['class']).'" data-toggle="'. esc_attr($this->sectionAttributes['data-toggle']).'" '.$this->getHtmlAttr().' '.($this->sectionAttributes['hide'] == 'true' ? ' style="display:none"' : '').'>';
		}else{
		    return '<div class="no-gutters '.($skipRowClass ? '' : 'row ').'dpc-section '.esc_attr($this->module) . ' ' . esc_attr($this->sectionAttributes['name']).' ' . esc_attr($class) .' '. esc_attr($this->sectionAttributes['class']).'" data-toggle="'. esc_attr($this->sectionAttributes['data-toggle']).'" '.$this->getHtmlAttr().'>';
		}
	}

	function sectionClose(){
		if($this->sectionAttributes['hasWrap'] != 'yes'){
			return '</div></div>';
		}else{
			return '</div>';
		}
	}



	function formButtons(){
		$helpUrl = '';
		$moduleInstance = $this->dpc->getModuleInstance(str_replace('dpc-', '', $_GET['page']));
		if(is_object($moduleInstance) && property_exists($moduleInstance, 'helpUrl')){
			$helpUrl = $moduleInstance->helpUrl;
		}

		return '<div class="topButtons">
				<span class="dpc_faq_wrapper">
					<input type="text" id="dpc_faq_search_input" name="faq_search_input" placeholder="'.esc_attr(__('Help search', 'delucks-seo')).'" />
					<a class="fa fa-search btn btn-primary" id="dpc_faq_search_link" href="https://delucks.com/" target="_blank" data-search_url="https://delucks.com/?s=[keyword]"> </a>
					'.(strlen($helpUrl) ? '<a href="'.esc_url($helpUrl).'" class="dpc-help-url"><i class="fa fa-youtube-play"></i></a>' : '').'
				</span>
				<input type="button" class="dpc-submit btn btn-save" value="'.esc_attr(__('Save', 'delucks-seo')).'" /></div>';
	}

	function formStart($name='', $upload = false){
	    return '<form id="dpc_settings_form" method="post"'.(strlen($name) ? ' name="'.esc_attr($name).'"' : '').($upload ? ' enctype="multipart/form-data"' : '').'><input type="hidden" name="dpc_save_settings" />'.wp_nonce_field('dpc_save_settings', 'dpc_save_settings_nonce', true, false);
	}

	function formClose($submit = false){
	    return $submit ? '<input type="button" class="dpc-submit dpc-submit-settings-footer btn btn-save" value="'.esc_attr(__('Save', 'delucks-seo')).'" />' : '' . '</form>';
	}

	function topMenu(){
	    $output = '';
	    $output .= '<nav class="navbar fixed-top navbar-expand-sm navbar-light bg-light">';
	    $output .= '   <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">';
	    $output .= '       <span class="navbar-toggler-icon"></span>';
	    $output .= '   </button>';

	    $output .= '   <div class="collapse navbar-collapse" id="navbarSupportedContent">';
	    $output .= '     <ul class="navbar-nav mr-auto">';
	    $output .= '         <li class="nav-item dropdown">';
	    $output .= '             <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">';

	    foreach($this->dpc->moduleInstances as $module){
	        if($module->isSubmodule !== true){
	            if($_GET['page'] == $module->optionsHook){
	                $output .= $module->moduleTitle;
	            }
	        }
	    }

	    $output .= '             </a>';
	    $output .= '             <div class="dropdown-menu" aria-labelledby="navbarDropdown">';

	    foreach($this->dpc->moduleInstances as $module){
	        if($module->isSubmodule !== true){
	            $output .= '<a class="dropdown-item '.($_GET['page'] == $module->optionsHook ? ' active' : 'hidden').'" href="?page='.$module->optionsHook.'">'.esc_html($this->dpc->getText($module->moduleTitle)).' <span class="caret"></span></a>';
	        }
	    }

	    $output .= '             </div>';
	    $output .= '         </li>';

	    foreach($this->dpc->moduleInstances as $module){
	        if($module->isSubmodule == true && (isset($module->hideInSubmenu) && $module->hideInSubmenu) != true && strpos($module->optionsHook, $_GET['page']) === 0){
	            $output .= '<li class="nav-item"><a href="#anchor-'.$module->optionsHook.'" class="menu-anchor nav-link" data-scroll="anchor-'.$module->optionsHook.'">'.esc_html($this->dpc->getText($module->moduleTitle)).'</a></li>';
	        }
	    }

	    $output .= '     </ul>';
	    $output .= '</div>';
	   # $output .= '     <input class="form-control mr-sm-2" type="search" placeholder="Search" aria-label="Search">';
	    $output .= '	  <ul class="nav navbar-nav navbar-right dpc-top-menu">';
	    $output .= '	      <li>'.$this->formButtons().'</li>';
	    $output .= '	  </ul>';
	    $output .= '</nav>';

	    if(!empty($this->dpc->messages)){
	        $output .= '<div class="dpc-messages">';
	        foreach($this->dpc->messages as $msg){
	            $messageClass = ($msg['type'] == 'error' ? 'danger' : ($msg['type'] == 'warning' ? 'warning' : 'success'));
	            $output .= '<div class="alert alert-'.$messageClass.'" role="alert">'.$msg['text'] .'</div>';
	        }
	        $output .= '</div>';
	    }

	    return $output;

	    $output = '<div id="nav" role="navigation" class="navbar navbar-default navbar-fixed-top">';
	    #$output .= '	<div class="container">';
	    $output .= '		<div class="navbar-header">
		          		<button data-target=".navbar-collapse" data-toggle="collapse" class="navbar-toggle" type="button">
			            	<span class="sr-only">Toggle navigation</span>
				            <span class="icon-bar"></span>
				            <span class="icon-bar"></span>
				            <span class="icon-bar"></span>
		          		</button>
			          	<button type="submit" class="dpc-submit btn btn-save nav-submit-xs"><i class="fa fa-floppy-o"></i>  '.esc_html__('Save all', 'delucks-seo').'</button>
		       		 </div>';
	    $output .= '		<div class="navbar-collapse collapse">';
	    $output .= '			<ul class="nav navbar-nav">';
	    $output .= '				<li class="dropdown head">';
								foreach($this->dpc->moduleInstances as $module){
									if($module->isSubmodule !== true){
									    $output .= '<a data-toggle="dropdown" class="dropdown-toggle '.($_GET['page'] == $module->optionsHook ? ' active' : 'hidden').'" href="#">'.esc_html($this->dpc->getText($module->moduleTitle)).' <span class="caret"></span></a>';
									}
								}
								$output .= '					<ul role="menu" class="dropdown-menu">';
								foreach($this->dpc->moduleInstances as $module){
									if($module->isSubmodule !== true){
									    $output .= '<li '.($_GET['page'] == $module->optionsHook ? ' class="active"' : '').'><a href="?page='.$module->optionsHook.'">'.esc_html($this->dpc->getText($module->moduleTitle)).'</a></li>';
									}
								}
		$output .= '					</ul>';
		$output .= '				</li>';
							foreach($this->dpc->moduleInstances as $module){
								if($module->isSubmodule == true && (isset($module->hideInSubmenu) && $module->hideInSubmenu) != true && strpos($module->optionsHook, $_GET['page']) === 0){
								    $output .= '<li><a href="#" class="menu-anchor" data-scroll="anchor-'.$module->optionsHook.'">'.esc_html($this->dpc->getText($module->moduleTitle)).'</a></li>';
								}
							}
		$output .= '			</ul>';
		$output .= '			<ul class="nav navbar-nav navbar-right dpc-top-menu">';
		$output .= '				<li>'.$this->formButtons().'</li>';
		$output .= '			</ul>';
		$output .= '		</div>';
		$output .= '	</div>';
		#$output .= '</div>';
		$output .= '<div class="space-top-50"></div>';

		if(!empty($this->dpc->messages)){
		    $output .= '<div class="dpc-messages">';
		    foreach($this->dpc->messages as $msg){
		        $messageClass = ($msg['type'] == 'error' ? 'danger' : ($msg['type'] == 'warning' ? 'warning' : 'success'));
		        $output .= '<div class="alert alert-'.$messageClass.'" role="alert">'.esc_html($msg['text']) .'</div>';
		    }
		    $output .= '</div>';
		}

		return $output;

	}

	function getTooltip(){
		if(strlen($this->getAttr('tooltip-content'))){
		    return ' <span class="tooltip-toggle" data-toggle="tooltip" data-placement="right" data-original-title="'.esc_attr($this->getAttr('tooltip-content')).'"><i class="fa fa-question-circle"></i></span>';
		}
		return '';
	}

	function getHeading(){
	    $input  = '<h'.esc_html($this->getAttr('size')).' '.$this->getHtmlAttr().'>'.(strlen($this->getValue()) ? esc_html($this->getValue()) : ' &nbsp;');
		$input .= $this->getTooltip();
		$input .= '</h'.esc_html($this->getAttr('size')).'>';

		return $input;
	}

	function getTable(){
		$this->initChilds();
		$rows	= $this->getAttr('rows');

		if($this->childs !== null){
		    echo '<table class="haswrap '.(strlen($this->getAttr('width')) ? 'col-md-'.esc_attr($this->getAttr('width')) : '').' '.esc_attr($this->getAttr('class')).'" '.esc_attr($this->getAttr('data-toggle')).' '.$this->getHtmlAttr().'>';
			$this->showFields($this->field->children());
			echo '</table>';
		}
	}

	function getTr(){
		if($this->childs !== null){
			echo '<tr '.$this->getHtmlAttr().'>';
			$this->showFields($this->field->children());
			echo '</tr>';
		}
	}

	function getTd(){
		echo '<td '.$this->getHtmlAttr().'>';
		echo esc_html($this->getAttr('label'));
		$this->showFields($this->field->children());
		echo '</td>';
	}

	function getThead(){
		if($this->childs !== null){
			echo '<thead '.$this->getHtmlAttr().'>';
			$this->showFields($this->field->children());
			echo '</thead>';
		}
	}

	function getTbody(){
		if($this->childs !== null){
			echo '<tbody '.$this->getHtmlAttr().'>';
			$this->showFields($this->field->children());
			echo '</tbody>';
		}
	}

	function getTfoot(){
		if($this->childs !== null){
			echo '<tfoot '.$this->getHtmlAttr().'>';
			$this->showFields($this->field->children());
			echo '</tfoot>';
		}
	}


	function getTrStart(){
		echo '<tr '.$this->getHtmlAttr().'>';
	}

	function getTrEnd(){
		echo '</tr>';
	}

	function getTrNext(){
		echo '</tr><tr '.$this->getHtmlAttr().'>';
	}

	function getTdStart(){
		echo '<td '.$this->getHtmlAttr().'>';
	}

	function getTdEnd(){
		echo '</td>';
	}

	function getTh(){
		echo '<th '.$this->getHtmlAttr().'>';
		echo esc_html($this->getAttr('label'));
		echo '</th>';
	}

	function getHidden(){
	    return '<input type="hidden" name="'.esc_attr($this->getName()).'" value="'.esc_attr($this->value).'" '.$this->getHtmlAttr().'/>';
	}

	function getPostAction(){
	    return '<input type="hidden" name="dpcActions['.$this->getAttr('module').']" value="'.esc_attr($this->getAttr('action')).'" />';
	}

	function getFabButton(){
		echo ' <div class="fixed-action-btn horizontal click-to-toggle" style="bottom: 45px; right: 24px;">
				    <a class="btn btn-success btn-rounded">
				   		<i class="fa fa-plus"></i>
				    </a>
				    <ul>
				      <li><a class="btn-floating btn btn-white">	<i class="fa fa-youtube-play"></i></a></li>
				      <li><a class="btn-floating btn btn-white">	<i class="fa fa-user"></i></a></li>
				      <li><a class="btn-floating btn btn-white">	<i class="fa fa-map-marker"></i></a></li>
				      <li><a class="btn-floating btn btn-white">	<i class="fa fa-paint-brush"></i></a></li>
				      <li><a class="btn-floating btn btn-white">	<i class="fa fa-list"></i></a></li>
				      <li><a class="btn-floating btn btn-white">	<i class="fa fa-calendar"></i></a></li>
				    </ul>
				  </div>';
	}

	function getButton(){
	    return '<button name="'.esc_attr($this->getName()).'" value="'.esc_attr($this->value).'" '.$this->getHtmlAttr().'>'.(strlen($this->getAttr('icon-class')) ? '<i class=" '.esc_attr($this->getAttr('icon-class')).'"></i>' : '').' '.esc_html($this->getAttr('label')).' </button>';
	}

	function getToggleButton(){
	    return '<button type="button" name="'.esc_attr($this->getName()).'" '.$this->getHtmlAttr().'><i id="toggle-icon" class="fa fa-'.(strlen($this->getAttr('icon-class')) ? esc_attr($this->getAttr('icon-class')) : 'plus').'"></i></button>';
	}

	function getDeleteButton(){
	    return '<div class="btn btn-danger btn-delete pull-right '.esc_attr($this->getAttr('class')).'" '.$this->getHtmlAttr().'><i class="row-option-elem del-row fa fa-trash-o"></i> <span class="del-option" style="display:none;"><a href="#" class="delete">'.esc_html__('delete', 'delucks-seo').'</a></span><div>';
	}
	function getHide($onElement = false){
		$valueSet 		= (isset($this->settings[(string)$this->getAttr('displayElement')]) ? $this->settings[(string)$this->getAttr('displayElement')] : '');
		$valueRequired 	= $this->getAttr('displayValue');

		echo '<div style="display:';
		if(isset($this->settings[(string)$this->getAttr('displayElement')]) && (is_array($this->settings[(string)$this->getAttr('displayElement')]) && in_array($valueRequired, $this->settings[(string)$this->getAttr('displayElement')])) || $valueSet == $valueRequired){
		 	echo esc_attr($this->getAttr('displayType', 'inline-block'));
		}else {
			echo 'none';
		}
		echo ';" class="hideControls '.esc_attr($this->getAttr('class')).'" id="'.esc_attr($this->getAttr('id')).'" data-display-element="'.esc_attr($this->getName($this->getAttr('displayElement'))).'" '.($this->getAttr('displayValue', false) ? 'data-display-value="'.esc_attr($this->getAttr('displayValue')).'"' : '').'  '.($this->getAttr('displaySearchValue', false) ? 'data-display-searchvalue="'.esc_attr($this->getAttr('displaySearchValue')).'"' : '').' data-display-type="'.esc_attr($this->getAttr('displayType')).'" '.$this->getHtmlAttr().'>';
		if($onElement){
			unset($this->attributes['hide']); //unset hide attribute to avoid endless loop
			echo $this->getInput($this->field);
		} else {
			$this->showFields($this->field->children());
		}
		echo '</div>';
	}

	function getText(){
		$id = (strlen($this->getAttr('id')) ? $this->getAttr('id') : $this->getName());

		$input  =	'<div class="form-group '.str_replace(array('[',']'), "", $this->getName()).'">';
		$input .=		'<div class="input-group">';
		$input .= 			(strlen($this->getAttr('label')) ? '<span class="input-group-addon" style="'.esc_attr($this->getAttr('label-style')).'">'. (strlen($this->getAttr('labelLinkUrl')) ? '<a href="'.esc_url($this->getAttr('labelLinkUrl')).'" target="'. (strlen($this->getAttr('labelLinkTarget')) ? esc_attr($this->getAttr('labelLinkTarget')) : '') .'">' : '') . esc_html($this->getAttr('label')) . (strlen($this->getAttr('labelLinkUrl')) ? '</a>' : '') .'</span>' : (strlen($this->getAttr('icon')) ? '<span class="input-group-addon" style="'.esc_attr($this->getAttr('label-style')).'"><i class="fa '.esc_attr($this->getAttr('icon')).'"></i></span>' : ''));
		$input .=	'		<input type="text" placeholder="'.esc_attr($this->getAttr('placeholder')).'" id="'.esc_attr($id).'" name="'.esc_attr($this->getName()).'" value="'.esc_attr($this->getValue()).'" '.$this->getHtmlAttr(array('value', 'placeholder', 'icon')).' '.(strlen($this->getAttr('tooltip-content')) ? 'style="width:80%;"' : '').' />';
		$input .=			$this->getTooltip();
		$input .=			(strlen($this->getAttr('description')) ? '<span class="description">'.esc_html($this->getAttr('description')).'</span>' : '');
		$input .=	'	</div>';
		$input .=	'</div>';

		if($this->getAttr('tooltip-label') == 'true'){
			$input .= '<script>
						if(typeof(jQuery.fn.popover) != "undefined"){
							jQuery(".form-group.'.str_replace(array('[',']'), "", $this->getName()).' input[name^=\''.$this->getName().'\']").tooltip({
								"title": "'.(strlen($this->getAttr('tooltip-label-content')) ? esc_js($this->getAttr('tooltip-label-content')) : esc_js($this->getAttr('placeholder')) ).'",
								"trigger": "hover focus",
							});
						}
						</script>';
		}
		return $input;
	}

	function getNumber(){
		$input  =	'<div class="form-group">';
		$input .=		'<div class="input-group">';
		$input .= 			(strlen($this->getAttr('label')) ? '<span class="input-group-addon number" style="'.esc_attr($this->getAttr('label-style')).'">'.esc_html($this->getAttr('label')).'</span>' : (strlen($this->getAttr('icon')) ? '<span class="input-group-addon" style="'.esc_attr($this->getAttr('label-style')).'"><i class="fa '.esc_attr($this->getAttr('icon')).'"></i></span>' : ''));
		$input .=	'		<input type="number" value="'.esc_attr($this->getValue()).'" step="'.esc_attr($this->getAttr('step')).'" max="'.esc_attr($this->getAttr('max')).'" min="'.esc_attr($this->getAttr('min')).'" name="'.esc_attr($this->getName()).'" '.$this->getHtmlAttr(array('value', 'placeholder', 'icon')).' '.(strlen($this->getAttr('tooltip-content')) ? 'style="width:80%;"' : '').' />';
		$input .=			$this->getTooltip();
		$input .=			(strlen($this->getAttr('description')) ? '<span class="description">'.esc_html($this->getAttr('description')).'</span>' : '');
		$input .=	'	</div>';
		$input .=	'</div>';
		return $input;
	}

	function getSpinner(){
		$input  = '<div class="input-group">
				  	<div class="input-group spinner" id="'.esc_attr($this->getAttr('spinner-id')).'">
						<div class="input-group-btn-vertical">
				      		<button class="btn btn-default btn-spinner minus"><i class="fa fa-minus"></i></button>
				    	</div>';
		$input .=		'<input type="text" placeholder="'.esc_attr($this->getAttr('placeholder')).'" id="'.esc_attr($this->getName()).'" name="'.esc_attr($this->getName()).'" value="'.esc_attr($this->getValue()).'" '.$this->getHtmlAttr(array('value', 'placeholder', 'icon')).'/>';
		$input .=    	'<div class="input-group-btn-vertical">
				      		<button class="btn btn-default btn-spinner plus"><i class="fa fa-plus"></i></button>
				    	</div>
					</div>
					'.(strlen($this->getAttr('description')) ? '<div class="sublabel"><span>'.esc_html($this->getAttr('description')).'</span></div>' : '').'
				</div>';

		$input .= '<script type="text/javascript">
						(function ($) {
						  $("#'.esc_js($this->getAttr('spinner-id')).' .plus").on("click", function() {
						    $("#'.esc_js($this->getAttr('spinner-id')).' input[name^=\''.esc_js($this->getName()).'\']").val( parseInt($("#'.esc_js($this->getAttr('spinner-id')).' input[name^=\''.esc_js($this->getName()).'\']").val(), 10) + 1);
							return false;
						  });
						  $("#'.esc_js($this->getAttr('spinner-id')).' .minus").on("click", function() {
						    $("#'.esc_js($this->getAttr('spinner-id')).' input[name^=\''.esc_js($this->getName()).'\']").val( parseInt($("#'.esc_js($this->getAttr('spinner-id')).' input[name^=\''.esc_js($this->getName()).'\']").val(), 10) - 1);
							return false;
						  });
						  $("#'.esc_js($this->getAttr('spinner-id')).' input[name^=\''.esc_js($this->getName()).'\']").change(function(){
						  	if( $(this).val() < "0"){
							  	$(this).val("0");
							  }
						  })
						})(jQuery);
					</script>';

		return $input;

	}

	function getSortable(){
		$input  =	'<div class="form-group sortable">';
		$input .=		'<div class="input-group">';
		$input .= 			(strlen($this->getAttr('label')) ? '<span class="input-group-addon" style="'.esc_attr($this->getAttr('label-style')).'">'.esc_html($this->getAttr('label')).'</span>' : (strlen($this->getAttr('icon')) ? '<span class="input-group-addon" style="'.esc_attr($this->getAttr('label-style')).'"><i class="fa '.esc_attr($this->getAttr('icon')).'"></i></span>' : ''));
		$input .=	'		<input type="text" placeholder="'.esc_attr($this->getAttr('placeholder')).'" id="'.esc_attr($this->getName()).'" name="'.esc_attr($this->getName()).'" value="'.(strlen($this->getValue()) ? esc_attr($this->getValue()) : (strlen($this->getAttr('value')) ? esc_attr($this->getAttr('value')) : '')).'" '.$this->getHtmlAttr(array('value', 'placeholder', 'icon')).'/>';
		$input .=			(strlen($this->getAttr('description')) ? '<span class="description">'.esc_html($this->getAttr('description')).'</span>' : '');
		$input .=	'	</div>';
		$input .=	'</div>';

		return $input;
	}

	function getColorpicker(){
		/**
		 * Enqueue colorpicker
		 */
		wp_enqueue_script('bootstrap-colorpicker', plugins_url( 'assets/colorpicker/js/bootstrap-colorpicker.min.js', DPC_FILE), array('jquery'), NULL, true);
		wp_enqueue_style('bootstrap-colorpicker', plugins_url( 'assets/colorpicker/css/bootstrap-colorpicker.css', DPC_FILE));

		$input  =	'<div class="form-group '.$this->getAttr('group-class').'">';
		$input .=		'<div class="input-group color-picker">';
		$input .= 			(strlen($this->getAttr('label')) ? '<span class="input-group-addon" style="'.esc_attr($this->getAttr('label-style')).'">'.esc_html($this->getAttr('label')).'</span>' : (strlen($this->getAttr('icon')) ? '<span class="input-group-addon" style="'.esc_attr($this->getAttr('label-style')).'"><i class="fa '.esc_attr($this->getAttr('icon')).'"></i></span>' : ''));
		$input .=	'		<input type="text" placeholder="'.esc_attr($this->getAttr('placeholder')).'" name="'.esc_attr($this->getName()).'" value="'.esc_attr($this->getValue()).'" '.$this->getHtmlAttr(array('value', 'placeholder', 'icon')).'/>';
		$input .=			(strlen($this->getAttr('description')) ? '<span class="description">'.esc_html($this->getAttr('description')).'</span>' : '');
		$input .=	'	</div>';
		$input .=	'</div>';

		return $input;
	}

	function getTimepicker(){
		/**
		 * Enqeue timepicker
		 */
		wp_enqueue_script('bootstrap-timepicker', plugins_url( 'assets/timepicker/js/bootstrap-timepicker.min.js', DPC_FILE), array('jquery'), NULL, true);
		wp_enqueue_style('bootstrap-timepicker', plugins_url( 'assets/timepicker/css/bootstrap-timepicker.css', DPC_FILE));
		$input  =	'<div class="form-group timepicker '.str_replace(array('[',']'), "", $this->getName()).'" style="max-width: 115px;">';
		$input .=		'<div class="input-group" >';
		$input .= 			'<span class="input-group-addon"><i class="fa fa-clock-o"></i></span>';
		$input .=	'		<input type="text" placeholder="'.esc_attr($this->getAttr('placeholder')).'" name="'.esc_attr($this->getName()).'" value="'.esc_attr($this->getValue()).'" '.$this->getHtmlAttr(array('value', 'placeholder', 'icon')).'/>';
		$input .=			(strlen($this->getAttr('description')) ? '<span class="time-description">'.esc_html($this->getAttr('description')).'</span>' : '');
		$input .=	'	</div>';
		$input .=	'</div>';


		$input .= '<script type="text/javascript">
					jQuery(document).ready(function($){
						$(\'input[name^="'.esc_js($this->getName()).'"]\').timepicker({
							template: "dropdown",
							minuteStep: 5,
							showInputs: false,
							disableFocus: true,
							up: "fa fa-chevron-up",
    						down: "fa fa-chevron-down",
    						appendWidgetTo: $("#wpwrap"),
							defaultTime: "'.esc_js($this->getAttr('defaultTime')).'"
						});
					});
					</script>';
		return $input;
	}

	function getDatepicker(){
		wp_enqueue_script('jquery-ui-datepicker');
		#wp_enqueue_script('bootstrap-datepicker', plugins_url( 'assets/bootstrap-datepicker/js/bootstrap-datepicker.js', DPC_FILE), array('jquery'), NULL, true);
		#wp_enqueue_style('bootstrap-datepicker', plugins_url( 'assets/bootstrap-datepicker/css/bootstrap-datepicker.css', DPC_FILE));

		$input  =	'<div class="form-group dpc-has-datepicker" style="max-width: 185px;">';
		$input .=		'<div class="input-group date">';
		$input .=			'<span class="input-group-addon"><span class="fa fa-calendar"></span></span>';
		$input .= 			'<input type="text" name="'.esc_attr($this->getName()).'" class="form-control dpc-datepicker" placeholder="'.esc_attr($this->getAttr('placeholder')).'" value="'.esc_attr($this->getValue()).'" '.$this->getHtmlAttr(array('value', 'placeholder', 'icon')).'/>';
		$input .=			(strlen($this->getAttr('description')) ? '<span class="time-description">'.esc_html($this->getAttr('description')).'</span>' : '');
		$input .=	'	</div>';
		$input .=	'</div>';

		$input .= '<script>jQuery(document).ready(function() {jQuery( ".dpc-datepicker" ).datepicker( { dateFormat: \'dd/mm/yy\' } ); });</script>';

		return $input;
	}

	function getCopyCode(){
		$url = plugins_url();
		$input  = '	<div class="copyCode" '.$this->getHtmlAttr().'>';
		$input .= '	<h5>'.
		  		(strlen($this->getAttr('name')) ? $this->getAttr('name') : esc_html__('Shortcode', 'delucks-seo')).': '.$this->getTooltip().'
					</h5>';
		  		$input .= '<span id="'.esc_attr($this->getAttr('id')).'" class="shortcode">'.esc_html($this->getAttr('text')).'</span>';
		$input .= '</div>';
		return $input;
	}

	function getTaglist(){
		wp_enqueue_script('caret', plugins_url( 'assets/tagEditor/jquery.caret.min.js', DPC_FILE), array('jquery'));
		wp_enqueue_script('tagEditor', plugins_url( 'assets/tagEditor/jquery.tag-editor.js', DPC_FILE), array('jquery'));
		wp_enqueue_style('tagEditor', plugins_url( 'assets/tagEditor/jquery.tag-editor.css', DPC_FILE));

		$preselection = ($this->getAttr('preselection') != '' ? explode(',', $this->getAttr('preselection')) : false);

		$id = wp_rand();

		$input =	'<div id="taglist'.$id.'" class="input-group input-taglist '.(strlen($this->getAttr('tooltip-content')) ? 'has-tooltip' : '') . '" >';
		$input .=	(strlen($this->getAttr('label')) ? '<span class="input-group-addon">'.esc_html($this->getAttr('label')).'</span>' : (strlen($this->getAttr('icon')) ? '<span class="input-group-addon"><i class="fa '.esc_attr($this->getAttr('icon')).'"></i></span>' : ''));
		$input .=	'	<input type="text" id="'.esc_attr($this->getName()).'" name="'.esc_attr($this->getName()).'" value="'.esc_attr($this->getValue()).'" '.$this->getHtmlAttr().'/>';
		$input .= $this->getTooltip();

		$value = array();
		if(strlen($this->getValue())){
			$value = explode(',', $this->getValue());
		}

		if($preselection){
			$input .=	'<div id="preselection'.$id.'" class="preselection">';
			$input .=	'	<h4>'.esc_html__('Placeholder', 'delucks-seo').':</h4>';
			foreach($preselection as $k => $v){
			    $input .=	'<a href="#" data-id="preselection_'.esc_attr($v).'_'.esc_attr($id).'" class="single-preselection '.(in_array($v, $value) ? 'disabled' : '').'" data-target="'.esc_attr($this->getName()).'" data-value="'.esc_attr($v).'">'.esc_attr($v).'</a>';
			}
			$input .=	'</div>';
		}

		$input .=	'</div>';
		$input .= 	'<script type="text/javascript">jQuery(document).ready(function($) {
						$(\'[name^="'.esc_js($this->getName()).'"]\').tagEditor({
							forceLowercase: false,
							initialTags:'.wp_json_encode($value).',
							tokenSeparators: ",",
							beforeTagDelete: function(field, editor, tags, val) {
								$(".single-preselection[data-id^=\'preselection_"+val+"_'.esc_js($id).'\']").removeClass("disabled");
							}
						});';
		$input .= '});</script>';
		return $input;
	}

	function getHtmlElements(){
		switch($this->getAttr('element')){
			case 'hr':
				return '<div class="clear"></div><hr '.$this->getHtmlAttr().'/>';
				break;
			case 'br':
				return '<br/>';
				break;
			case 'border':
			    return '<div class="'.esc_attr($this->getAttr('class')).'" '.$this->getHtmlAttr().'></div>';
				break;
			case 'span':
			    return '<span '.$this->getHtmlAttr().'>'.esc_html($this->getAttr('text')).'</span>';
				break;
			case 'clear':
				return '<div class="clear"></div>';
		}


	}

	function getHinweis(){
	    return '<p class="advice '.esc_attr($this->getAttr('class')).'"><span class="hinweis"><i class="fa fa-info-circle"></i> '.esc_html__('Notice', 'delucks-seo').'</span> <span>'.esc_html($this->getAttr('text')).'&nbsp;'.(strlen($this->getAttr('link')) ? '<a href="'.esc_url($this->getAttr('link')).'" target="_blank">'.esc_html($this->getAttr('link-text')).'</a> '.esc_html($this->getAttr('text-after-link')) : '').'</span></p>';
	}

	function getInfo(){
	    return '<p class="advice"><span class="info" id="'.esc_attr($this->getAttr('id')).'"><i class="fa fa-info-circle"></i> '.esc_html__('Info', 'delucks-seo').'</span> <span>'.esc_html($this->getAttr('text')).'&nbsp;'.(strlen($this->getAttr('link')) ? '<a href="'.esc_url($this->getAttr('link')).'" target="_blank">'.esc_html($this->getAttr('link-text')).'</a> '.esc_html($this->getAttr('text-after-link')) : '').'</span></p>';
	}

	function getAlert(){
	    $input  = '	<div class="alert alert-'.esc_attr($this->getAttr('alert-type')).' '.esc_attr($this->getAttr('class')).'" role="alert" style="width: 100%;">
						<div class="row"><div class="col-md-12">';
	    $input .= 			(strlen($this->getAttr('bold-text')) ? '<strong>'.esc_html($this->getAttr('bold-text')).'</strong>' : '').' '.esc_html($this->getAttr('text'));

		if(strlen($this->getAttr('link'))){
		    $input .= ' <a href="'.esc_url($this->getAttr('link')).'" class="'.esc_attr($this->getAttr('link-class')).'" '.(strlen($this->getAttr('link-target')) ? 'target="'.esc_attr($this->getAttr('link-target')).'"' : '').'>'.esc_html($this->getAttr('link-text')).'</a>';
		}

		$input .= '</div></div></div>';

		return $input;
	}

	function getParagraph(){
	    $input  = '<div id="'.esc_attr($this->getAttr('id')).'" class="form-group"><div class="input-group ">';
	    $input .= '<p class="'.esc_attr($this->getAttr('class')).'" '.$this->getHtmlAttr(array('class,id')).'>';
		if(strlen($this->getAttr('icon-class'))){
		    $input .= '<i class="'.esc_attr($this->getAttr('icon-class')).'"></i>';
		}

		$input .= $this->getAttr('text');
		if(strlen($this->getAttr('link'))){
		    $input .= '<a href="'.esc_url($this->getAttr('link')).'" class="'.esc_attr($this->getAttr('link-class')).'">'.esc_html($this->getAttr('link-text')).'</a>';
		}
		$input .= $this->getTooltip();
		$input .= '</p>';
		$input .= '</div>';
		$input .= '</div>';
		return $input;
	}

	function getLabel(){
	    $input  = '<div id="'.esc_attr($this->getAttr('id')).'" class="form-group"><div class="input-group ">';
	    $input .= '<label class="'.esc_attr($this->getAttr('class')).'" '.$this->getHtmlAttr(array('class,id')).'>';
	    if(strlen($this->getAttr('icon-class'))){
	        $input .= '<i class="'.esc_attr($this->getAttr('icon-class')).'"></i>';
	    }

	    $input .= $this->getAttr('text');
	    if(strlen($this->getAttr('link'))){
	        $input .= '<a href="'.esc_url($this->getAttr('link')).'" class="'.esc_attr($this->getAttr('link-class')).'">'.esc_html($this->getAttr('link-text')).'</a>';
	    }
	    $input .= $this->getTooltip();
	    $input .= '</label>';
	    $input .= '</div>';
	    $input .= '</div>';
	    return $input;
	}

	function getIcon(){
	    $input  = '<div id="'.esc_attr($this->getAttr('id')).'" class="form-group"><div class="input-group ">';
		if(strlen($this->getAttr('tooltip'))){
		    $input .= '<span class="tooltip-toggle" data-original-title="'.esc_attr($this->getAttr('tooltip')).'" data-placement="'.(strlen($this->getAttr('tooltip-placement')) ? esc_attr($this->getAttr('tooltip-placement')) : 'top').'" data-toggle="tooltip">';
		}
		$input .= '<i class="'.esc_attr($this->getAttr('class')).'" '.$this->getHtmlAttr(array('id')).'></i>';
		if(strlen($this->getAttr('tooltip'))){
			$input .= '</span>';
		}
		$input .= '</div></div>';

		return $input;
	}

	/*
	 * https://getbootstrap.com/docs/4.0/components/collapse/
	 **/
	function getAccordion(){
	    $this->initChilds();

	    $accordionId = md5(wp_rand(5, 15));
	    $input  = '<div id="dpc_accordion'.$accordionId.'" class="dpc_accordion '.esc_attr($this->getAttr('class')).'">';

	    foreach($this->childs->content as $content){
	        $expanded = (isset($content['expanded']) && $content['expanded'] == 'true') ? true : false;

	        ob_start();
	        $this->getSection($content['section']);

	        $id = md5(wp_rand(1, 999999));

	        $input  .= '<div class="card col">';
	        $input  .= '    <div class="card-header" id="dpc_accordion_'.$id.'_heading">';
	        $input  .= '        <h5 class="mb-0">';
	        $input  .= '            <a class="btn btn-link '.($expanded ? '' : 'collapsed').'" aria-expanded="'.($expanded ? 'true' : 'false').'" data-toggle="collapse" href="#dpc_accordion_'.$id.'_content" aria-controls="dpc_accordion_'.$id.'_content">'. esc_html($content['heading']) .'</a>';
	        $input  .= '        </h5>';
	        $input  .= '    </div>';
	        $input  .= '    <div id="dpc_accordion_'.$id.'_content" class="collapse'.($expanded ? ' show in' : '').'" aria-labelledby="dpc_accordion_'.$id.'_heading" data-parent="#dpc_accordion'.$accordionId.'">';
	        $input  .= '        <div class="card-body">'. ob_get_clean() .'</div>';
	        $input  .= '    </div>';
	        $input  .= '</div>';
	    }

	    $input .= '</div>';

	    return $input;
	}

	function getLink(){
	    $input  = '<div id="'.esc_attr($this->getAttr('id')).'" class="form-group"><div class="input-group ">';
		if($this->getAttr('nowrap', false)){
		    $input = '';
		}
		$input .= (strlen($this->getAttr('text-before')) ? '<p class="text-before">'.esc_html($this->getAttr('text-before')).'' : '');
		$input .= '<a target="'.esc_attr($this->getAttr('target')).'" href="'.esc_url($this->getAttr('link')).'" class="'.esc_attr($this->getAttr('class')).'" '.$this->getHtmlAttr(array('class,id')).'>';
		if(strlen($this->getAttr('icon-class'))){
		    $input .= '<i class="'.esc_attr($this->getAttr('icon-class')).'">'.(strlen($this->getAttr('icon-text')) ? esc_html($this->getAttr('icon-text')) : '').'</i>';
		}
		$input .= esc_html($this->getAttr('text')).'</a>';
		$input .= (strlen($this->getAttr('text-before')) ? '</p>' : '');

		if(!$this->getAttr('nowrap', false)){
		    $input .= '</div></div>';
		}

		return $input;
	}

	function getModal(){
		//$this->initChilds();
	    $input  = '<div class="modal fade dpc-modal '.esc_attr($this->getAttr('class')).'" data-triggerBy="'.esc_attr($this->getAttr('triggerBy')).'" id="'.esc_attr($this->getAttr('target')).'" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">';
		//Head
  		$input .= '		<div class="modal-dialog">
  							<div class="modal-content">';
		$input .= ' 			<div class="modal-header">';
        $input .= '					<button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span></button>';
        $input .= '					<h4 class="modal-title" id="myModalLabel">'.(strlen($this->getAttr('icon-class', '')) ? '<i class="fa fa-'.esc_attr($this->getAttr('icon-class')).'"></i> ' : '').esc_html($this->getAttr('title')).'</h4>
        						</div>';
        //Head End - Body Start
     	$input .= '				<div class="modal-body">';
								 	if($this->field->children !== null){
										$field 	= $this->field;
										$attributes = $this->attributes;
								        $input .= $this->showFields($this->field->children(), true);
										$this->field = $field;
										$this->attributes 	= $attributes;
								    }
        $input .= '					<p>'.esc_html($this->getAttr('content')).'</p>'.(strlen($this->getAttr('extra-content')) ? '<p class="'.esc_attr($this->getAttr('extra-content-type')).'">'.esc_html($this->getAttr('extra-content')).'</p>' : '');
      	$input .= '				</div>';
		//Body End - Footer Start
      	$input .= '				<div class="modal-footer">';
      	$input .= 					$this->getAttr('abort', false) !== false ? '<button type="button" class="btn btn-danger pull-left" data-dismiss="modal">'.esc_html($this->getAttr('abort')).'</button>' : '';
      	$input .= 					$this->getAttr('continue', false) !== false ? '<button type="button" class="btn btn-success pull-right">'.esc_html($this->getAttr('continue')).'</button>' : '';
		//Modal End
      	$input .= '				</div>
      						</div>
      					</div>
      				</div>';


		return $input;
	}

	function getImage(){
		$url = ($this->getAttr('absolute', false) || preg_match('|^http(s?)://|', $this->getAttr('image')) ? $this->getAttr('image') : DPC_PLUGIN_URL.$this->getAttr('image'));
		$input  = '<div class="form-group"><div class="input-group ">';
		$input .= (strlen($this->getAttr('text-before')) ? '<p class="lang-before">'.esc_html($this->getAttr('text-before')).'</p>' : '');
		$input .= '<img src="'.esc_url($url).'" alt="'.esc_attr($this->getAttr('alt', '')).'" '.$this->getHtmlAttr(array('alt')).' />';
		$input .= (strlen($this->getAttr('text-after')) ? '<p class="lang-after">'.esc_html($this->getAttr('text-after')).'</p>' : '');
		$input .= $this->getTooltip();
		$input .= '</div></div>';

		return $input;
	}

	function getIFrame(){
		$url = ($this->getAttr('absolute', false) || preg_match('|^http(s?)://|', $this->getAttr('src')) ? $this->getAttr('src') : DPC_PLUGIN_URL.$this->getAttr('src'));
		$input  = '<div class="form-group"><div class="input-group ">';
		$input .= (strlen($this->getAttr('text-before')) ? '<p class="lang-before">'.esc_html($this->getAttr('text-before')).'</p>' : '');
		$input .= '<iframe width="'.esc_attr($this->getAttr('width', '')).'" height="'.esc_attr($this->getAttr('height', '')).'" src="'.esc_url($url).'" frameborder="0" allowfullscreen '.$this->getHtmlAttr(array('alt')).'></iframe>';
		$input .= (strlen($this->getAttr('text-after')) ? '<p class="lang-after">'.esc_html($this->getAttr('text-after')).'</p>' : '');
		$input .= $this->getTooltip();
		$input .= '</div></div>';

		return $input;
	}

	function getCheckbox(){
		/**
		 * Enqeue icheck
		 */
		wp_enqueue_script('icheck', plugins_url( 'assets/iCheck/icheck.min.js', DPC_FILE), array('jquery'), NULL, true);
		wp_enqueue_style('icheck-blue', plugins_url( 'assets/iCheck/blue.css', DPC_FILE));
		wp_enqueue_style('icheck-green', plugins_url( 'assets/iCheck/green.css', DPC_FILE));

		$input = 	'<ul class="form-group '.(strlen($this->getAttr('ul-class')) ? esc_attr($this->getAttr('ul-class')) : '').'"><li>';
		$input .=	'<input id="'.esc_attr($this->getAttr('id')).'" type="checkbox" class="icheck-checkbox '.esc_attr($this->getAttr('class')).'" name="'.esc_attr($this->getName()).'" '.($this->getValue() == 'on' ? ' checked="checked"' : '').' '.$this->getHtmlAttr(array('checked,class')).'/>' ;
		$input .=	'<label>'.esc_html($this->getAttr('label')).'</label>';
		if(strlen($this->getAttr('tooltip-content'))){
		    $input .= '  <span class="tooltip-toggle" data-toggle="tooltip" data-placement="'.esc_attr($this->getAttr('tooltip-placement')).'" data-original-title="'.esc_attr($this->getAttr('tooltip-content')).'"><i class="fa fa-question-circle"></i></span>';
		}
		$input .=	'</li></ul>';
		$input .= 	'<script type="text/javascript">
					jQuery(document).ready(function($) {
						$("#'.esc_js($this->getAttr('id')).'").iCheck({
					    	checkboxClass: "icheckbox_square-'.(strlen($this->getAttr('color')) ? esc_js($this->getAttr('color')) : 'blue').'",
					  	});
				  	});
					</script>';
		return $input;
	}

	function getRadio(){
		$input =	'<div class="radio"><label>';
		foreach($this->possibleValues as $val){
		    $input  .= '<input type="radio" id="'.esc_attr($this->getName()).'" name="'.esc_attr($this->getName()).'" value="'.esc_attr($val['value']).'"'.($val['value'] == $this->getValue() ? ' checked="checked"' : '').' '.$this->getHtmlAttr().'/>'.esc_html($this->getAttr('label'));
		}
		$input .=	'</label></div>';

		return $input;
	}

	function getRadioSwitch(){
		/**
		 * Multiselect
		 */

		wp_enqueue_script('bootstrap-multiselect', plugins_url( 'assets/bootstrap-multiselect/js/bootstrap-multiselect.js', DPC_FILE), array('jquery'), NULL, true);
		wp_enqueue_style('bootstrap-multiselect', plugins_url( 'assets/bootstrap-multiselect/css/bootstrap-multiselect.css', DPC_FILE));

		$input =	'<div class="btn-group btn-toggle" data-toggle="buttons">';
		foreach($this->possibleValues as $val){$input  .= '<label class="'.esc_attr($val['class']).' '.($val['value'] == $this->getValue() ? ' active' : '').'">';
		  $input  .= '<input type="radio" id="'.esc_attr($this->getName()).'" name="'.esc_attr($this->getName()).'" value="'.esc_attr($val['value']).'"'.($val['value'] == $this->getValue() ? ' checked="checked"' : '').' '.$this->getHtmlAttr().'/>'.esc_html($val['label']);
			$input 	.= '</label>';
			if(isset($val['toggle'])){
			}
		}
		$input .=	'</div>';

		return $input;
	}

	function getSelect(){
		/**
		 * Multiselect
		 */

		wp_enqueue_script('bootstrap-multiselect', plugins_url( 'assets/bootstrap-multiselect/js/bootstrap-multiselect.js', DPC_FILE), array('jquery'), NULL, true);
		wp_enqueue_style('bootstrap-multiselect', plugins_url( 'assets/bootstrap-multiselect/css/bootstrap-multiselect.css', DPC_FILE));

		$input 	 = '<div id="'.esc_attr($this->getAttr('id')).'" class="input-group '.($this->getAttr('hidden') == 'true' ? 'hidden' : '').'">'.(strlen($this->getAttr('label')) ? '<span class="input-group-addon" style="width:'.esc_attr($this->getAttr('label-width')).'px;">'.esc_html($this->getAttr('label')).'</span>' : '' );
		$input  .= '<select id="'.esc_attr($this->getName()). '" name="'.esc_attr($this->getName()).($this->getAttr('multiple') == 'multiple' ? '[]' : '').'" '.$this->getHtmlAttr().($this->getAttr('fullheight') == 'true' ? ' size="'.count($this->possibleValues).'"' : '' ).'>';
		if(is_array($this->possibleValues)){
			foreach($this->possibleValues as $val){
				$selected = false;
				if($this->getAttr('multiple') == 'multiple'){
					$selected = (is_array($this->getValue()) && in_array($val['value'], $this->getValue()) ? true : false);
				} else {
					$selected = (($val['value'] == $this->getValue() || (string)$val['value'] == (string)$this->getAttr('value', false)) ? true : false);
				}
				$input .= '<option value="'.esc_attr($val['value']).'"'.($selected ? ' selected="selected"' : '').'>'.esc_html($val['label']).'</option>';
			}
		}
		$input .= '</select>';
		$input .= $this->getTooltip();
		$input .= '</div>';
		$input .= 	'<script type="text/javascript">
					jQuery(document).ready(function($) {
						$(\'select[name^="'.esc_js($this->getName()).($this->getAttr('multiple') == 'multiple' ? '[]' : '').'"]\').multiselect({
							nonSelectedText: "'.(strlen($this->getAttr('nonSelectedText')) ? esc_js($this->getAttr('nonSelectedText')) : esc_js(__('None selected', 'delucks-seo'))).'",
							nSelectedText: "'.esc_js(__('selected', 'delucks-seo')).'",
							allSelectedText: "'.esc_js(__('All selected', 'delucks-seo')).'",
							selectAllText: "'.esc_js(__('Select all', 'delucks-seo')).'",
							buttonClass: \'btn btn-blue '.esc_js($this->getAttr('btn-class')).'\''.
							         (strlen($this->getAttr('numberDisplayed')) ? ', numberDisplayed: '.esc_js($this->getAttr('numberDisplayed')) : '').
									 (strlen($this->getAttr('onChange')) ? ', onChange: '.esc_js($this->getAttr('onChange')) : '');
		if($this->getAttr('templates') == 'true'){
			$input .=				', templates: {'.
					(strlen($this->getAttr('button')) ? 'button: "<'.esc_js($this->getAttr('button')).'></button>"' : '')
					.'}';
		}
		$input .=		'});
					});
					</script>';


		return $input;
	}

	function getSelectImg(){
		$options = explode(',', $this->getAttr('items'));

		$input  = '<div id="'.esc_attr($this->getAttr('id')).'" class="select-img">';
			if(!$this->getAttr('unicode')){
				foreach($options as $option){
				    $input .= '<span id="'.esc_attr($option).'" class="img-option" data-value="'.esc_attr($option).'"><i class="'.( $this->getAttr('font-family') ? esc_attr($this->getAttr('font-family')) : 'fa fa-').''.esc_attr($option).'"></i></span>';
				}
			}else{
				foreach($options as $option){
				    $input .= '<span id="'.esc_attr($option).'" class="img-option" data-value="'.esc_attr($option).'"><i class="dpc-rating-icon '.esc_attr($option).'"></i></span>';
				}
			}

		$input .= '<input type="hidden" value="'.esc_attr($this->getValue()).'" name="'.esc_attr($this->getName()).'"/>';
		$input .= '</div>';

		$input .= 	'<script type="text/javascript">
					jQuery(document).ready(function($) {
						if($(\'input[name^="'.esc_js($this->getName()).'"]\').val()){
							var selected = $(\'input[name^="'.esc_js($this->getName()).'"]\').val();
							$("#'.esc_js($this->getAttr('id')).'.select-img").find("#"+selected).addClass("active"); //check
						}
						$("#'.esc_js($this->getAttr('id')).' .img-option").bind("click", function(ev){
							if(!$(this).hasClass("active")){
								$("#'.esc_js($this->getName()).' > .img-option").removeClass("active");
								$(this).addClass("active").siblings().removeClass("active");
								$(\'input[name^="'.esc_js($this->getName()).'"]\').val($(this).data("value"));
							}
						})
					});
					</script>';

  		return $input;
	}

	function getselectToggle(){
		/**
		 * Multiselect
		 */

		wp_enqueue_script('bootstrap-multiselect', plugins_url( 'assets/bootstrap-multiselect/js/bootstrap-multiselect.js', DPC_FILE), array('jquery'), NULL, true);
		wp_enqueue_style('bootstrap-multiselect', plugins_url( 'assets/bootstrap-multiselect/css/bootstrap-multiselect.css', DPC_FILE));

		//$input 	 = '<div class="input-group '.($this->getAttr('hidden') == 'true' ? 'hidden' : '').'">';
		$input  .= '<select id="'.esc_attr($this->getName()). '" name="'.esc_attr($this->getName()).($this->getAttr('multiple') == 'multiple' ? '[]' : '').'" '.$this->getHtmlAttr().($this->getAttr('fullheight') == 'true' ? ' size="'.count($this->possibleValues).'"' : '' ).'>';
		foreach($this->possibleValues as $val){
			$selected = false;
			if($this->getAttr('multiple') == 'multiple'){
				$selected = (in_array($val['value'], $this->getValue()) ? true : false);
			} else {
				$selected = ($val['value'] == $this->getValue() ? true : false);
			}
			$input .= '<option value="'.esc_attr($val['value']).'"'.($selected ? ' selected="selected"' : '').'>'.esc_html($val['label']).'</option>';
		}
		$input .= '</select>';
		//$input .= '</div>';
		$input .= 	'<script type="text/javascript">
					jQuery(document).ready(function($) {
						$(\'select[name^="'.esc_js($this->getName()).'"]\').multiselect({
							buttonClass: \'btn btn-blue '.esc_js($this->getAttr('btn-class')).'\',
						});
					});
					</script>';


		return $input;
	}
	function getTextarea(){
		$input = '<div class="form-group '.str_replace(array('[',']'), "", $this->getName()).'">
					<div class="input-group">'.(strlen($this->getAttr('label','')) ? '<div class="textareaLabel">'.esc_html($this->getAttr('label','')).'</div>' : '').'
						<textarea id="'.esc_attr($this->getName()).'" name="'.esc_attr($this->getName()).'" '.$this->getHtmlAttr().'>'.esc_textarea(stripslashes($this->getValue('textarea'))).'</textarea>
					</div>
				</div>';
		if($this->getAttr('tooltip-label') == 'true'){
			$input .= '<script>
						if(typeof(jQuery.fn.popover) != "undefined"){
							jQuery(".form-group.'.esc_js(str_replace(array('[',']'), "", $this->getName())).' textarea[name^=\''.esc_js($this->getName()).'\']").tooltip({
								"title": "'.(strlen($this->getAttr('tooltip-label-content')) ? esc_js($this->getAttr('tooltip-label-content')) : esc_js($this->getAttr('placeholder')) ).'",
								"trigger": "hover focus",
							});
						}
						</script>';
		}
		return $input;
	}

	function getNextRow(){
	    return '<div class="w-100 d-none d-md-block"></div>';
	}

	function getHtml(){
		echo "<pre>";
		print_r($this->field);
		echo "</pre>";
		return '';
	}

	function debug(){
		echo "<pre>";
		print_r(($this->getAttr('dbg') ? $this->getAttr('dbg') : $this->field));
		echo "</pre>";
		return '';
	}

	function getMediaUploader(){
	    $input  = '	<div class="dpc-fileinput fileinput-new '.($this->getAttr('alt-input') == 'true' ? 'has-alt-input" data-input-id="'.esc_attr($this->getAttr('alt-input-id')).'"' : '"').'>';
	    $input .= '		<div class="dpc-input-thumbnail" style="width: '.esc_attr($this->getAttr('width')).'; height: '.esc_attr($this->getAttr('height')).';">';
	    $input .= '			<img class="dpc-file-holder" src="'.(strlen($this->getValue()) ? esc_url($this->getValue()) : '').'" alt="'. (strlen($this->getAttr('placeholder')) ? esc_attr($this->getAttr('placeholder')) : esc_attr(__('Nothing selected', 'delucks-seo'))) .'"/>';
		$input .= '		</div>';
		$input .= '		<div class="dpc-media-uploader">

							<a href="#" class="btn btn-default btn-file dpc-file-upload-button" data-name="'.esc_attr($this->getAttr('id')).'" data-frame-title="'.esc_attr($this->getAttr('frame-title')).'">'.esc_html__('Select', 'delucks-seo').'</a>
							<a href="#" class="btn btn-default btn-file upload-dpc-file" data-name="'.esc_attr($this->getAttr('id')).'" data-frame-title="'.esc_attr($this->getAttr('frame-title')).'">'.esc_html__('Change', 'delucks-seo').'</a>
							<a href="#" class="btn btn-danger remove-dpc-file" data-name="'.esc_attr($this->getAttr('id')).'">'.esc_html__('Remove', 'delucks-seo').'</a>';
		if($this->getAttr('alt-input') != 'true'){
		    $input .= '		<input type="text" name="'.esc_attr($this->getName()).'" class="dpc-fileinput-input" id="'.esc_attr($this->getAttr('id')).'" value="'.(strlen($this->getValue()) ? esc_attr($this->getValue()) : '').'"/>';
		}
		$input .= '		</div>
					</div>';

		return $input;
	}

	function getFile(){
		$input =	'<div class="form-group">';

		if(!$this->getAttr('buttonLabel', false)){
		    $input .=	'<label for="'.esc_attr($this->getName()).'">'.esc_html($this->getAttr('label')).'</label>';
		}

		$input .=	'<input type="file" id="'.esc_attr($this->getName()).'" name="'.esc_attr($this->getattr('index')).'"'.($this->getAttr('showUploadField', false) == false ? ' style="display: none;"' : '').'/>';
    	if($this->getAttr('buttonLabel', false)){
    	    $input .= '<button name="'.esc_attr($this->getName()).'" value="'.esc_attr($this->getValue()).'" '.$this->getHtmlAttr().'>'.esc_html($this->getAttr('buttonLabel')).' '.(strlen($this->getAttr('icon-class')) ? '<i class="fa '.esc_attr($this->getAttr('icon-class')).'"></i>' : '').'</button>';
    	}

    	if(strlen($this->getAttr('helptext'))){
    	    $input .=	'<p class="help-block">'.esc_html($this->getAttr('helptext')).'</p>';
    	}
  		$input .=	'</div>';
		return $input;
	}

	function showFields($fields = null, $return = false){
		if($fields == null){ return false; }
		$return_fields = '';
		foreach($fields as $field){
			$this->initPossibleValues($field);
			$this->field 	= $field;
			$attr 			= $field->attributes();
			$this->value	= $attr->value;
			if($return !== false){
				$return_fields .= $this->getInput($field->attributes());
			} else {
				echo $this->getInput($field->attributes());
			}
		}

		if($return !== false){
			return $return_fields;
		}

	}

	function showSection($fields = null, $addAnchor = false, $skipWrapper = false){
		if(isset($this->sectionAttributes['bootstrap']) && $this->sectionAttributes['bootstrap'] == true){
		    wp_register_script('popper', plugins_url( 'assets/bootstrap/js/popper.min.js', DPC_FILE ), array('jquery'), NULL, true);
			wp_enqueue_script('bootstrap', plugins_url( 'assets/bootstrap/js/bootstrap.min.js', DPC_FILE ), array('jquery', 'popper'), NULL, true);
			wp_enqueue_script('dpc', plugins_url( 'assets/dpc/js/functions.js', DPC_FILE ), array('jquery'), NULL, true);
		}
		if(isset($this->sectionAttributes['css']) && $this->sectionAttributes['css'] == true){
			wp_enqueue_style('dpc-edit-css', plugins_url( 'assets/dpc/css/edit.min.css', DPC_FILE ));
			wp_enqueue_style('dpc-css', plugins_url( 'assets/dpc/css/style.css', DPC_FILE ));
			#wp_enqueue_style('dpc-css-additional', plugins_url( 'assets/dpc/css/style_additional.css', DPC_FILE ));
			wp_enqueue_style('dpc-responsive', plugins_url( 'assets/dpc/css/style-responsive.css', DPC_FILE ));
			wp_enqueue_style('dpc-font-awesome', plugins_url( 'assets/font-awesome/css/font-awesome.min.css', DPC_FILE ));
		}


		if($fields == null){ return false; }
		if(isset($this->sectionAttributes['extendable']) && $this->sectionAttributes['extendable'] == true){
			#unset($this->sectionAttributes['extendable']);
			$this->inLoop = true;
			$sectionName = (string)$this->sectionAttributes['name'];
			/* DRAFT: start */
			if($skipWrapper == false || $this->getAttr('skipWrapper', false)){
				echo $this->sectionStart('dpc-draft extendable', $this->sectionAttributes['skipRowClass']);
			}
			echo $this->getExtendableButtonRemove();
			$this->isDraftLoop = true;
			foreach($fields as $field){
				$this->initPossibleValues($field);
				$this->field 	= $field;
				$attr 			= $field->attributes();
				$this->value	= $attr->value;
				echo $this->getInput($field->attributes());
			}
			$this->isDraftLoop = false;
			if(!$skipWrapper){
				echo $this->sectionClose();
			}
			/* DRAFT: end */

			if(isset($this->settings[$sectionName]) && is_array($this->settings[$sectionName]) && count($this->settings[$sectionName])){
				foreach($this->settings[$sectionName] as $k => $v){
					if($skipWrapper == false || $this->getAttr('skipWrapper', false)){
						echo $this->sectionStart('extendable', $this->sectionAttributes['skipRowClass']);
					}
					echo $this->getExtendableButtonRemove();
					foreach($fields as $field){
						$this->initPossibleValues($field);
						$this->field 	= $field;
						$attr 			= $field->attributes();
						$this->value	= $attr->value;
						echo $this->getInput($field->attributes());
					}
					if($skipWrapper == false || $this->getAttr('skipWrapper', false)){
						echo $this->sectionClose();
					}
					$this->loopIndex++;
				}
			}

			echo $this->getExtendableButtonAdd();
			$this->loopIndex = 0;
			$this->inLoop = false;
		} else {
			if($skipWrapper == false || $this->getAttr('skipWrapper', false)){
				echo $this->sectionStart($this->getAttr('class'));
			}
			foreach($fields as $field){
				$this->initPossibleValues($field);
				$this->field 	= $field;
				$attr 			= $field->attributes();
				$this->value	= $attr->value;
				echo $this->getInput($field->attributes());
			}
			if($skipWrapper == false || $this->getAttr('skipWrapper', false)){
				echo $this->sectionClose();
			}
		}
	}

	function getExtendableButtonAdd(){
		if(isset($this->sectionAttributes['buttonAddClass'])){
			$class = trim($this->sectionAttributes['buttonAddClass']);
		}
		return '<button class="dpc-extendable-add btn-md btn btn-default btn-block '.(strlen($class) ? esc_attr($class) : '').'" data-container=".'. esc_attr($this->module) . '.' . esc_attr($this->sectionAttributes['name']) .'.dpc-draft">'. esc_html($this->sectionAttributes['buttonAddText']) .'</button>';
	}

	function getExtendableButtonRemove(){
		$text = '';
		if(isset($this->sectionAttributes['buttonRemoveText'])){
			$text = trim($this->sectionAttributes['buttonRemoveText']);
		}
		if(isset($this->sectionAttributes['buttonRemoveClass'])){
			$class = trim($this->sectionAttributes['buttonRemoveClass']);
		}
		return '<button class="dpc-extendable-remove btn btn-xs btn-warning'.(strlen($class) ? ' '.esc_attr($class) : '').'">'.(strlen($text) ? esc_html($text) : '<i class="fa fa-minus"></i>').'</button>';
	}

	function initPossibleValues($field){
		$possibleValues = $this->getValuesBySource($field);

		if(is_array($field) || is_object($field)){
			foreach($field->children() as $child){
				$possibleValues[] = $this->replaceXmlAttributes($child);
			}
		}
		if(count($possibleValues)){
			$this->possibleValues = $possibleValues;
		} else {
			$this->possibleValues = null;
		}
	}

	function initChilds(){
		$field = $this->field;
		$childs = array();
		$this->childs = ($field ? $field : null);
	}



}