<?php

class DPC_Gui {

	var $dpc 				= null;
	var $module				= null;
	var $settings 			= null;
	var $defaults 			= null;
	var $field				= null;
	var $sectionAttributes 	= null;
	var $attributes 		= null;
	var $value 				= null;
	var $possibleValues		= null;
	var $childs				= null;
	var $isDraftLoop		= false;
	var $inLoop				= false;
	var $loopIndex			= 0;
	var $namespace			= array();
	var $namespaceLoopIndex	= array();
	var $vars				= array();

	function __construct(&$dpc){
		$this->dpc = $dpc;
	}

	function getInput($attributes){
		$this->attributes 	= $attributes;
		$this->field 		= $this->replaceXmlAttributes($this->field);
		$input = '';

		if(isset($this->attributes['debug']) && $this->attributes['debug'] == 'true'){
			echo "<pre>";
			print_r($this->field);
			echo "</pre>";
		}

		if((bool)$this->getAttr('hide', false)){
			return $this->getHide(true);
		}

		switch($this->getAttr('type')){
			case 'wrap':
				return $this->getWrap();
				break;
			case 'printMethod':
				return $this->printMethod();
				break;
			case 'wrapper':
				$this->getWrapper();
				break;
			case 'section':
				$this->getSection();
				break;
			case 'collection':
				$this->getCollection();
				break;
			case 'tabs':
				$this->getTabs();
				break;
			case 'selectall':
				return $this->getSelectAll();
				break;
			case 'wizard':
				return $this->getWizard();
				break;
			case 'dpcOption':
				$this->getDpcOption();
				break;
			case 'var':
				$this->setVar($this->field);
				break;
			case 'method':
				return $this->getMethod();
				break;
			case 'knob':
				return $this->getKnob();
				break;
			case 'donut':
				return $this->getDonut();
				break;
			case 'horizontalbar':
				return $this->getHorizontalBar();
				break;
			case 'each':
				$this->getEach();
				break;
			case 'heading':
				return $this->getHeading();
				break;
			case "modal":
				return $this->getModal();
				break;
			case 'image':
				return $this->getImage();
				break;
			case 'iframe':
				return $this->getIFrame();
				break;
			//Table
			case 'table':
				return $this->getTable();
				break;
			case 'th':
				return $this->getTh();
				break;
			case 'td':
				return $this->getTd();
				break;
			case 'tr':
				return $this->getTr();
				break;
			case 'trStart':
				return $this->getTrStart();
				break;
			case 'trEnd':
				return $this->getTrEnd();
				break;
			case 'thead':
				return $this->getThead();
				break;
			case 'tbody':
				return $this->getTbody();
				break;
			case 'tfoot':
				return $this->getTfoot();
				break;
			case 'tdStart':
				return $this->getTdStart();
				break;
			case 'tdEnd':
				return $this->getTdEnd();
				break;
			case 'trNext':
				return $this->getTrNext();
				break;
			// Table END
			case 'hidden':
				return $this->getHidden();
				break;
			case 'postAction':
				return $this->getPostAction();
				break;
			case 'button':
				return $this->getButton();
				break;
			case 'simplebutton':
				return $this->getSimpleButton();
				break;
			case 'fab':
				return $this->getFabButton();
				break;
			case 'deleteButton':
				return $this->getDeleteButton();
				break;
			case 'toggleButton':
				return $this->getToggleButton();
				break;
			case 'hide':
				return $this->getHide();
				break;
			case 'text':
				return $this->getText();
				break;
			case 'number':
				return $this->getNumber();
				break;
			case 'spinner':
				return $this->getSpinner();
				break;
			case 'sortable':
				return $this->getSortable();
				break;
			case 'colorpicker':
				return $this->getColorpicker();
				break;
			case 'timepicker':
				return $this->getTimepicker();
				break;
			case 'datepicker':
				return $this->getDatepicker();
				break;
			case 'copycode':
				return $this->getCopyCode();
				break;
			case 'checkbox':
				return $this->getCheckbox();
				break;
			case 'radio':
				return $this->getRadio();
				break;
			case 'multiRadio':
				return $this->getMultiRadio();
				break;
			case 'radioSwitch':
				return $this->getRadioSwitch();
				break;
			case 'select':
				return $this->getSelect();
				break;
			case 'selectImg':
				return $this->getSelectImg();
				break;
			case 'selectToggle':
				return $this->getSelectToggle();
				break;
			case 'textarea':
				return $this->getTextarea();
				break;
			case 'html':
				return $this->getHtml();
				break;
			case 'debug':
				return $this->debug();
				break;
			case 'mediaUploader':
				return $this->getMediaUploader();
				break;
			case 'file':
				return $this->getFile();
				break;
			case 'status':
				return $this->getStatus();
				break;
			case 'taglist':
				return $this->getTaglist();
				break;
			case 'htmlelement':
				return $this->getHtmlElements();
				break;
			case 'hinweis':
				return $this->getHinweis();
				break;
			case 'alert':
				return $this->getAlert();
				break;
			case 'paragraph':
				return $this->getParagraph();
				break;
			case 'label':
			    return $this->getLabel();
			    break;
			case 'icon':
				return $this->getIcon();
				break;
			case 'link':
				return $this->getLink();
				break;
			case 'info':
				return $this->getInfo();
				break;
			case 'if':
				return $this->getIf();
			case 'form':
				return $this->getForm();
		}
		return $input;
	}

	function resetProperties(){
		$this->module	 	= null;
		$this->settings 	= null;
		$this->value 		= null;
		$this->attributes 	= null;
	}

	function printMethod(){
		$module = $this->dpc->getModuleInstance($this->getAttr('module'));
		$method = (string)$this->getAttr('method');
		$params = $this->getAttr('params', null);

		if(is_object($module)){
			if(method_exists($module, $method)){
				$params = (is_null($params) ? array() : $params);
				return call_user_func_array(array($module, $method), $params);
			}
		}
	}

	function getValuesBySource($field){
		$field 	= $this->replaceXmlAttributes($field);
		$values = array();

		if(isset($field['source'])){
			$sourceArray = explode(':', $field['source']);
			switch($sourceArray[0]){
				case '@method':
					$isModule 		= (count($sourceArray) == 3) ? true : false;
					$isSubModule 	= (count($sourceArray) == 4) ? true : false;

					if($isSubModule){
						$values = $this->dpc->triggerModuleMethod($sourceArray[1].'_'.$sourceArray[2], $sourceArray[3], strlen($field['sourceParams']) ? explode('|', $field['sourceParams']) : null);
					} elseif($isModule){
						$values = $this->dpc->triggerModuleMethod($sourceArray[1], $sourceArray[2], strlen($field['sourceParams']) ? explode('|', $field['sourceParams']) : null);
					}
					break;
				case '@function':
					if($this->dpc->oFunctions == null){
						require_once('functions.php');
						$this->dpc->oFunctions = new DPC_Functions($this->dpc);
					}
					if(is_object($this->dpc->oFunctions)){
						if(method_exists($this->dpc->oFunctions, $sourceArray[1])){
							$values = call_user_func_array(array($this->dpc->oFunctions, $sourceArray[1]), strlen($field['sourceParams']) ? (array)$field['sourceParams'] : array());
							#$values = call_user_method($sourceArray[1], $this->dpc->oFunctions, strlen($field['sourceParams']) ? explode('|', $field['sourceParams']) : null);
						}
					}
					break;
				case '@list':
				    if(strlen($field['sourceParams'])){
				        $values = explode(',', $field['sourceParams']);
				    }
				    break;
			}
		}

		return $values;
	}

	function setVar($field){
		$field 	= $this->replaceXmlAttributes($field);

		if(isset($field['value'])){
			$sourceArray = explode(':', $field['value']);
			switch($sourceArray[0]){
				case '@method':
					$isModule 		= (count($sourceArray) == 3) ? true : false;
					$isSubModule 	= (count($sourceArray) == 4) ? true : false;

					if($isSubModule){
						$this->vars[(string)$field['key']] = $this->dpc->triggerModuleMethod($sourceArray[1].'_'.$sourceArray[2], $sourceArray[3], strlen($field['params']) ? explode('|', $field['params']) : null);
					} elseif($isModule){
						$this->vars[(string)$field['key']] = $this->dpc->triggerModuleMethod($sourceArray[1], $sourceArray[2], strlen($field['params']) ? explode('|', $field['params']) : null);
					} else {
					    break;
					}
					break;
				case '@function':
					if($this->dpc->oFunctions == null){
						require_once('functions.php');
						$this->dpc->oFunctions = new DPC_Functions($this->dpc);
					}
					if(is_object($this->dpc->oFunctions)){
						if(method_exists($this->dpc->oFunctions, $sourceArray[1])){
							$this->vars[(string)$field['key']] = call_user_func_array(array($this->dpc->oFunctions, $sourceArray[1]), strlen($field['params']) ? explode('|', $field['params']) : array());
						}
					}
					break;
			}
		}
	}

	function getValueRecursive($array, $parts = array()){
		if(count($parts)){
			$currentElement = array_shift($parts);
			if(isset($array[$currentElement])){
				if(is_array($array[$currentElement])){
					if(count($parts)){
						return $this->getValueRecursive($array[$currentElement], $parts);
					}
					return $array[$currentElement];
				} else {

					return $array[$currentElement];
				}
			}
		}
	}
	
	/**
	 * 
	 * Bar colors:
	 * danger, warning, success
	 */
	function getHorizontalBar(){
		
		if($this->getAttr('mode') == 'min_max'){
			$max 	= (int)$this->getAttr('max');
			$value	= (int)$this->getValue();

			$percentage 		= ($value > 0 ? ($value/$max)*100 : $value);
			$display_value 	= ($this->getAttr('displayValue') ? $this->getAttr('displayValue') : $value . ' / ' . $max);
		}else{
			$percentage 		= $this->getValue();
			$display_value 	= $this->getAttr('displayValue');
		}

		$output  = '<div class="dpc-bar-wrapper '. esc_attr($this->getAttr('class')) .'">';
		$output .= '		<div class="dpc-bar-label">';
		$output .= '			<span class="dpc-bar-label-text">'. esc_attr($this->getAttr('text')) .'</span>';
		$output .= '			<span class="dpc-bar-label-value">'. $display_value . '</span>';
		$output .= '		</div>';
		$output .= '		<div class="dpc-bar"><span class="dpc-bar-background success" style="width: '. $percentage .'%"></span></div>';
		$output .= '	</div>';	

		return $output;
	}
	
	function getValue(){
		if($this->getAttr('forceValue', false)){
			return $this->value;
		}

		$realname = (string) $this->getAttr('realname');
		if(strlen($realname)){
			return get_option($realname);
		}

		if($this->getAttr('postMeta', false)){
			global $post;
			$attributeName = (string)$this->attributes['name'];
			if(strpos($attributeName, '[') !== false){
				$attributeName = substr($attributeName, 0, strpos($attributeName, '['));
				$attributeParts = trim(str_replace($attributeName, '', (string)$this->attributes['name']), '[]');
				$attributeParts = explode('][', $attributeParts);
				$valueArray = get_post_meta($post->ID,'_' .$attributeName,true);
				$this->value = $this->getValueRecursive($valueArray, $attributeParts);
				return $this->value;
			} elseif(is_object($post) && property_exists($post, 'ID')) {
			    return get_post_meta($post->ID, '_' .(string)$this->getName(), true);
			} elseif(is_int($this->dpc->currentId)) {
			    return get_post_meta($this->dpc->currentId, '_' . (string)$this->getName(), true);
			}
		}

		$attributeName = (string)$this->attributes['name'];
		if(strpos($attributeName, '][') !== false){
			$this->value = $this->getValueRecursive($this->settings, explode('][', $attributeName));
		}

		if($this->inLoop != true){
			if(isset($this->settings[$attributeName])){
				return $this->settings[$attributeName];
			} elseif($this->getAttr('type') == "checkbox" && !count($this->settings)){
				return '';
			} else {
				return (!is_array($this->value) ? (string)$this->value : $this->value);
			}
		} elseif($this->isDraftLoop == false){
			if(isset($this->settings[(string)$this->sectionAttributes['name']][$this->loopIndex][$attributeName])){
				return $this->settings[(string)$this->sectionAttributes['name']][$this->loopIndex][$attributeName];
			} elseif($this->getAttr('type') == "checkbox" && isset($this->settings[(string)$this->sectionAttributes['name']])){
				return '';
			} else {
				return (!is_array($this->value) ? (string)$this->value : $this->value);
			}
		} else {
			return (!is_array($this->value) ? (string)$this->value : $this->value);
		}
	}

	function getAttr($key, $default = null){
		if(isset($this->attributes[$key])){
			return $this->attributes[$key];
		}
		if($default !== null){
			return $default;
		}
	}

	function getHtmlAttr($skip = array()){
		$htmlAttr = '';
		$attr = $this->attributes;
		if(isset($attr['addToDom'])){
			foreach(explode(',', $attr['addToDom']) as $useAttr){
				if(isset($attr[$useAttr]) && !in_array($useAttr, $skip)){
					$htmlAttr .= ' ' . $useAttr . '="' . $attr[$useAttr] .  '"';
				}
			}
		}
		return '' . $htmlAttr;
	}

	function getName($name = false, $realname = false){
		if($this->getAttr('forceName', false) == 'true' || $this->getAttr('postMeta', false) == 'true'){
			return $this->getAttr('name');
		}

		$name 		= ($name ? $name : $this->getAttr('name'));
		$realname 	= ($realname ? $realname : $this->getAttr('realname'));
		if($realname){
			return 'dpc[realnames][' . $realname . ']';
		}

		if($this->inLoop == true){
			return 'dpc[' . $this->module . '][' . $this->sectionAttributes['name'] . '][' . $this->loopIndex . '][' . $name . ']';
		} else {
			return 'dpc[' . $this->module . '][' . $name . ']';
		}
	}

	function getWrap(){
		$html = '';
		$this->initChilds();
		$html .= '<div'.($this->getAttr('id', false) ? ' id="'.esc_attr($this->getAttr('id')).'"' : '' ).' class="'.($this->getAttr('hasWrap', 'yes') == 'yes' ? 'haswrap' : '').' '.(strlen($this->getAttr('width')) ? 'dpc-col dpc-col-'.esc_attr($this->getAttr('width')).'-12' : '').($this->getAttr('class', false) ? ' '.esc_attr($this->getAttr('class')) : '').'" '.esc_attr($this->getAttr('data-toggle')).' '.$this->getHtmlAttr().'>';
		if($this->childs !== null){
			$html .= $this->showFields($this->childs, true);
		}

		$html .= '</div>';
		return $html;
	}

	function getWrapper(){
		$this->initChilds();
		echo '<div'.($this->getAttr('id', false) ? ' id="'.esc_attr($this->getAttr('id')).'"' : '' ).' class="'.($this->getAttr('hasWrap', 'yes') == 'yes' ? 'haswrap' : '').' '.(strlen($this->getAttr('width')) ? 'dpc-col dpc-col-'.esc_attr($this->getAttr('width')).'-12' : '').($this->getAttr('class', false) ? ' '.esc_attr($this->getAttr('class')) : '').'" '.esc_attr($this->getAttr('data-toggle')).' '.$this->getHtmlAttr().'>';
		if($this->childs !== null){
			$this->showFields($this->childs);
		}
		echo '</div>';
	}

	function getDpcOption(){
		$this->initChilds();
		echo '<div '.($this->getAttr('id', false) ? ' id="'.esc_attr($this->getAttr('id')).'"' : '' ).' class="jumbotron dpc-option '.esc_attr($this->getAttr('class')).' '.esc_attr($this->getAttr('name')).' " '.$this->getHtmlAttr().'>';
		if($this->childs !== null){
			$this->showFields($this->childs);
		}
		echo '</div>';
	}

	function getMethod(){
		if(!$this->getAttr('module') || !$this->getAttr('function')){
			return false;
		}

		if(!is_null($params = $this->getAttr('params', null))){
			$params = explode(',', $params);
		}

		return $this->dpc->triggerModuleMethod((string)$this->getAttr('module'), (string)$this->getAttr('function'), $params);
	}

	function getDonut(){
		echo 	'<div class="chart-donut">
					<div id="donut"></div>
				</div>
				';
		echo '<script>
		jQuery(document).ready(function($) {
			Morris.Donut({
			  element: "donut",
			  data: [
			    {label: "'.esc_attr(__('Warnings', 'delucks-seo')).'", value: '.esc_js($this->dpc->log->count('warning')).'},
			    {label: "'.esc_attr(__('Optimal', 'delucks-seo')).'", value: '.esc_js($this->dpc->log->getOptimus(true)).'},
			    {label: "'.esc_attr(__('Errors', 'delucks-seo')).'", value: '.esc_js($this->dpc->log->count('error')).'}
			  ],
			  resize: true,
			  colors: [
				"#EAB631",
				"#60B660",
				"#E44D42"
			   ],
			   backgroundColor: "#2F3033",
			   labelColor: "'.($this->dpc->oLicense->products['suite']['status'] == true ? '#efefef' : '#2F3033').'",
			   width: "140px"
			});
		});
	</script>';
	}

	function getIf(){
		$this->initChilds();
		if($this->childs !== null){
			$success	= false;
			$condition	= (string)trim($this->getAttr('condition'));
			$operator	= (string)trim($this->getAttr('operator'));
			$value		= (string)trim($this->getAttr('value'));
			if(strlen($operator)){
				switch($operator){
					case '==':
						if($condition == $value){
							$success = true;
						}
						break;
					case '!=':
						if($condition != $value){
							$success = true;
						}
						break;
				}
			}

			if($success == true){
				$this->showFields($this->childs);
			}
		}
	}

	function getForm(){
	    echo '<form name="'. esc_attr($this->getAttr('name')) .'" method="'. esc_attr($this->getAttr('method')) .'"' . ($this->getAttr('action', false) ? ' action="'.esc_attr($this->getAttr('action')).'"' : '') . ' '.$this->getHtmlAttr().'/>';
		$this->initChilds();
		if($this->childs !== null){
			$this->showFields($this->childs);
		}
		echo '</form>';
	}

	function getCollection(){
		$this->initChilds();
		echo '<div class="collection'.($this->getAttr('class', false) ? ' '.esc_attr($this->getAttr('class')) : '').'" '.$this->getHtmlAttr().'>';

		$newChilds = array();
		if($this->childs !== null){
			$ci = 0;

			if($this->getValue()){
				foreach($this->childs as $child){
					$vi = 0;
					foreach($this->getValue() as $vk => $vv){
						if(strpos($child['name'], $vk) !== false){
							$newChilds[$vi] = $child;
							$vi++;
							break;
						}
						$vi++;
					}
					$ci++;
				}

				ksort($newChilds);
				$this->showFields($newChilds);
			} else {
				$this->showFields($this->childs);
			}
		}
		echo '</div>';
	}

	function replaceXmlAttributes($xmlObject, $data = array(), $type = false){
		if($type){
			if(method_exists($xmlObject->{$type}, 'count')){
				for($i=0; $i<$xmlObject->{$type}->count(); $i++){
					foreach($xmlObject->{$type}[$i]->attributes() as $ak => $av){
						if(preg_match_all('/\{(@LANG|@TEXT):(.*)\}/Ui', $av, $matches)){
							$xmlObject[$ak] = (string)str_replace($matches[0][0], $this->dpc->getText($matches[2][0]), $av);
						} elseif(preg_match_all('/\{@VAR:(.*)\}/Ui', $av, $matches)){
							$parts 		= explode('|', $matches[1][0]);
							if(count($parts) && isset($this->vars[$parts[0]])){
								$xmlObject[$ak] = (string)str_replace($matches[0][0], $this->vars[$parts[0]], $av);
							}
						} elseif(preg_match_all('/\{@META:(.*)\}/Ui', $av, $matches)){
							$metaKey = $matches[1][0];
							$postId = $this->dpc->currentPost->ID;
							if(!is_int($postId) || !strlen($metaKey)){
								break(1);
							}

							$xmlObject[$ak] = (string)str_replace($matches[0][0], get_post_meta($postId, $metaKey, true), $av);
						} elseif(preg_match_all('/\{@OPTION:(.*)\}/Ui', $av, $matches)){
							$parts	= explode('|', $matches[1][0]);
							$module	= $parts[0];
							$option	= $parts[1];

							$settings = $this->dpc->getModuleSettings($module);
							if(isset($settings) && isset($settings[$option])){
								$xmlObject[$ak] = (string)str_replace($matches[0][0], $settings[$option], $av);
							}
						} elseif (preg_match_all('/\{@NS:(.*)\}/Ui', $av, $matches)){
							$parts 		= explode('|', $matches[1][0]);
							$namespace 	= array_shift($parts);
							$key	 	= array_shift($parts);
							if(isset($this->namespace[$namespace]) && isset($this->namespace[$namespace][$this->namespaceLoopIndex[$namespace]])){
								$xmlObject[$ak] = (string)str_replace($matches[0][0], $this->namespace[$namespace][$this->namespaceLoopIndex[$namespace]][$key], $av);
							}
						} elseif (preg_match_all('/\{(.*)\}/U', $av, $matches)){
							foreach($matches[1] as $mk => $mv){
								if(key_exists($mv, $data)){
									$string		=	(string)$xmlObject->{$type}[$i]->attributes()->$ak;
									$search		=	(string)$matches[0][$mk];
									$replace	=	(string)$data[$mv];
									$newString	=	(string)str_replace($search, $replace, $string);
									$xmlObject->{$type}[$i][$ak] = $newString;
								}
							}
						}
					}
				}
			}
		} else {
			foreach($xmlObject->attributes() as $ak => $av){
				if(preg_match_all('/\{(@LANG|@TEXT):(.*)\}/Ui', $av, $matches)){
					$xmlObject[$ak] = (string)str_replace($matches[0][0], $this->dpc->getText($matches[2][0]), $av);
				} elseif(preg_match_all('/\{@VAR:(.*)\}/Ui', $av, $matches)){
					$parts 		= explode('|', $matches[1][0]);
					if(count($parts) && isset($this->vars[$parts[0]])){
						$xmlObject[$ak] = (string)str_replace($matches[0][0], $this->vars[$parts[0]], $av);
					}
				} elseif(preg_match_all('/\{@META:(.*)\}/Ui', $av, $matches)){
					$metaKey = $matches[1][0];
					$postId = $this->dpc->currentPost->ID;
					if(!is_int($postId) || !strlen($metaKey)){
						break(1);
					}

					$xmlObject[$ak] = (string)str_replace($matches[0][0], get_post_meta($postId, $metaKey, true), $av);
				} elseif(preg_match_all('/\{@OPTION:(.*)\}/Ui', $av, $matches)){
					$parts	= explode('|', $matches[1][0]);
					$module	= $parts[0];
					$option	= $parts[1];

					$settings = $this->dpc->getModuleSettings($module);
					if(isset($settings) && isset($settings[$option])){
						$xmlObject[$ak] = (string)str_replace($matches[0][0], $settings[$option], $av);
					}
				} elseif (preg_match_all('/\{@NS:(.*)\}/Ui', $av, $matches)){
					$parts 		= explode('|', $matches[1][0]);
					$namespace 	= array_shift($parts);
					$key	 	= array_shift($parts);
					if(isset($this->namespace[$namespace]) && isset($this->namespace[$namespace][$this->namespaceLoopIndex[$namespace]])){
						$xmlObject[$ak] = (string)str_replace($matches[0][0], (isset($this->namespace[$namespace][$this->namespaceLoopIndex[$namespace]][$key]) ? $this->namespace[$namespace][$this->namespaceLoopIndex[$namespace]][$key] : ''), $av);
					}
				} elseif(preg_match_all('/\{(.*)\}/U', $av, $matches)){
					foreach($matches[1] as $mk => $mv){
						if(key_exists($mv, $data)){
							$string		=	(string)$xmlObject->attributes()->$ak;
							$search		=	(string)$matches[0][$mk];
							$replace	=	(string)$data[$mv];
							$newString	=	(string)str_replace($search, $replace, $string);
							$xmlObject[$ak] = $newString;
						}
					}
				}
			}
		}
		return $xmlObject;
	}

	function getEach(){
		$this->initChilds();
		$loopFields = $this->childs;
		$source 	= $this->getValuesBySource($this->field);

		$namespace	= false;
		if($this->getAttr('namespace', false) !== false){
			$namespace = (string)$this->getAttr('namespace');
			$this->namespace[$namespace] = $source;
		}
		if($loopFields !== null && count($source)){
			if(is_array($source)){
				foreach($source as $sk => $sv){
					if($namespace !== false){
						$this->namespaceLoopIndex[$namespace] = $sk;
					}
					$childFields = new SimpleXMLElement($loopFields->asXML());
					$childFields = $this->replaceXmlAttributes($childFields, $sv, 'option');
					$this->showFields($childFields);
				}
			}
		}
	}

	function getSection($section = '', $file = false){
		$section = (strlen($section) ? $section : (string)$this->getAttr('section'));

		if(!$file){
			if($this->getAttr('file', false)){
				$file = DPC_PLUGIN_MODULES_DIR . (string)$this->getAttr('file');
			}
		}

		if(!strlen($section)){
			return '';
		}

		$this->dpc->new_parseSettingsByXml(($file ? $file : $this->dpc->lastSettingsFile), $section, $this->getAttr('inEach', false), ($this->getAttr('skipWrapper', false) ? true : false));
	}

	function getTabs(){
		$this->initChilds();
		if($this->childs !== null){
		    echo '<ul class="nav nav-tabs dpc-tabs" role="tablist" id="tab_'.esc_attr($this->module).'">';
			$i = 0;
			foreach($this->childs as $tab){
				echo '<li '.($i == 0 ? 'class="active"' : '').'>';
				echo '	<a href="#tab-'. esc_attr($this->module) .'_'.esc_attr(str_replace(array(' '), array('_'), $tab['title'])).'" role="tab" data-toggle="tab">'.esc_html($tab['title']).'</a>';
				echo '</li>';
			$i++;
			}
			echo '</ul>';

			echo '<div class="tab-content">';
			$i = 0;
			foreach($this->childs as $tab){
			    echo '<div class="tab-pane '.($i == 0 ? 'active' : '').'" id="tab-'. esc_attr($this->module) .'_'.esc_attr(str_replace(array(' '), array('_'), $tab['title'])).'">';
				$this->showFields($tab->children());
				echo '</div>';
				$i++;
			}
			echo '</div>';
		}
	}

	function getSelectAll(){

	}

	function getWizard(){

	}

	function getStatus(){

	}

	function sectionStart($class = '', $skipRowClass = false){
		if($this->sectionAttributes['hasWrap'] != 'yes'){
		    return '<div class="'.($this->sectionAttributes['several'] == 'yes' ? '' : 'dpc-section dpc-group').'" '.($this->sectionAttributes['hide'] == 'true' ? ' style="display:none"' : '').'><div class="'.($this->sectionAttributes['several'] == 'yes' ? '' : '').' dpc-section '.esc_attr($this->module) . ' ' . esc_attr($this->sectionAttributes['name']).' ' . esc_attr($class) .' '. esc_attr($this->sectionAttributes['class']).'" data-toggle="'. esc_attr($this->sectionAttributes['data-toggle']).'" '.$this->getHtmlAttr().'>';
		}else{
		    return '<div class="'.($skipRowClass ? '' : 'dpc-section ').'dpc-group '.esc_attr($this->module) . ' ' . esc_attr($this->sectionAttributes['name']).' ' . esc_attr($class) .' '. esc_attr($this->sectionAttributes['class']).'" data-toggle="'. esc_attr($this->sectionAttributes['data-toggle']).'" '.$this->getHtmlAttr().'>';
		}
	}

	function sectionClose(){
		if($this->sectionAttributes['hasWrap'] != 'yes'){
			return '</div></div>';
		}else{
			return '</div>';
		}
	}

	function formButtons(){

	}

	function formStart($name='', $upload = false){
	    return '<div class="row"><div class="col-md-12"><form method="post"'.(strlen($name) ? ' name="'.esc_attr($name).'"' : '').($upload ? ' enctype="multipart/form-data"' : '').'><input type="hidden" name="dpc_save_settings" />'.wp_nonce_field('dpc_save_settings', 'dpc_save_settings_nonce');
	}

	function formClose($submit = false){
	    return $submit ? '<input type="button" class="dpc-submit dpc-submit-settings-footer btn btn-save" value="'.esc_attr(__('Save', 'delucks-seo')).'" />' : '' . '</form></div></div>';
	}

	function topMenu(){

	}

	function getTooltip(){

	}

	function getHeading(){
		$input  = '<h'.$this->getAttr('size').' '.$this->getHtmlAttr().'>';
		$input .= $this->getAttr('value');
		$input .= '</h'.$this->getAttr('size').'>';

		return $input;
	}

	function getTable(){
		$this->initChilds();
		$rows	= $this->getAttr('rows');

		if($this->childs !== null){
		    echo '<table class="haswrap '.(strlen($this->getAttr('width')) ? 'dpc-col dpc-col-'.esc_attr($this->getAttr('width')).'-12' : '').' '.esc_attr($this->getAttr('class')).'" '.esc_attr($this->getAttr('data-toggle')).' '.$this->getHtmlAttr().'>';
			$this->showFields($this->field->children());
			echo '</table>';
		}
	}

	function getTr(){
		if($this->childs !== null){
			echo '<tr '.$this->getHtmlAttr().'>';
			$this->showFields($this->field->children());
			echo '</tr>';
		}
	}

	function getTd(){
		echo '<td '.$this->getHtmlAttr().'>';
		echo esc_html($this->getAttr('label'));
		$this->showFields($this->field->children());
		echo '</td>';
	}

	function getThead(){
		if($this->childs !== null){
			echo '<thead '.$this->getHtmlAttr().'>';
			$this->showFields($this->field->children());
			echo '</thead>';
		}
	}

	function getTbody(){
		if($this->childs !== null){
			echo '<tbody '.$this->getHtmlAttr().'>';
			$this->showFields($this->field->children());
			echo '</tbody>';
		}
	}

	function getTfoot(){
		if($this->childs !== null){
			echo '<tfoot '.$this->getHtmlAttr().'>';
			$this->showFields($this->field->children());
			echo '</tfoot>';
		}
	}

	function getTrStart(){
		echo '<tr '.$this->getHtmlAttr().'>';
	}

	function getTrEnd(){
		echo '</tr>';
	}

	function getTrNext(){
		echo '</tr><tr '.$this->getHtmlAttr().'>';
	}

	function getTdStart(){
		echo '<td '.$this->getHtmlAttr().'>';
	}

	function getTdEnd(){
		echo '</td>';
	}

	function getTh(){
		echo '<th '.$this->getHtmlAttr().'>';
		echo esc_html($this->getAttr('label'));
		echo '</th>';
	}

	function getHidden(){
	    return '<input type="hidden" name="'.esc_attr($this->getName()).'" value="'.esc_attr($this->value).'" '.$this->getHtmlAttr().'/>';
	}

	function getPostAction(){
	    return '<input type="hidden" name="dpcActions['.esc_attr($this->getAttr('module')).']" value="'.esc_attr($this->getAttr('action')).'" />';
	}

	function getFabButton(){

	}

	/**
	 * getButton()
	 *
	 * available colors: button-default, button-primary, button-secondary, button-tertiary
	 * available sizes: button-small, button-medium, button-large
	 */
	function getButton(){
	    return '<button name="'.esc_attr($this->getName()).'" value="'.esc_attr($this->value).'" '.$this->getHtmlAttr().'> '.esc_html($this->getAttr('label')).' </button>';
	}


	/**
	 * getSimpleButton()
	 *
	 * available colors: button-default, button-primary, button-secondary, button-tertiary
	 * available sizes: button-small, button-medium, button-large
	 *
	 * possibility to add FA icons via attribute "icon-class"
	 */
	function getSimpleButton(){
	    return '<a href="'.esc_url($this->getAttr('href')).'" '.$this->getHtmlAttr().'>'.(strlen($this->getAttr('icon-class')) ? '<i class=" '.esc_attr($this->getAttr('icon-class')).'"></i>' : '').' '.esc_html($this->getAttr('label')).' </a>';
	}

	function getToggleButton(){
	    return '<button type="button" name="'.esc_attr($this->getName()).'" '.$this->getHtmlAttr().'><i id="toggle-icon" class="fa fa-'.(strlen($this->getAttr('icon-class')) ? esc_attr($this->getAttr('icon-class')) : 'plus').'"></i></button>';
	}

	function getDeleteButton(){
	    return '<div class="btn btn-danger btn-delete pull-right '.esc_attr($this->getAttr('class')).'" '.$this->getHtmlAttr().'><i class="row-option-elem del-row fa fa-trash-o"></i> <span class="del-option" style="display:none;"><a href="#" class="delete">'.esc_html__('delete', 'delucks-seo').'</a></span><div>';
	}

	function getHide($onElement = false){
		$valueSet 		= (isset($this->settings[(string)$this->getAttr('displayElement')]) ? $this->settings[(string)$this->getAttr('displayElement')] : '');
		$valueRequired 	= $this->getAttr('displayValue');

		echo '<div style="display:';
		if(isset($this->settings[(string)$this->getAttr('displayElement')]) && (is_array($this->settings[(string)$this->getAttr('displayElement')]) && in_array($valueRequired, $this->settings[(string)$this->getAttr('displayElement')])) || $valueSet == $valueRequired){
		    echo esc_attr($this->getAttr('displayType', 'inline-block'));
		}else {
			echo 'none';
		}
		echo ';" class="hideControls '.esc_attr($this->getAttr('class')).'" id="'.esc_attr($this->getAttr('id')).'" data-display-element="'.esc_attr($this->getName($this->getAttr('displayElement'))).'" '.($this->getAttr('displayValue', false) ? 'data-display-value="'.esc_attr($this->getAttr('displayValue')).'"' : '').'  '.($this->getAttr('displaySearchValue', false) ? 'data-display-searchvalue="'.esc_attr($this->getAttr('displaySearchValue')).'"' : '').' data-display-type="'.esc_attr($this->getAttr('displayType')).'" '.$this->getHtmlAttr().'>';
		if($onElement){
			unset($this->attributes['hide']); //unset hide attribute to avoid endless loop
			echo $this->getInput($this->field);
		} else {
			$this->showFields($this->field->children());
		}
		echo '</div>';
	}

	function getNumber(){

	}

	function getSpinner(){

	}

	function getSortable(){

	}

	function getColorpicker(){

	}

	function getTimepicker(){

	}

	function getDatepicker(){
	    wp_enqueue_script('jquery-ui-datepicker');
	    #wp_enqueue_script('bootstrap-datepicker', plugins_url( 'assets/bootstrap-datepicker/js/bootstrap-datepicker.js', DPC_FILE), array('jquery'), NULL, true);
	    #wp_enqueue_style('bootstrap-datepicker', plugins_url( 'assets/bootstrap-datepicker/css/bootstrap-datepicker.css', DPC_FILE));

	    $input  =	'<div class="form-group dpc-has-datepicker" style="max-width: 185px;">';
	    $input .=		'<div class="input-group date">';
	    $input .=			'<span class="input-group-addon"><span class="fa fa-calendar"></span></span>';
	    $input .= 			'<input type="text" name="'.esc_attr($this->getName()).'" class="form-control dpc-datepicker" placeholder="'.esc_attr($this->getAttr('placeholder')).'" value="'.esc_attr($this->getValue()).'" '.$this->getHtmlAttr(array('value', 'placeholder', 'icon')).'/>';
	    $input .=			(strlen($this->getAttr('description')) ? '<span class="time-description">'.esc_html($this->getAttr('description')).'</span>' : '');
	    $input .=	'	</div>';
	    $input .=	'</div>';

	    $input .= '<script>jQuery(document).ready(function() {jQuery( ".dpc-datepicker" ).datepicker( { dateFormat: \'dd/mm/yy\' } ); });</script>';

	    return $input;
	}

	function getCopyCode(){

	}

	function getTaglist(){

	}

	/**
	 * getHtmlElements()
	 *
	 * available HTML elements:
	 * hr, br, border, span, div_start & div_end, clear, custom
	 *
	 * except for br & div_end, every element accepts custom HTML attributes
	 *
	 */
	function getHtmlElements(){
		switch($this->getAttr('element')){
			case 'hr':
				return '<div class="clear"></div><hr '.$this->getHtmlAttr().'/>';
				break;
			case 'br':
				return '<br/>';
				break;
			case 'border':
			    return '<div class="'.esc_attr($this->getAttr('class')).'" '.$this->getHtmlAttr().'></div>';
				break;
			case 'span':
			    return '<span '.$this->getHtmlAttr().'>'.esc_html($this->getAttr('text')).'</span>';
				break;
			case 'span':
			    return '<a '.$this->getHtmlAttr().'>'.esc_html($this->getAttr('text')).'</a>';
				break;
			case 'div_start':
				return '<div '.$this->getHtmlAttr().'>';
				break;
			case 'div_end':
				return '</div>';
				break;
			case 'clear':
			    return '<div class="clear" '.esc_attr($this->getHtmlAttr()).'></div>';
				break;
			case 'custom':
			    return '<'.esc_attr($this->getAttr('tag')).' '.$this->getHtmlAttr().'>'.esc_html($this->getAttr('text')).'</'.esc_attr($this->getAttr('tag')).'>';
		}


	}

	function getHinweis(){

	}

	function getInfo(){

	}

	function getAlert(){

	}

	function getParagraph(){
		$input  = '<p '.$this->getHtmlAttr().'>';
		$input .= esc_html($this->getAttr('value'));
		$input .= '</p>';

		return $input;
	}

	function getLabel(){
	    $input  = '<l '.$this->getHtmlAttr().'>';
	    $input .= esc_html($this->getAttr('value'));
	    $input .= '</l>';

	    return $input;
	}

	function getIcon(){

		$input = '<i '.$this->getHtmlAttr().'></i>';

		return $input;
	}

	function getLink(){
		$input  = '';
		$input .= (strlen($this->getAttr('text-before')) ? '<p class="text-before">'.esc_html($this->getAttr('text-before')).'' : '');
		$input .= '<a target="'.esc_attr($this->getAttr('target')).'" href="'.esc_url($this->getAttr('link')).'" '.$this->getHtmlAttr().'>';
		if(strlen($this->getAttr('icon-class'))){
		    $input .= '<i class="'.esc_attr($this->getAttr('icon-class')).'">'.(strlen($this->getAttr('icon-text')) ? esc_html($this->getAttr('icon-text')) : '').'</i>';
		}
		$input .= esc_html($this->getAttr('text')).'</a>';
		$input .= (strlen($this->getAttr('text-before')) ? '</p>' : '');

		return $input;
	}

	function getModal(){
	    $input  = '<div class="modal fade dpc-modal '.esc_attr($this->getAttr('class')).'" data-triggerBy="'.esc_attr($this->getAttr('triggerBy')).'" id="'.esc_attr($this->getAttr('target')).'" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">';
		//Head
  		$input .= '		<div class="modal-dialog">
  							<div class="modal-content">';
		$input .= ' 			<div class="modal-header">';
        $input .= '					<button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span></button>';
        $input .= '					<h4 class="modal-title" id="myModalLabel">'.(strlen($this->getAttr('icon-class', '')) ? '<i class="fa fa-'.esc_attr($this->getAttr('icon-class')).'"></i> ' : '').esc_html($this->getAttr('title')).'</h4>
        						</div>';
        //Head End - Body Start
     	$input .= '				<div class="modal-body">';
								 	if($this->field->children !== null){
										$field 	= $this->field;
										$attributes = $this->attributes;
								        $input .= $this->showFields($this->field->children(), true);
										$this->field = $field;
										$this->attributes 	= $attributes;
								    }
        $input .= '					<p>'.esc_html($this->getAttr('content')).'</p>'.(strlen($this->getAttr('extra-content')) ? '<p class="'.esc_attr($this->getAttr('extra-content-type')).'">'.esc_html($this->getAttr('extra-content')).'</p>' : '');
      	$input .= '				</div>';
		//Body End - Footer Start
      	$input .= '				<div class="modal-footer">';
      	$input .= 					$this->getAttr('abort', false) !== false ? '<button type="button" class="btn btn-danger pull-left" data-dismiss="modal">'.esc_html($this->getAttr('abort')).'</button>' : '';
      	$input .= 					$this->getAttr('continue', false) !== false ? '<button type="button" class="btn btn-success pull-right">'.esc_html($this->getAttr('continue')).'</button>' : '';
		//Modal End
      	$input .= '				</div>
      						</div>
      					</div>
      				</div>';


		return $input;
	}

	function getImage(){

	}

	function getIFrame(){

	}

	function getCheckbox(){
		$input  = '';
		$input .= '	<div class="form-field '.esc_attr(str_replace(array('[',']'), "", $this->getName())).'">';
		$input .= '		<label for="'.esc_attr($this->getName()).'">';
		$input .= '			<input name="'.esc_attr($this->getName()).'" id="'.esc_attr(str_replace(array('[',']'), "_", $this->getName())).'" '.($this->getValue() == 'on' ? ' checked="checked"' : '').' type="checkbox">';
		$input .= 			(strlen($this->getAttr('label','')) ? esc_html($this->getAttr('label','')) : '');
		$input .= '		</label>';
		$input .= '	</div>';

		return $input;
	}

	function getRadio(){

	}

	function getRadioSwitch(){

	}

	function getSelect(){
	    $input  = '	<div class="form-field '.esc_attr(str_replace(array('[',']'), "", $this->getName())).'">
						'.(strlen($this->getAttr('label','')) ? '<label for="'.esc_attr($this->getName()).'">'.esc_html($this->getAttr('label','')).'</label>' : '');

	    $input  .= '	<select id="'.esc_attr($this->getName()). '" name="'.esc_attr($this->getName()).($this->getAttr('multiple') == 'multiple' ? '[]' : '').'" '.$this->getHtmlAttr().($this->getAttr('fullheight') == 'true' ? ' size="'.count($this->possibleValues).'"' : '' ).'>';
						if(is_array($this->possibleValues)){
							foreach($this->possibleValues as $val){
								$selected = false;
								if($this->getAttr('multiple') == 'multiple'){
									$selected = (is_array($this->getValue()) && in_array($val['value'], $this->getValue()) ? true : false);
								} else {
									$selected = (($val['value'] == $this->getValue() || (string)$val['value'] == (string)$this->getAttr('value', false)) ? true : false);
								}
								$input .= '<option value="'.esc_attr($val['value']).'"'.($selected ? ' selected="selected"' : '').'>'.esc_html($val['label']).'</option>';
							}
						}
		$input .= '		</select>';
		$input .= 	(strlen($this->getAttr('description','')) ? '<p>'.esc_html($this->getAttr('description','')).'</p>' : '');
		$input .= '	</div>';

		return $input;
	}

	function getSelectImg(){

	}

	function getselectToggle(){

	}

	function getInlineInput(){
	    $input = '	<span class="dpc-edit '.esc_attr(str_replace(array('[',']'), "", $this->getName())).'"
							data-input-type="'.(strlen( $this->getAttr('data-input-type','') ) ? esc_attr($this->getAttr('data-input-type','')) : '').'

							'.(strlen( $this->getAttr('data-default','') ) ? 'data-default="'.esc_attr($this->getAttr('data-default','')).'" ' : '').'
							'.(strlen( $this->getAttr('data-has-addition','') ) ? 'data-has-addition="'.esc_attr($this->getAttr('data-has-addition','')).'" ' : '').'
							'.(strlen( $this->getAttr('data-save','') ) ? 'data-save="'.esc_attr($this->getAttr('data-save','')).'" ' : '').'
							'.(strlen( $this->getAttr('data-max-length','') ) ? 'data-max-length="'.esc_attr($this->getAttr('data-max-length','')).'" ' : '').'
							'.(strlen( $this->getAttr('data-pixel-length','') ) ? 'data-pixel-length="'.esc_attr($this->getAttr('data-pixel-length','')).'" ' : '').'
							'.(strlen( $this->getAttr('data-pixel-length-alert','') ) ? 'data-pixel-length-alert="'.esc_attr($this->getAttr('data-pixel-length-alert','')).'" ' : '').'
							'.(strlen( $this->getAttr('data-pixel-length-danger','') ) ? 'data-pixel-length-danger="'.esc_attr($this->getAttr('data-pixel-length-danger','')).'" ' : '').'
							'.(strlen( $this->getAttr('data-extra-text','') ) ? 'data-extra-text="'.esc_attr($this->getAttr('data-extra-text','')).'" ' : '').'
							'.(strlen( $this->getAttr('data-prevtext','') ) ? 'data-prevtext="'.esc_attr($this->getAttr('data-prevtext','')).'" ' : '').'


							data-has-addition="true"
							data-save="post_title"
							data-max-length="70"
							data-pixel-length="true"
							data-pixel-length-alert="64"
							data-pixel-length-danger="70"
							data-extra-text="'. esc_attr(__('. Integrate focus keyword!', 'delucks-seo')).'"
							data-prevtext="'.esc_attr($title).'">
						'.$meta_title.'
					</span>';

		#return $input;
	}

	function getText(){
		$valLeng 	= strlen( ($this->getValue() != '' ? $this->getValue() : $this->getAttr('placeholder','')) );
		$alert		= '';
		if($this->getAttr('has-counter','') == 'true'){
			$percentage	= $valLeng / $this->getAttr('data-maximum','');

			switch ($percentage) {
				case $percentage >= 0.75 && $percentage <= 0.99:
					$alert = 'data-status="alert"';
					break;
				case $percentage >= 1.00:
					$alert = 'data-status="danger"';
					break;
				default:
					$alert = 'data-status="green"';
					break;
			}
		}



		$input  = '	<div class="form-field '.esc_attr(str_replace(array('[',']'), "", $this->getName())).' '.($this->getAttr('inline-edit','') == 'true' ? 'dpc-inline-editable-DISABLED' : '').' '.($this->getAttr('has-counter','') == 'true' ? 'dpc-input-counter' : '').'" data-type="input">
						'.(strlen($this->getAttr('label','')) ? '<label for="'.esc_attr($this->getName()).'">'.esc_html($this->getAttr('label','')).'</label>' : '').'
						<input '.$alert.' type="text" id="'.esc_attr($this->getName()).'" name="'.esc_attr($this->getName()).'" '.$this->getHtmlAttr().' value="'.esc_attr($this->getValue()).'" '.(strlen($this->getAttr('placeholder','')) ? 'placeholder="'.esc_attr($this->getAttr('placeholder','')).'"' : '').' />
						'.(strlen($this->getAttr('description','')) ? '<p>'.esc_html($this->getAttr('description','')).'</p>' : '').'
						'.($this->getAttr('has-counter','') == 'true' ? '<span class="input-counter-wrapper"> <span class="current-count">'.esc_html($valLeng).'</span> / <span class="maximum-count">max. '.esc_html($this->getAttr('data-maximum','')).'</span></span>' : '').'
					</div>';


		return $input;
	}

	function getTextarea(){
		$valLeng 	= strlen( ($this->getValue() != '' ? $this->getValue() : $this->getAttr('placeholder','')) );
		$alert		= '';
		if($this->getAttr('has-counter','') == 'true'){
			$percentage	= $valLeng / $this->getAttr('data-maximum','');

			switch ($percentage) {
				case $percentage >= 0.75 && $percentage <= 0.99:
					$alert = 'data-status="alert"';
					break;
				case $percentage >= 1.00:
					$alert = 'data-status="danger"';
					break;
				default:
					$alert = 'data-status="green"';
					break;
			}
		}

		$input = '	<div class="form-field '.esc_attr(str_replace(array('[',']'), "", $this->getName())).' '.($this->getAttr('inline-edit','') == 'true' ? 'dpc-inline-editable-DISABLED' : '').' '.($this->getAttr('has-counter','') == 'true' ? 'dpc-input-counter' : '').'" data-type="textarea">
						'.(strlen($this->getAttr('label','')) ? '<label for="'.esc_attr($this->getName()).'">'.esc_html($this->getAttr('label','')).'</label>' : '').'
						<textarea '.$alert.' id="'.esc_attr($this->getName()).'" name="'.esc_attr($this->getName()).'" '.$this->getHtmlAttr().' rows="5" cols="40" style="min-height:125px;" '.(strlen($this->getAttr('placeholder','')) ? 'placeholder="'.esc_attr($this->getAttr('placeholder','')).'"' : '').'>'.esc_html($this->getValue()).'</textarea>
						'.(strlen($this->getAttr('description','')) ? '<p>'.esc_html($this->getAttr('description','')).'</p>' : '').'
						'.($this->getAttr('has-counter','') == 'true' ? '<span class="input-counter-wrapper"> <span class="current-count">'.esc_html($valLeng).'</span> / <span class="maximum-count">max. '.esc_html($this->getAttr('data-maximum','')).'</span></span>' : '').'
					</div>';

		return $input;
	}

	function getHtml(){
		echo "<pre>";
		print_r($this->field);
		echo "</pre>";
		return '';
	}

	function debug(){
		echo "<pre>";
		print_r($this->field);
		echo "</pre>";
		return '';
	}

	function getMediaUploader(){
		$id = $this->dpc->currentId;

		$input  = '<div class="form-field" data-type="media-input">
						<label for="'.esc_attr($this->getName()).'">'.esc_html($this->getAttr('label')).'</label>';
		$input .= '		<div class="dpc-fileinput fileinput-new '.($this->getAttr('alt-input') == 'true' ? 'has-alt-input" data-input-id="'.esc_attr($this->getAttr('alt-input-id')).'"' : '"').'>';
		$input .= '			<div class="dpc-input-thumbnail" style="width: '.esc_attr($this->getAttr('width')).'; height: '.esc_attr($this->getAttr('height')).';">';

		if( $this->getAttr('usePostImageDefault') == 'true' && !strlen($this->getValue()) ){
			if(has_post_thumbnail($id)){
			    $input .=	'<img class="dpc-file-holder" src="'.esc_url(get_the_post_thumbnail_url($id)).'" />';
			}else{
			    $input .=	'<img class="dpc-file-holder" src="'.(strlen($this->getValue()) ? esc_url($this->getValue()) : '').'" alt="'.esc_attr(__('Nothing selected', 'delucks-seo')).'" '.(strlen($this->getValue()) ? '' : 'style="display:none;"').'/>
									<span style="display: block;position: relative;color: red;padding: 70px 0;">'.esc_html__('Automatic', 'delucks-seo').'</span>';
			}
		}else{
		    $input .= '				'. (strlen($this->getValue()) ? '<img class="dpc-file-holder" src="'.esc_url($this->getValue()).'" />' : '<span style="display: block;position: relative;color: red;padding: 70px 0;">'.esc_html__('Automatic', 'delucks-seo').'</span>' ) ;
		}

		$input .= '			</div>';
		$input .= '			<div class="dpc-media-uploader">
								<a href="#" class="btn btn-default btn-file dpc-file-upload-button" data-name="'.esc_attr($this->getAttr('id')).'" data-frame-title="'.esc_attr($this->getAttr('frame-title')).'">'.esc_html__('Select', 'delucks-seo').'</a>
								<a href="#" class="btn btn-default btn-file upload-dpc-file" data-name="'.esc_attr($this->getAttr('id')).'" data-frame-title="'.esc_attr($this->getAttr('frame-title')).'">'.esc_html__('Change', 'delucks-seo').'</a>
								<a href="#" class="btn btn-danger remove-dpc-file" data-name="'.esc_attr($this->getAttr('id')).'">'.esc_html__('Remove', 'delucks-seo').'</a>';
		if($this->getAttr('alt-input') != 'true'){
		    $input .= ' <input type="text" name="'.esc_attr($this->getName()).'" class="dpc-fileinput-input" id="'.esc_attr($this->getAttr('id')).'" value="'.(strlen($this->getValue()) ? esc_attr($this->getValue()) : '').'"/>';
		}
		$input .= '			</div>
						</div>
					</div>';

		return $input;
	}

	function getFile(){

	}

	function showFields($fields = null, $return = false){
		if($fields == null){ return false; }
		$return_fields = '';
		foreach($fields as $field){
			$this->initPossibleValues($field);
			$this->field 	= $field;
			$attr 			= $field->attributes();
			$this->value	= $attr->value;
			if($return !== false){
				$return_fields .= $this->getInput($field->attributes());
			} else {
				echo $this->getInput($field->attributes());
			}
		}

		if($return !== false){
			return $return_fields;
		}

	}

	function showSection($fields = null, $addAnchor = false, $skipWrapper = false){
		if(isset($this->sectionAttributes['bootstrap']) && $this->sectionAttributes['bootstrap'] == true){
			#wp_enqueue_script('bootstrap', plugins_url( 'assets/bootstrap/js/bootstrap.min.js', DPC_FILE ), array('jquery'), NULL, true);
			#wp_enqueue_script('dpc', plugins_url( 'assets/dpc/js/functions.js', DPC_FILE ), array('jquery'), NULL, true);
		}
		if(isset($this->sectionAttributes['css']) && $this->sectionAttributes['css'] == true){
			wp_enqueue_style('dpc-edit-css', plugins_url( 'assets/dpc/css/edit.min.css', DPC_FILE ));
			wp_enqueue_style('dpc-css', plugins_url( 'assets/dpc/css/style.css', DPC_FILE ));
			#wp_enqueue_style('dpc-css-additional', plugins_url( 'assets/dpc/css/style_additional.css', DPC_FILE ));
			wp_enqueue_style('dpc-responsive', plugins_url( 'assets/dpc/css/style-responsive.css', DPC_FILE ));
			wp_enqueue_style('dpc-font-awesome', plugins_url( 'assets/font-awesome/css/font-awesome.min.css', DPC_FILE ));
		}


		if($fields == null){ return false; }
		if(isset($this->sectionAttributes['extendable']) && $this->sectionAttributes['extendable'] == true){
			#unset($this->sectionAttributes['extendable']);
			$this->inLoop = true;
			$sectionName = (string)$this->sectionAttributes['name'];
			/* DRAFT: start */
			if($skipWrapper == false || $this->getAttr('skipWrapper', false)){
				echo $this->sectionStart('dpc-draft extendable', $this->sectionAttributes['skipRowClass']);
			}
			echo $this->getExtendableButtonRemove();
			$this->isDraftLoop = true;
			foreach($fields as $field){
				$this->initPossibleValues($field);
				$this->field 	= $field;
				$attr 			= $field->attributes();
				$this->value	= $attr->value;
				echo $this->getInput($field->attributes());
			}
			$this->isDraftLoop = false;
			if(!$skipWrapper){
				echo $this->sectionClose();
			}
			/* DRAFT: end */

			if(isset($this->settings[$sectionName]) && is_array($this->settings[$sectionName]) && count($this->settings[$sectionName])){
				foreach($this->settings[$sectionName] as $k => $v){
					if($skipWrapper == false || $this->getAttr('skipWrapper', false)){
						echo $this->sectionStart('extendable', $this->sectionAttributes['skipRowClass']);
					}
					echo $this->getExtendableButtonRemove();
					foreach($fields as $field){
						$this->initPossibleValues($field);
						$this->field 	= $field;
						$attr 			= $field->attributes();
						$this->value	= $attr->value;
						echo $this->getInput($field->attributes());
					}
					if($skipWrapper == false || $this->getAttr('skipWrapper', false)){
						echo $this->sectionClose();
					}
					$this->loopIndex++;
				}
			}

			echo $this->getExtendableButtonAdd();
			$this->loopIndex = 0;
			$this->inLoop = false;
		} else {
			if($skipWrapper == false || $this->getAttr('skipWrapper', false)){
				echo $this->sectionStart($this->getAttr('class'));
			}
			foreach($fields as $field){
				$this->initPossibleValues($field);
				$this->field 	= $field;
				$attr 			= $field->attributes();
				$this->value	= $attr->value;
				echo $this->getInput($field->attributes());
			}
			if($skipWrapper == false || $this->getAttr('skipWrapper', false)){
				echo $this->sectionClose();
			}
		}
	}

	function getExtendableButtonAdd(){
		if(isset($this->sectionAttributes['buttonAddClass'])){
			$class = trim($this->sectionAttributes['buttonAddClass']);
		}
		return '<button class="dpc-extendable-add btn-md btn btn-default btn-block '.(strlen($class) ? $class : '').'" data-container=".'. $this->module . '.' . $this->sectionAttributes['name'] .'.dpc-draft">'. $this->sectionAttributes['buttonAddText'] .'</button>';
	}

	function getExtendableButtonRemove(){
		$text = '';
		if(isset($this->sectionAttributes['buttonRemoveText'])){
			$text = trim($this->sectionAttributes['buttonRemoveText']);
		}
		if(isset($this->sectionAttributes['buttonRemoveClass'])){
			$class = trim($this->sectionAttributes['buttonRemoveClass']);
		}
		return '<button class="dpc-extendable-remove btn btn-xs btn-warning'.(strlen($class) ? ' '.$class : '').'">'.(strlen($text) ? $text : '<i class="fa fa-minus"></i>').'</button>';
	}

	function initPossibleValues($field){
		$possibleValues = $this->getValuesBySource($field);

		if(is_array($field) || is_object($field)){
			foreach($field->children() as $child){
				$possibleValues[] = $this->replaceXmlAttributes($child);
			}
		}
		if(count($possibleValues)){
			$this->possibleValues = $possibleValues;
		} else {
			$this->possibleValues = null;
		}
	}

	function initChilds(){
		$field = $this->field;
		$childs = array();
		$this->childs = ($field ? $field : null);
	}



}