<?php

class DPC_Helper_Placeholder {

    var $dpc            = null;
    var $placeholders   = array();
    var $currentId      = null;
    var $allowedOption  = array('admin_email', 'blogname', 'blogdescription', 'blog_charset', 'date_format', 'default_category', 'home', 'siteurl', 'template', 'start_of_week', 'upload_path', 'users_can_register', 'posts_per_page', 'posts_per_rss');
    var $allowedPost    = array('title', 'excerpt', 'permalink', 'thumbnail');
    var $allowedBloginfo= array('name', 'description', 'wpurl', 'url', 'admin_email', 'charset', 'version', 'html_type', 'text_direction', 'language', 'stylesheet_url', 'stylesheet_directory', 'template_url', 'pingback_url', 'atom_url', 'rdf_url', 'rss_url', 'rss2_url', 'comments_atom_url', 'comments_rss2_url');

    function __construct(&$dpc){
        $this->dpc = $dpc;
    }

    function replace($string, $id = false){
        $this->currentId = $id;
        if($id == false && $id = get_the_ID()){
            $this->currentId = $id;
        }

        #$string = preg_replace_callback('/%%(\w*)\.(\w[a-zA-Z0-9-]*)%%/im', array($this, 'replaceCallback'), $string);
        $string = preg_replace_callback('/%%(\w*)\.(\w[a-zA-Z0-9-]*)%%|%%(\w*)\.(\w[a-zA-Z0-9-]*)\.(\w[a-zA-Z0-9-.]*)%%/im', array($this, 'replaceCallback'), $string);
        return $string;
    }

    function replaceCallback($match){
        if(is_array($match) && !(count($match) < 3)){
            #echo "<pre>";
            #print_r($match);
            #echo "</pre>";

            if(isset($this->placeholders[$match[1]]) && isset($this->placeholders[$match[2]])){
                return $this->placeholders[$match[1]];
            }

            switch($match[1]){
                case 'post':
                    return $this->getPostData($match[2]);
                    break;
                case 'meta':
                    return $this->getPostMeta($match[2]);
                    break;
                case 'option':
                    return $this->getOption($match[2]);
                    break;
                case 'bloginfo':
                    return $this->getBloginfo($match[2]);
                    break;
                case 'config':
                    return $this->getConfig($match[2], $match[3]);
                    break;
                case 'lang':
                    return $this->getLang($match[2]);
                    break;
            }
        }
    }

    function getPostData($key){
        if(!$this->currentId){
            return;
        }

        if(in_array($key, $this->allowedPost)){
            switch($key){
                case 'title':
                    $value = get_the_title($this->currentId);
                    break;
                case 'excerpt':
                    $value = get_the_excerpt($this->currentId);
                    break;
                case 'permalink':
                    $value = get_permalink($this->currentId);
                    break;
                case 'thumbnail':
                    $value = get_the_post_thumbnail($this->currentId);
                    break;
            }

            $this->placeholders['post'][$key] = $value;
            return $value;
        }
    }
    function getPostMeta($key){
        if(!$this->currentId){
            return;
        }

        $value = get_post_meta($this->currentId, $key, true);
        $this->placeholders['option'][$key] = $value;
        return $value;
    }

    function getOption($key){
        if(in_array($key, $this->allowedOption)){
            $value = get_option($key);
            $this->placeholders['option'][$key] = $value;
            return $value;
        }
    }

    function getBloginfo($key){
        if(in_array($key, $this->allowedBloginfo)){
            $value = get_bloginfo($key);
            $this->placeholders['option'][$key] = $value;
            return $value;
        }
    }

    function getConfig($module, $key){  }
    function getLang($key){  }

}