<?php
// Creating the breadcrumb widget
	class DelucksBreadcrumbs extends WP_Widget {

		function __construct() {
			// Instantiate the parent object
		    parent::__construct('DelucksBreadcrumbs', esc_html__('Breadcrumbs', 'dpc'), array( 'description' => esc_html__('Navigation paths show your visitors and Google, where they are in your website.', 'delucks-seo' ) ));
		}

		public function widget( $args, $instance ) {
			global $plugin_dpc;

			echo $args['before_widget'];
			if ( ! empty( $instance['title'] ) ) {
				echo $args['before_title'] . apply_filters( 'widget_title', $instance['title'] ). $args['after_title'];
			}

			$module = $plugin_dpc->getModuleInstance('basic', 'breadcrumbs')->settings;;
			echo $plugin_dpc->getModuleInstance('basic', 'breadcrumbs')->the_breadcrumb();
			echo $args['after_widget'];
		}

		public function update( $new_instance, $old_instance ) {
			$instance = array();
			$instance['title'] = ( ! empty( $new_instance['title'] ) ) ? wp_strip_all_tags( $new_instance['title'] ) : '';
			return $instance;
		}

		public function form( $instance ) {
			$title = ! empty( $instance['title'] ) ? $instance['title'] : '';
		?>
			<p>
				<label for="<?php echo esc_attr($this->get_field_id('title')); ?>"><?php echo esc_html(__('Title:')); ?></label>
				<input class="widefat" id="<?php echo esc_attr($this->get_field_id('title')); ?>" name="<?php echo esc_attr($this->get_field_name('title')); ?>" type="text" value="<?php echo esc_attr($title); ?>">
			</p>
		<?php
		}




	}
?>