jQuery(document).ready(function($){
	"use strict";

	window.modalOnTabEnterCallbacks['tab-dpc-basic-metadata'] = [];
	window.modalOnTabEnterCallbacks['tab-dpc-basic-metadata'].push(function(){
		jQuery('.dpc-modal-footer-button').css('display', 'none');		
		jQuery('.dpc-modal-footer-button#dpc-seo-popover-content-ai').css('display', 'inline-block');
		jQuery('.dpc-modal-footer-button#dpc-seo-popover-content-keywords').css('display', 'inline-block');
		jQuery('.dpc-modal-footer-button#dpc-seo-popover-content-title').css('display', 'inline-block');
		jQuery('.dpc-modal-footer-button#dpc-seo-popover-content-description').css('display', 'inline-block');
		jQuery('.dpc-modal-footer-button#dpc-seo-popover-sistrix-button').css('display', 'inline-block');
		jQuery('.dpc-modal-footer-button#dpc-seo-popover-sistrix-sync-post-button').css('display', 'inline-block');
		jQuery('.dpc-modal-footer-button#dpc-seo-popover-check-in-google-button').css('display', 'inline-block');
	});


	window.modalBeforeSubmitCallbacks.push(function(arr, $form, options){
		var keywordList = new Array();
		$('#content-dpc-basic-metadata .keyword-list-wrapper .keyword-list-item:not(.primary) .keyword').each(function(index, element){
			if(!$(element).hasClass('primary')){
				keywordList.push($(element).text());
			}
		});

		arr.push({name: 'dpc-keyword-list', value: keywordList});
		arr.push({name: 'dpc-keyword-primary', value: $('#content-dpc-basic-metadata .keyword-list-wrapper .keyword-list-item.primary .keyword').text()});

		/* GSC keywords list */		
		var gscValueArrayNotPrimary = [];
		$('#content-dpc-basic-metadata .gsc-appended-keyword-list-wrapper .gsc-keyword-list-item:not(.primary)').each(function(index, element) {
			var keyword = $(element).find('.gsc-keyword').text();
			var ranking = $(element).find('.ranking').text();
			gscValueArrayNotPrimary.push({ keyword: keyword, ranking: ranking });
		});

		var jsonGscValueArrayNotPrimary = JSON.stringify(gscValueArrayNotPrimary);

		arr.push({name: 'dpc-gsc-keyword-list', value: jsonGscValueArrayNotPrimary});


		var gscValueArray = [];
		$('#content-dpc-basic-metadata .gsc-appended-keyword-list-wrapper .gsc-keyword-list-item.primary').each(function() {
			var keyword = $(this).find('.gsc-keyword').text();
			var ranking = $(this).find('.ranking').text();
			gscValueArray.push({ keyword: keyword, ranking: ranking });
		});

		var jsonGscValueArray = JSON.stringify(gscValueArray);

		arr.push({ name: "dpc-gsc-keyword-primary", value: jsonGscValueArray });


		/* Title */
		var defaultTitle = $('#content-dpc-basic-metadata #headline_serp .dpc-edit').attr('data-default');
		var prevTitle = $('#content-dpc-basic-metadata #headline_serp .dpc-edit').attr('data-prevtext');
		var newTitle = $('#dpc_post_title').text();
		if(newTitle == defaultTitle){ newTitle = ''; }
		if($('#dpc_post_title').attr('data-applicable') == 'true'){ arr.push({name: 'dpc-meta-title', value: newTitle }); }

		/* Description */
		var defaultDescription = $('#content-dpc-basic-metadata #description_serp.dpc-edit').attr('data-default');
		var newDescription = $('#dpc_post_description').text();
		if(newDescription == defaultDescription){ newDescription = ''; }
		if($('#dpc_post_description').attr('data-applicable') == 'true'){ arr.push({name: 'dpc-textopt-description', value: newDescription}); }
		
		/* Canonical */
		var defaultLink = $('#content-dpc-basic-metadata #canonical .dpc-edit').attr('data-default');
		var newLink = $('#dpc_post_canonical').text();
		if(newLink == defaultLink || newLink == $('#dpc_modal_data input[type="hidden"][name="dpc_permalink"]').val()){ newLink = ''; }
		if($('#dpc_post_canonical').attr('data-applicable') == 'true'){	arr.push({name: 'dpc-canonical', value: newLink});	}

		if($('#content-dpc-basic-metadata [name="dpc[basic_metadata][no_follow]"]').prop('checked')){
			arr.push({name: 'dpc-no_follow', value: 'on'});
		}

		if($('#content-dpc-basic-metadata [name="dpc[basic_metadata][no_index]"]').prop('checked')){
			arr.push({name: 'dpc-no_index', value: 'on'});
		}
		
		if($('#content-dpc-basic-metadata [name="dpc[basic_metadata][metaDescriptionAsExcerpt]"]').prop('checked')){
			arr.push({name: 'dpc-metaDescriptionAsExcerpt', value: 'on'});
		}
		
    });

	window.modalSuccessSubmitCallbacks.push(function(response, statusText, xhr, form, data){
		$('td.column-dpc-keyword', window.wpListTableEntry).html(data['dpc-keyword-primary'].value);
		if($('#dpc_post_description').attr('data-applicable') == 'true'){
			$('td.column-dpc-description', window.wpListTableEntry).html(data['dpc-textopt-description'].value);
		}
    });


	/****************************************************************************************************************/


	function calcWidth( elem, source){
		return $(elem).width();
	}

	function checkCustomKeywords(){
		if($('.keyword-list-item').length){
			setTimeout(function(){
				jQuery('.keyword-list-wrapper > .keyword-list-item > .keyword').each(function(){
					var keyword = jQuery(this).text().toLowerCase().trim();
					if(isTextInMetaDescription(keyword) || isTextInMetaTitle(keyword) || isTextInContent(keyword)){
						jQuery('.dashicons.icon', $(this).parent()).addClass('dashicons-yes').removeClass('dashicons-no').attr('title', dpc_basic_metadata_translator.keywordFound);
					} else {
						jQuery('.dashicons.icon', $(this).parent()).addClass('dashicons-no').removeClass('dashicons-yes').attr('title', dpc_basic_metadata_translator.keywordMissing);
					}
				});
			}, 1000);
		}
		/* GSC */
		if($('.gsc-keyword-list-item').length){
			setTimeout(function(){
				jQuery('.gsc-appended-keyword-list-wrapper > .gsc-keyword-list-item > .gsc-keyword').each(function(){
					var keyword = jQuery(this).text().toLowerCase().trim();
					if(isTextInMetaDescription(keyword) || isTextInMetaTitle(keyword) || isTextInContent(keyword)){
						jQuery('.dashicons.icon', $(this).parent()).addClass('dashicons-yes').removeClass('dashicons-no').attr('title', dpc_basic_metadata_translator.keywordFound);
					} else {
						jQuery('.dashicons.icon', $(this).parent()).addClass('dashicons-no').removeClass('dashicons-yes').attr('title', dpc_basic_metadata_translator.keywordMissing);
					}
				});
			}, 1000);
		}
	}


	function isTextInMetaDescription(text){
		var content = $('#description_serp').text().replace(/(\r\n|\n|\r)/gmi," ");
		if(content.toLowerCase().search(text.toLowerCase().trim()) > -1){
			return true;
		}
		return false;
	}

	function isTextInMetaTitle(text){
		var content = $('#headline_serp .dpc-edit').text().replace(/(\r\n|\n|\r)/gmi," ");
		if(content.toLowerCase().search(text.toLowerCase().trim()) > -1){
			return true;
		}
		return false;
	}

	function isTextInContent(text){
		var content = dpc_post_data.post_content.replace(/(\r\n|\n|\r)/gmi," ");
		if(content.toLowerCase().search(text.toLowerCase().trim()) > -1){
			return true;
		}
		return false;
	}


	/**
	 * Keyword autocomplete
	 */

	if (typeof dpc_basic_metadata_settings != 'undefined'){
		// Sistrix autocomplete
		$("#content-dpc-basic-metadata #dpc-keyword").autocomplete({
	        source: function(request, response) {
	            $.ajax( {
	                url: dpc_basic_metadata_suggest_callback,
	                dataType: "jsonp",
	                data: {
	                	hl		: dpc_lang, //"de", // Language
	                	q		: request.term, // query term
	                	client	: "youtube", // force youtube style response, i.e. jsonp
	                },
	                success: function( data ) {
		                var suggestions = [];
		                $.each(data[1], function(key, val) {
		                    suggestions.push({"value":val[0]});
		                });
		                if(suggestions.length){
		                	suggestions.length = 5; // prune suggestions list to only 10 items
		                	response(suggestions);
		                }
		                $('#content-dpc-basic-metadata #dpc-keyword').removeClass('ui-autocomplete-loading');
	                }
	            });
	        },
	        focus: function() {
	        	return false;	// prevent value inserted on focus
	        },
	        select: function( event, ui ) {
	        	if(typeof(ui.item.value) !== undefined){
	        		addNewKeyword(ui.item.value);
	        		$('#content-dpc-basic-metadata #dpc-keyword').val('');
	        	}
	        },
	        close: function( event, ui ) {
				if (!$("#content-dpc-basic-metadata #dpc-keyword").val()) {
					// Only reset the value if it is empty
					$('#content-dpc-basic-metadata #dpc-keyword').val('');
				}
	        }
	    });

		// Click event on #dpc-add-keyword
		$('#content-dpc-basic-metadata').on('click', '#dpc-add-keyword', function(ev) {
			ev.preventDefault();
			// var keyword = $("#content-dpc-basic-metadata #dpc-keyword").val();
			 addNewKeyword();
		});

		//GSC autocomple
		$("#content-dpc-basic-metadata #dpc-gsc-keyword").autocomplete({
	        source: function(request, response) {
	            $.ajax( {
	                url: dpc_basic_metadata_suggest_callback,
	                dataType: "jsonp",
	                data: {
	                	hl		: dpc_lang, //"de", // Language
	                	q		: request.term, // query term
	                	client	: "youtube", // force youtube style response, i.e. jsonp
	                },
	                success: function( data ) {
		                var suggestions = [];
		                $.each(data[1], function(key, val) {
		                    suggestions.push({"value":val[0]});
		                });
		                if(suggestions.length){
		                	suggestions.length = 5; // prune suggestions list to only 10 items
		                	response(suggestions);
		                }
		                $('#content-dpc-basic-metadata #dpc-gsc-keyword').removeClass('ui-autocomplete-loading');
	                }
	            });
	        },
	        focus: function() {
	        	return false;	// prevent value inserted on focus
	        },
	        select: function( event, ui ) {
	        	if(typeof(ui.item.value) !== undefined){
					gscAddNewKeyword(ui.item.value, "0");
	        		$('#content-dpc-basic-metadata #dpc-gsc-keyword').val('');
	        	}
	        },
	        close: function( event, ui ) {
				if (!$("#content-dpc-basic-metadata #dpc-gsc-keyword").val()) {
					// Only reset the value if it is empty
					$("#content-dpc-basic-metadata #dpc-gsc-keyword").val("");
				}
	        }
	    });

		// Click event on #dpc-gsc-add-keyword
		$('#content-dpc-basic-metadata').on('click', '#dpc-gsc-add-keyword', function(ev) {
			ev.preventDefault();
			var keyword = $("#content-dpc-basic-metadata #dpc-gsc-keyword").val();
			var ranking = "0";
			gscAddNewKeyword(keyword, ranking);
		});

	}

	function addContextMenu(){
		jQuery.contextMenu({
	        selector: '#content-dpc-basic-metadata .keyword-list-item',
	        trigger: 'left',
	        callback: function(key, options) {
	            if(key == 'primary'){
	            	jQuery('#content-dpc-basic-metadata .keyword-list-item').removeClass('primary');
	            	jQuery(this).addClass('primary');
	            	var focusKeyword = jQuery(this).text().trim();
	    			$('#content-dpc-basic-metadata #dpc_googlesearch_preview .focus-keyword-preview').text(focusKeyword);
	            	return 'context-menu-icon context-menu-icon-quit';
	            }else if(key == 'delete'){
	            	jQuery(this).remove();
	            	if(jQuery('#content-dpc-basic-metadata .keyword-list-wrapper .keyword-list-item.primary').length == 0){
						var focusKeyword = false;
		    			$('#content-dpc-basic-metadata #dpc_googlesearch_preview .focus-keyword-preview').text('');
		    		}
		    		return 'context-menu-icon context-menu-icon-quit';
	            }
	        },
	        items: {
	            "primary": {name: dpc_basic_metadata_translator.setAsPrimary, icon: "edit"},
	            "delete": {name: dpc_basic_metadata_translator.remove, icon: "delete"}
	        }
	    });
	}
	
	function gscAddContextMenu(){
		jQuery.contextMenu({
	        selector: '#content-dpc-basic-metadata .gsc-appended-keyword-list-wrapper .gsc-keyword-list-item',
	        trigger: 'left',
	        callback: function(key, options) {
	            if(key == 'primary'){
	            	jQuery('#content-dpc-basic-metadata .gsc-keyword-list-item').removeClass('primary');
	            	jQuery(this).addClass('primary');
	            	var focusKeyword = jQuery(this).text().trim();
	    			$('#content-dpc-basic-metadata #dpc_googlesearch_preview .focus-keyword-preview').text(focusKeyword);
	            	return 'context-menu-icon context-menu-icon-quit';
	            }else if(key == 'delete'){
	            	jQuery(this).remove();
	            	if(jQuery('#content-dpc-basic-metadata .gsc-appended-keyword-list-wrapper .gsc-keyword-list-item.primary').length == 0){
						var focusKeyword = false;
		    			$('#content-dpc-basic-metadata #dpc_googlesearch_preview .focus-keyword-preview').text('');
		    		}
		    		return 'context-menu-icon context-menu-icon-quit';
	            }
	        },
	        items: {
	            "primary": {name: dpc_basic_metadata_translator.setAsPrimary, icon: "edit"},
	            "delete": {name: dpc_basic_metadata_translator.remove, icon: "delete"}
	        }
	    });
	}

	$('#content-dpc-basic-metadata .keyword-list-item').on('click', function(){
		addContextMenu();
	});

	$('#content-dpc-basic-metadata .gsc-appended-keyword-list-wrapper .gsc-keyword-list-item').on('click', function(){
		gscAddContextMenu();
	});

    $("#content-dpc-basic-metadata #dpc-keyword").keypress(function(ev){
	    if(ev.keyCode == 13){
	    	ev.preventDefault();
	        $("#content-dpc-basic-metadata #dpc-add-keyword").click();
	    }
	});

    $('#content-dpc-basic-metadata #dpc-add-keyword').bind('click', function(ev){
    		ev.preventDefault();
    		addNewKeyword();
    });

	/* GSC keypress and binding methods */
    $("#content-dpc-basic-metadata #dpc-gsc-keyword").keypress(function(ev){
	    if(ev.keyCode == 13){
	    	ev.preventDefault();
	        $("#content-dpc-basic-metadata #dpc-gsc-add-keyword").click();
	    }
	});

    $('#content-dpc-basic-metadata #dpc-gsc-add-keyword').bind('click', function(ev){
    		ev.preventDefault();
			var keyword = $("#dpc-gsc-keyword").val();
			var ranking = "0";
			gscAddNewKeyword(keyword, ranking);
    });

	function addNewKeyword(keyword = false){
		var primary = false;

		if($('#content-dpc-basic-metadata .keyword-list-wrapper .keyword-list-item').length == 0){
			primary = true;
		}

		if($('#content-dpc-basic-metadata #dpc-keyword').val() != '' && !keyword){
	    		$.each($('#content-dpc-basic-metadata #dpc-keyword').val().split(','), function( index, value ) {
	    			//var content = '	<span class="keyword-list-item'+ (primary ? ' primary' : '') +'" data-keyword="'+value+'"><span class="keyword">'+value+'</span><span class="ranking"><span class="ranking_count"></span><span class="ranking_trend"></span></span><span class="status-icon icon dashicons dashicons-no" title="' + dpc_basic_metadata_translator.keywordMissing + '"></span></span>';
	    			var content = '	<span class="keyword-list-item'+ (primary ? ' primary' : '') +'" data-keyword="'+value+'"><span class="keyword">'+value+'</span><span class="status-icon icon dashicons dashicons-no" title="' + dpc_basic_metadata_translator.keywordMissing + '"></span></span>';
	
	    			$('#content-dpc-basic-metadata .keyword-list-wrapper').append(content);
		    		if(primary){
		    			var focusKeyword = $('#content-dpc-basic-metadata .keyword-list-item.primary').text().trim();
		    			$('#content-dpc-basic-metadata #dpc_googlesearch_preview .focus-keyword-preview').text(focusKeyword);
		    		}
		    		primary = false;
	    		});
	    		$('#content-dpc-basic-metadata #dpc-keyword').val('');
    		}else if(keyword){
    			//var content = '	<span class="keyword-list-item'+ (primary ? ' primary' : '') +'" data-keyword="'+keyword+'"><span class="keyword">'+keyword+'</span><span class="ranking"><span class="ranking_count"></span><span class="ranking_trend"></span></span><span class="status-icon icon dashicons dashicons-no" title="' + dpc_basic_metadata_translator.keywordMissing + '"></span></span>';
	    		var content = '	<span class="keyword-list-item'+ (primary ? ' primary' : '') +'" data-keyword="'+keyword+'"><span class="keyword">'+keyword+'</span><span class="status-icon icon dashicons dashicons-no" title="' + dpc_basic_metadata_translator.keywordMissing + '"></span></span>';
			
			$('#content-dpc-basic-metadata .keyword-list-wrapper').append(content);
	    		if(primary){
	    			var focusKeyword = $('#content-dpc-basic-metadata .keyword-list-item.primary').text().trim();
	    			$('#content-dpc-basic-metadata #dpc_googlesearch_preview .focus-keyword-preview').text(focusKeyword);
	    		}
	    		$('#content-dpc-basic-metadata #dpc-keyword').val('');
    		}

		addContextMenu();
		checkCustomKeywords();
	}

	$(".gsc-keyword-list-wrapper .gsc-keyword-list-item.primary").click(function () {
		var keyword = $(this).attr("data-keyword");
		var ranking = $(this).attr("data-ranking");
		gscAddNewKeyword(keyword, ranking);
	});

	function gscAddNewKeyword(keyword, ranking) {
		var keywordElement = $(".gsc-keyword-list-item.primary");
		// var keyword = keywordElement.attr("data-keyword");

		var primary = false;

		if ($("#content-dpc-basic-metadata .gsc-appended-keyword-list-wrapper .gsc-keyword-list-item").length === 0) {
			primary = true;
		}

		if($('#content-dpc-basic-metadata #dpc-gsc-keyword').val() != '' && !keyword){
			$.each($('#content-dpc-basic-metadata #dpc-gsc-keyword').val().split(','), function( index, value ) {
				var content = ' <span class="gsc-keyword-list-item' + (primary ? " primary" : "") + '" data-keyword="' + keyword + '"><span class="gsc-keyword">' + keyword + '</span><span class="ranking dpc-ranking" title="GSC - ' + keyword + '"><span class="dots-loader"><span class="dot dot-one"></span><span class="dot dot-two"></span><span class="dot dot-three"></span><span class="dot dot-four"></span></span><span class="ranking_count">' + ranking + '</span></span><span class="status-icon icon dashicons dashicons-no" title="' + dpc_basic_metadata_translator.keywordMissing + '"></span></span>';

				$('#content-dpc-basic-metadata .gsc-appended-keyword-list-wrapper').append(content);
				if(primary){
					var focusKeyword = $('#content-dpc-basic-metadata .gsc-keyword-list-item.primary').text().trim();
					$('#content-dpc-basic-metadata #dpc_googlesearch_preview .focus-keyword-preview').text(focusKeyword);
				}
				primary = false;
			});
			$('#content-dpc-basic-metadata #dpc-gsc-keyword').val('');
		}else if(keyword){
			var content = ' <span class="gsc-keyword-list-item' + (primary ? " primary" : "") + '" data-keyword="' + keyword + '"><span class="gsc-keyword">' + keyword + '</span><span class="ranking dpc-ranking" title="GSC - ' + keyword + '"><span class="dots-loader"><span class="dot dot-one"></span><span class="dot dot-two"></span><span class="dot dot-three"></span><span class="dot dot-four"></span></span><span class="ranking_count">' + ranking + '</span></span><span class="status-icon icon dashicons dashicons-no" title="' + dpc_basic_metadata_translator.keywordMissing + '"></span></span>';
		
		$('#content-dpc-basic-metadata .gsc-appended-keyword-list-wrapper').append(content);
			if(primary){
				var focusKeyword = $('#content-dpc-basic-metadata .gsc-keyword-list-item.primary').text().trim();
				$('#content-dpc-basic-metadata #dpc_googlesearch_preview .focus-keyword-preview').text(focusKeyword);
			}
			$('#content-dpc-basic-metadata #dpc-gsc-keyword').val('');
		}

		gscAddContextMenu();
		checkCustomKeywords();
	}

	/**
	 *inline edit
	 */
	$('#content-dpc-basic-metadata #headline_serp .dpc-edit').inlineEdit({
		reverseCounter: false,
        showCounter: true,
        defaultText: true,
        inputType: 'input',
        onFocus: function (val) {
        		$(this).parents().closest('div').addClass('dpc-editing');
        		return;
        },
        onUpdate: function (val) {
        	$(this).parents().closest('div').removeClass('dpc-editing');
        	$('#dpc_post_title').attr('data-applicable', 'true').text(val);
        	if(val.trim() == ''){
        		$('#content-dpc-basic-metadata #headline_serp .dpc-edit').text( $(this).attr('data-default') );
        		$('#dpc_post_title').text( $(this).attr('data-default') );
        	}

			checkCustomKeywords();
        }
    });
    
    $('#content-dpc-basic-metadata #canonical .dpc-edit').inlineEdit({
		reverseCounter: false,
        showCounter: false,
        defaultText: true,
        inputType: 'input',
        onFocus: function (val) {
        		$(this).parents().closest('div').addClass('dpc-editing');
        		return;
        },
        onUpdate: function (val) {
        		$(this).parents().closest('div').removeClass('dpc-editing');
        		$('#dpc_post_canonical').attr('data-applicable', 'true').text(val);
	        
	        	if(val.trim() == ''){
	        		$('#content-dpc-basic-metadata #canonical .dpc-edit').text( $(this).attr('data-default') );
	        		$('#dpc_post_canonical').text( $(this).attr('data-default') );
	        	}

        }
    });
	
    
	var prevDesc = $('#content-dpc-basic-metadata #description_serp.dpc-edit').text();
    $('#content-dpc-basic-metadata #description_serp.dpc-edit').inlineEdit({
		reverseCounter: true,
        showCounter: true,
        defaultText: true,
        inputType: 'input',
        onFocus: function (val) {
        	$(this).parents().closest('div').addClass('dpc-editing');
        	return;
        },
        onUpdate: function (val) {
        	$(this).parents().closest('div').removeClass('dpc-editing');
        	$('#dpc_post_description').attr('data-applicable', 'true').text(val);

        	if(val.trim() == '' && $(this).attr('data-default') != ''){
        		$('#content-dpc-basic-metadata #description_serp.dpc-edit').text( $(this).attr('data-default') );
        		$('#dpc_post_description').text( $(this).attr('data-default') );
        	}else if(val.trim() == '' && $(this).attr('data-default') == ''){
        		$('#content-dpc-basic-metadata #description_serp.dpc-edit').text( $(this).attr('data-fallback') );
        		$('#dpc_post_description').text( $(this).attr('data-fallback') );
        	}
        	checkCustomKeywords();
        }
    });


	/**
	 * Google preview
	 */
	$('#dpc_seotitle').bind('keyup', function(ev){
		var previewHeadline		= $('#headline_serp > span'),
			val					= $(this).val(),
			widthCounter		= $('#dpc_title_width'),
			letterCounter		= $('#dpc_title_count');

		$('#headline_serp > span').text(val);
		letterCounter();
	});

	$('#dpc_seodescription').bind('keyup', function(ev){
		$('#description_serp').text($(this).val());
	});

    checkCustomKeywords();

});