if(typeof(dpc_basic_metadata_settings) != 'undefined'){
	jQuery(document).ready(function($){
		"use strict";

		$('.title-wrap').each(function(){
			jQuery(this).find('.counter').before('<strong class="input-length green"></strong>');
			countInputTitleLength();

			$(this).find('input[type^="text"]').each(function(){
				$(this).keyup(function(){ countInputTitleLength(); });
			})
		});

		$('.description-wrap').each(function(){
			jQuery(this).find('.desc-counter').before('<strong class="input-length green"></strong>');
			countInputDescLength();

			$(this).find('.desc').each(function(){
				$(this).keyup(function(){ countInputDescLength(); });
			})
		});

		$('[name^="dpc[basic_metadata][titleLimit]"]').multiselect({
			onChange: function(option, checked) {
				var selectedTitleLength = $('[name^="dpc[basic_metadata][titleLimit]"] option:selected');
				dpc_basic_metadata_config.maxTitleLength = selectedTitleLength.val();
				countInputTitleLength();
			}
		});
		$('[name^="dpc[basic_metadata][descLimit]"]').multiselect({
			onChange: function(option, checked) {
				var selectedDescLength = $('[name^="dpc[basic_metadata][descLimit]"] option:selected');
				dpc_basic_metadata_config.maxDescLength = selectedDescLength.val();
				countInputDescLength();
			}
		});
	});

	function countInputTitleLength(){
		jQuery('.title-wrap').each(function($){
			var homeTitle		= jQuery(this).find('.home-title').val().length,
				divider			= jQuery(this).find('.divider').val().length,
				websiteTitle	= jQuery(this).find('.website-title').val().length,
				inputLength		= homeTitle+divider+websiteTitle;
				diff			= dpc_basic_metadata_config.maxTitleLength-inputLength;


			jQuery(this).find('.input-length').html(inputLength);
			/*
			if(diff < '1'){
				jQuery(this).find('.green').css('color','red');
			}else if(diff < '20'){
				jQuery(this).find('.green').css('color','orange');
			}else{
				jQuery(this).find('.green').css('color', '');
			}
			*/
			if(inputLength >= 30 && inputLength <= 65){
				jQuery(this).find('.green').css('color', '');
			} else {
				jQuery(this).find('.green').css('color','red');
			}


		});
	}
	function countInputDescLength(){
		jQuery('.description-wrap').each(function($){
			var descLength	= jQuery(this).find('textarea.desc').val().length,
				diff		= dpc_basic_metadata_config.maxDescLength-descLength;

			jQuery(this).find('.input-length').html(descLength);

			/*
			if(diff < '0'){
				jQuery(this).find('.green').css('color','blue');
			}else if(diff < '40'){
				jQuery(this).find('.green').css('color','green');
			}else{
				jQuery(this).find('.green').css('color', 'red');
			}*/

			if(descLength >= 70 && descLength <= 155){
				jQuery(this).find('.green').css('color', '');
			} else if(descLength > 155){
				jQuery(this).find('.green').css('color','orange');
			} else if(descLength < 70){
				jQuery(this).find('.green').css('color','red');
			}

		});
	}

}