<?php
// Creating the description widget
	class DelucksMetaDescription extends WP_Widget {

		function __construct() {
			// Instantiate the parent object
		    parent::__construct('DelucksMetaDescription', esc_html__('Meta description', 'delucks-seo'), array( 'description' => esc_html__( 'Use the meta descriptions as intros for your visitors.', 'delucks-seo' ), ));
		}

		function widget( $args, $instance ) {
			global $plugin_dpc;

			echo $args['before_widget'];
			if ( ! empty( $instance['title'] ) ) {
				echo $args['before_title'] . apply_filters( 'widget_title', $instance['title'] ). $args['after_title'];
			}

			echo esc_html($plugin_dpc->getModuleInstance('basic', 'metadata')->the_metadescription());
			echo $args['after_widget'];
		}

		function update( $new_instance, $old_instance ) {
			$instance = array();
			$instance['title'] = ( ! empty( $new_instance['title'] ) ) ? wp_strip_all_tags( $new_instance['title'] ) : '';
			return $instance;
		}

		function form( $instance ) {
			if ( isset( $instance[ 'title' ] ) ) {
				$title = $instance[ 'title' ];
			} else {
				$title = '';
			}
		?>
			<p>
				<label for="<?php echo esc_attr($this->get_field_id( 'title' )); ?>"><?php echo esc_html( 'Title', 'delucks-seo' ); ?>:</label>
				<input class="widefat" id="<?php echo esc_attr($this->get_field_id( 'title' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'title' )); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" />
			</p>
		<?php
		}
	}
?>