<?php
/**
 * XML Sitemap Feed Template for pages feed.
 *
 * @package XML Sitemap Feed plugin for WordPress
 */
global $plugin_dpc;
$module		= $plugin_dpc->getModuleInstance('basic', 'sitemaps');
$metadata	= $plugin_dpc->getModuleInstance('basic', 'metadata')->settings;
$posttype 	= str_replace('sitemap-posttype-', '', get_query_var( 'feed' )); // sitemap-posttype-xxxx
$query 		= $module->getPosts($posttype);

status_header('200'); // force header('HTTP/1.1 200 OK') for sites without posts
header('Content-Type: text/xml; charset=UTF-8' , true);
echo '<?xml version="1.0" encoding="UTF-8"?>';
?>
<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
	xsi:schemaLocation="http://www.sitemaps.org/schemas/sitemap/0.9
		http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd">
<?php while($query->have_posts()): $query->the_post(); ?>

<?php if(!strlen(get_post_meta( get_the_ID(), '_dpc-no-index', true))){ ?>
	<url>
		<loc><![CDATA[<?php echo esc_url( get_permalink() ); ?>]]></loc>
		<lastmod><?php echo esc_html(mysql2date('Y-m-d',$post->post_modified_gmt)); ?></lastmod>
		<changefreq><?php echo esc_html($module->settings['default']['cpt'][$posttype]['frequence']); ?></changefreq>
	 	<priority><?php echo esc_html($module->settings['default']['cpt'][$posttype]['priority']); ?></priority>
	</url>
<?php } ?>
<?php endwhile; ?>

<?php /* Add Categories */
if(isset($metadata['categories']) && count($metadata['categories'])){
    foreach($metadata['categories'] as $id => $value){
        if($value['follow'] == 'follow' || $value['index'] == 'index'){ ?>
       	<url>
    		<loc><![CDATA[<?php echo esc_url( get_category_link($id) ); ?>]]></loc>
    		<changefreq>weekly</changefreq>
    	 	<priority>0.6</priority>
    	</url>
        <?php }
    }
}
?>
</urlset>