<?php
// Creating the description widget
	class DelucksGaOptOut extends WP_Widget {

		function __construct() {
			// Instantiate the parent object
		    parent::__construct('DelucksGaOptOut', esc_html__('Deactivate Google Analytics', 'delucks-seo'), array( 'description' => esc_html__( 'Placeholder for Google Analytics opt-out', 'delucks-seo' ), ));
		}

		function widget( $args, $instance ) {
			global $plugin_dpc;

			echo $args['before_widget'];
			if ( ! empty( $instance['title'] ) ) {
				echo $args['before_title'] . apply_filters( 'widget_title', $instance['title'] ). $args['after_title'];
			}

			//$module = $plugin_dpc->getModuleInstance('basic', 'metadata')->settings;
			echo '<a onclick="alert(\''.esc_attr(__('Google Analytics has been deactivated', 'delucks-seo')).'\');" href="javascript:gtmOptOut(); gaOptout();">'.(isset($instance['link_text']) && strlen($instance['link_text']) ? esc_html($instance['link_text']) : esc_html__('Deactivate Google Analytics', 'delucks-seo')).'</a>';
			echo $args['after_widget'];
		}

		function update( $new_instance, $old_instance ) {
			$instance = array();
			$instance['title'] = ( ! empty( $new_instance['title'] ) ) ? wp_strip_all_tags( $new_instance['title'] ) : '';
			$instance['link_text'] = ( ! empty( $new_instance['link_text'] ) ) ? wp_strip_all_tags( $new_instance['link_text'] ) : '';
			return $instance;
		}

		function form( $instance ) {
			if ( isset( $instance[ 'title' ] ) ) {
				$title = isset($instance[ 'title' ]) ? $instance[ 'title' ] : '';
				$link_text = isset($instance[ 'link_text' ]) ? $instance[ 'link_text' ] : '';
			} else {
				$title = '';
				$link_text = '';
			}


			if(!isset($this->settings['analytics']['gaOptOut']) || $this->settings['analytics']['gaOptOut'] != 'on'){ ?>
			<p>
				<label style="font-weight: bold;"><?php echo esc_html(__( 'Warning', 'delucks-seo' )); ?>:</label>
				<?php printf(esc_html__('The DELUCKS SEO option "%s" is turned off. This could result in a javascript and theme error.','delucks-seo' ), esc_html__('Activate Google Analytics Opt-out code', 'delucks-seo')); ?>
			</p>
			<?php }	?>


			<p>
				<label for="<?php echo esc_attr($this->get_field_id( 'title' )); ?>"><?php echo esc_html(__( 'Title', 'delucks-seo' )); ?>:</label>
				<input class="widefat" id="<?php echo esc_attr($this->get_field_id( 'title' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'title' )); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" />
			</p>
			<p>
				<label for="<?php echo esc_attr($this->get_field_id( 'link_text' )); ?>"><?php echo esc_html(__( 'Link text', 'delucks-seo' )); ?>:</label>
				<input class="widefat" id="<?php echo esc_attr($this->get_field_id( 'link_text' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'link_text' )); ?>" type="text" value="<?php echo esc_attr( $link_text ); ?>" placeholder="<?php echo esc_attr(__('Deactivate Google Analytics', 'delucks-seo')); ?>"/>
			</p>
		<?php
		}
	}
?>