<?php

class DPC_Module_Dpc_Dashboard {

	var $dpc				= null;
	var $isSubmodule		= true;
	var $moduleDirectory 	= 'dashboard/';
	var $moduleTitle 		= '';
	var $optionsHook		= 'dpc-dpc-dashboard';
	var $settingsFile		= false;
	var $translatorJs		= array();

	function __construct(&$dpc){		
		$this->settingsFile = dirname(__FILE__) . '/settings.xml';
		$this->dpc 			= $dpc;
		$this->moduleTitle	= esc_html__('Start', 'delucks-seo');
		$this->settings     = $this->dpc->getModuleSettings('dpc_dashboard');
		$this->translatorJs = array(
		    'unlock' 	=> esc_html__('Unlock', 'delucks-seo')
		);

		//assign wizard input values
		$metadataSettings                     = $this->dpc->getModuleSettings('basic_metadata');
		$this->settings['verify']['google']   = (isset($metadataSettings['verify']) && isset($metadataSettings['verify']['google']) ? $metadataSettings['verify']['google'] : '');
		$this->settings['verify']['bing']     = (isset($metadataSettings['verify']) && isset($metadataSettings['verify']['bing']) ? $metadataSettings['verify']['bing'] : '');
		//$licenseKey                           = sanitize_text_field($_POST['dpc']['dpc_dashboard']['active_license']);
		update_option('dpc_dpc_dashboard', $this->settings);
	}

	function adminSettings(){
		$this->dpc->parseSettingsByXml($this->settingsFile, 'general');
	}

	function adminSettingsHead(){
		wp_enqueue_script('dpc-dashboard-settings', plugins_url( 'assets/js/settings.js', __FILE__ ), array('jquery'));
		wp_localize_script('dpc-dashboard-settings', 'dpc_dashboard_translator', $this->translatorJs);
		wp_enqueue_script('knob', plugins_url( 'assets/js/jquery.knob.js', __FILE__ ), array('jquery'));
		wp_enqueue_script('raphael', plugins_url( 'assets/js/raphael-min.js', __FILE__ ), array('jquery'));
		wp_enqueue_script('morris', plugins_url( 'assets/js/morris-0.5.1.min.js', __FILE__ ), array('jquery'));
		wp_enqueue_style('dpc-dashboard-settings', plugins_url( 'assets/css/settings.css', __FILE__ ));
	}

	function getTextWizardSeoGoogleDescripion(){
	    return sprintf(wp_kses(__('Please confirm your authorship in Google for <strong>%s</strong>. Use an existing property with that URL or create a new one and select the option for <strong>URL prefix property</strong> confirmation. Copy the HTML-tag here, hit save and re-check confirmation in the Google tab.', 'delucks-seo'), $this->dpc->guiHelper->text_allowed_html), get_bloginfo('url'));
	}

	function getTextWizardSeoBingDescripion(){
	    return sprintf(wp_kses(__('Please confirm your authorship in Bing for <strong>%s</strong>. Use an existing property with that URL or create a new site. Copy the HTML-tag here, hit save and re-check confirmation in the Bing tab.', 'delucks-seo'), $this->dpc->guiHelper->text_allowed_html), get_bloginfo('url'));
	}

	function registerWidgets(){ }
	function adminHead(){ }
	function executeFrontendActions(){ }
	function onSaveActionAfter(){ }

	function wizardInstall(){
	    echo "Install File";
	    die();
	}

	function initXMLText(){
	    esc_html__('For small blogs and one-page websites', 'delucks-seo');
	    esc_html__('For ambitious blogs, multi-page websites and shops', 'delucks-seo');
	    esc_html__('Activate Premium', 'delucks-seo');
	    esc_html__('Save', 'delucks-seo');
	    esc_html__('Next', 'delucks-seo');
	    esc_html__('Setup', 'delucks-seo');
	    esc_html__('Searchengines', 'delucks-seo');
	    esc_html__('Modules', 'delucks-seo');
	    esc_html__('Backup', 'delucks-seo');
	    esc_html__('Select and confirm property', 'delucks-seo');
	    esc_html__('Paste HTML-Tag', 'delucks-seo');
	    esc_html__('Buy Premium', 'delucks-seo');
	    esc_html__('License / Purchase code', 'delucks-seo');
	    esc_html__('Comment', 'delucks-seo');
	    esc_html__('Date / Time', 'delucks-seo');
	    esc_html__('Download', 'delucks-seo');
	    esc_html__('Blank', 'delucks-seo');
	    esc_html__('Start from scratch without pre-defined metadata.', 'delucks-seo');
	    esc_html__('With recommended settings', 'delucks-seo');
	    esc_html__('Import', 'delucks-seo');
	    esc_html__('Import your metadata from another SEO Plugin', 'delucks-seo');
	    esc_html__('Restore from backup', 'delucks-seo');
	    esc_html__('PageSpeed Test', 'delucks-seo');
	    esc_html__('Performane Optimization', 'delucks-seo');
	}
	
}