<?php

class DPC_Module_Dpc_Importexport_Migration_Aioseop {

	var $adapterKey			= 'aioseop';
	var $adapterDirectory	= 'all-in-one-seo-pack';
	var $adapterName		= '';
	var $adapterVersion		= '1.0';
	var $dpc				= null;
	var $optionSettings		= array();
	var $migrationCount		= array();
	var $srcValueState		= null;

	function __construct(&$dpc){
		$this->dpc = $dpc;
		$this->getFields();
		$this->adapterName = esc_html__('All in One SEO Pack', 'delucks-seo');
	}

	function migrationDone(){
	    $this->dpc->activateModule('basic_metadata');
	    $this->dpc->activateModule('basic_sitemaps');
	    $this->dpc->activateModule('basic_statistics');
	    $this->dpc->activateModule('basic_urls');
	}

	function showWizard($step = 'wizard'){
		$this->dpc->parseSettingsByXml(dirname(__FILE__) . '/'.$this->adapterKey.'.xml', $step, false, true);
	}

	function getFields($index = false){

	}

	function getFormdata(){
		if(isset($_REQUEST['dpc']['dpc_importexport_migration_'.$this->adapterKey])){
			return $_REQUEST['dpc']['dpc_importexport_migration_'.$this->adapterKey];
		}
		return false;
	}

	function migrate(){

	    $this->migrationCount[esc_html__('Metadata fields', 'delucks-seo')] = 0;
		global $wpdb;
		$sql = "SELECT `ID` FROM $wpdb->posts WHERE `post_type` IN('".join("','",get_post_types(array('public' => true)))."') AND `post_type` NOT IN('".join("','",array('attachment', 'revision'))."') AND `post_status` NOT IN('".join("','",array('auto-draft', 'trash'))."')";
		$posts = $wpdb->get_results($wpdb->prepare($sql), ARRAY_A);

		foreach($posts as $id){

			/** SEO Title **/
			$title = get_post_meta($id['ID'], '_aioseop_title', true);
			if(!empty($title)){
				update_post_meta($id['ID'], '_dpc-meta-title', $title);
				$this->migrationCount[_html__('Metadata fields', 'delucks-seo')] = $this->migrationCount[esc_html__('Metadata fields', 'delucks-seo')] +1; //count for success area
			}

			/** SEO Description **/
			$metaDescription = get_post_meta($id['ID'], '_aioseop_description', true);
			if(!empty($metaDescription)){
				update_post_meta($id['ID'], '_dpc-meta-description', $metaDescription);
				$this->migrationCount[esc_html__('Metadata fields', 'delucks-seo')] = $this->migrationCount[esc_html__('Metadata fields', 'delucks-seo')] +1; //count for success area
			}
		}

		$this->dpc->parseSettingsByXml(dirname(__FILE__) . '/'.$this->adapterKey.'.xml', 'success', false, true);
		add_action('init', array($this, 'migrationDone'));
		die();
	}

	function modifyValue($destField, $value){
		switch($destField){
			case 'forceSSL':
				if($value == 'https'){
					$value = 'on';
				} else {
					$value = null;
				}
				break;
			case 'default][cpt][post][status':
			case 'default][cpt][page][status':
				if($value == 1){
					$value = null;
				} else {
					$value = 'on';
				}

				break;
		}
		return $value;
	}

	function setValueToDestSettings(array $dest, $destField, $value){
		if(strpos($destField, '][') !== false){
			$temp = &$dest;
			foreach(explode('][', $destField) as $key) {
			    $temp = &$temp[$key];
			}
			$temp = $value;

			unset($temp);
			return $dest;
		}
		$dest[$destField] = $value;

		if($value == null){
			unset($dest[$destField]);
		}

		return $dest;
	}

	function getSrcValue($optionField, $optionKey = false){
		if($optionKey){
			$data = get_option($optionKey);
			if(isset($data[$optionField])){
				return $data[$optionField];
			}
			return '';

		}
		return get_option($optionField);
	}

	function getMigrationCount(){
		$data = array();
		foreach($this->migrationCount as $module => $count){
			$data[] = array('module' => $module, 'count' => $count);
		}
		return $data;
	}

}