const Jobs = {
    
    scope:      document.querySelectorAll('.jobs-table'),
    filters:    document.querySelectorAll('.jobs-table-filters'),
    
    init: function(){
        if(this.scope.length > 0 && this.filters.length > 0 ){
            this.initFilters();
            this.initView();
            this.initBeforeUnload();
        }

    },

	initView: function(){
        var dpcJobSearchForm        = JSON.parse(sessionStorage.getItem('dpcJobSearchForm')),
            dpcJobSearchFormResults = JSON.parse(sessionStorage.getItem('dpcJobSearchFormResults'));
        
        if( dpcJobSearchForm !== null ){
            for (const key in dpcJobSearchForm) {
                this.filters[0].querySelector("[name=" + CSS.escape(key) + "]").value = dpcJobSearchForm[key];
            }
        }

        if( dpcJobSearchFormResults !== null ){
            if(dpcJobSearchFormResults.success){
                if(dpcJobSearchFormResults.type === 'table'){
                    jQuery('tbody.job-offers-table-body').html( dpcJobSearchFormResults.output )
                }else{
                    jQuery('.job-offers-list').html( dpcJobSearchFormResults.output )
                }
            }else{
                container.innerHTML = dpcJobSearchFormResults.output;
            }
        }
        
	}, 

    initBeforeUnload: function(){
        window.addEventListener('beforeunload', () => {
            var form        = this.filters[0].querySelector('#dpc_job_filters'),
                formData    = {};

            for (const [key, value] of new FormData(form)) {
                formData[key] = value;
            }
 
            sessionStorage.setItem('dpcJobSearchForm', JSON.stringify(formData));
        });
    },
    
    
    initFilters: function() {
		let form        = this.filters[0].querySelector('#dpc_job_filters');
		let submit      = this.filters[0].querySelector('#submit_jobs_form');
		let container   = this.scope[0].querySelector('.job-contents');
		
		submit.addEventListener('click', (event) => { this.getData(event, form, container); });
    },
    
    getData: async function(event, form, container){
        event.preventDefault();

		sessionStorage.removeItem("dpcJobSearchForm");
		sessionStorage.removeItem("dpcJobSearchFormResults");

        var formData            = {};
        formData['action']      = 'get_jobs_filtered';
        
        for (const [key, value] of new FormData(form)) {
            formData[key] = value;
        }
        
        jQuery.getJSON(script_data.ajaxurl, formData, function(response) {
        
            if(response.success){
                if(response.type === 'table'){
                    jQuery('tbody.job-offers-table-body').html( response.output )
                }else{
                    jQuery('.job-offers-list').html( response.output )
                }
            }else{
                container.innerHTML = response.output;
            }

			sessionStorage.setItem('dpcJobSearchForm', JSON.stringify(formData));
			sessionStorage.setItem('dpcJobSearchFormResults', JSON.stringify(response));
        });

            
            return false;
    }
};


document.addEventListener("DOMContentLoaded", function() { 
    Jobs.init();
});



