<?php
/**
 * The template for displaying archive jobs content.
 *
 * @link https://codex.wordpress.org/Template_Hierarchy
 *
 * @package DELUCKS jobs
 */
global $post, $plugin_dpc;

$post_ID = get_the_ID();
 
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

$settings	= get_post_meta( $post_ID, 'jobsettings', true);

?>

<table id="job_offers"> 
	<thead>
		<tr>
			<th><?php echo esc_html(__( 'Hiring date', 'delucks-seo' )); ?></th>
			<th><?php echo esc_html(__( 'Job title', 'delucks-seo' )); ?></th>
			<th><?php echo esc_html( __( 'Location', 'delucks-seo' )); ?></th>
			<th><?php echo esc_html( __( 'Section', 'delucks-seo' )); ?></th>
			<?php
				if( isset($this->settings['jobOverviewHiringDate']) && $this->settings['jobOverviewHiringDate'] === 'on' ){
					echo '<th>' . esc_html(__( 'Hiring date', 'delucks-seo' )) . '</th>';
				}

				if( isset($this->settings['jobOverviewDeadlineDate']) && $this->settings['jobOverviewDeadlineDate'] === 'on' ){
					echo '<th>' . esc_html(__( 'Application deadline', 'delucks-seo' )) . '</th>';
				}
			?>
			
			<th><?php echo esc_html(__( 'Working time (h/week)', 'delucks-seo' )); ?></th>
		</tr>
	</thead>
	<tbody class="job-offers-table-body">
		
		<?php 
		foreach($posts as $post){

			$settings		= get_post_meta( $post->ID, 'jobsettings', true);
			$job_sections 	= get_the_terms( $post->ID , 'dpc_job_section' );
			$job_locations 	= get_the_terms( $post->ID , 'dpc_job_location' );
			$location_list 	= '';
			
			if ( !empty($locations) ) {
				foreach ( $job_locations as $location ) {
					$location_list .= $location->name . ', ';
				}
				$location_list = rtrim( $location_list, ', ' );
			}
			
			$section_list 	= '';
			
			if ( !empty($sections) ) {
				foreach ( $job_sections as $section ) {
					$section_list .= $section->name . ', ';
				}
				$section_list = rtrim( $section_list, ', ' );
			}
			
			
			include(DPC_JOBS_PATH . '/templates/partials/table-content.php');
			
			
		 } // End of the loop. 
		 ?>
		
	</tbody>	
</table>
