<?php
/**
 * The template for displaying archive jobs.
 *
 * @link https://codex.wordpress.org/Template_Hierarchy
 *
 * @package DELUCKS jobs
 */

get_header();
$filter_available = false; // if no filter in settings do not show

?>

	<div id="primary" class="content-area">
		<main id="main" class="site-main" role="main">
			<header class="page-header">
				<?php 
				
				the_archive_title( '<h1 class="page-title jobs-page-title">', '</h1>' );
								
				?>
			</header>
			<!-- .page-header -->
			
							
			<div class="jobs-table">
				<div class="jobs-table-filters">
					<form method="POST" id="dpc_job_filters">
						<?php
						$sections = get_terms( array( 'taxonomy' => 'dpc_job_section', 'hide_empty' => true ) );
						if ( isset($this->settings['jobSectionFilter']) && $this->settings['jobSectionFilter'] === 'on' ) {
							$filter_available = true;
						?>
							<select name="dpc_job_section" id="job_filter_section">
								<option value=""><?php echo esc_html(__( 'All sections', 'delucks-seo' )); ?></option>
								<?php
								if ( !empty($sections) && $this->settings['jobSectionFilter'] === 'on' ) {
									foreach ( $sections as $section ) {
										echo '<option value="' . esc_attr($section->slug) . '" ' . selected(sanitize_text_field($_POST['dpc_job_section']), $section->slug) . '>' . esc_html($section->name) . '</option>';
									}
								}
								?>
								
							</select>
						<?php
						}
						?>
						
						<?php
						$locations = get_terms( array( 'taxonomy' => 'dpc_job_location', 'hide_empty' => true ) );
						if ( isset($this->settings['jobLocationFilter']) && $this->settings['jobLocationFilter'] === 'on') {
							$filter_available = true;
						?>
							<select name="dpc_job_location" id="job_filter_location">
								<option value=""><?php echo esc_html(__( 'All locations', 'delucks-seo' )); ?></option>
								<?php
								if ( !empty($locations) ) {
									foreach ( $locations as $location ) {
										echo '<option value="' . esc_attr($location->slug) . '" ' . selected(sanitize_text_field($_POST['dpc_job_location']), $location->slug) . '>' . esc_html($location->name) . '</option>';
									}
								}
								?>
								
							</select>
						<?php
						}
						?>

						<?php
						if($filter_available){
							?>
							<button id="submit_jobs_form" type='submit'><?php echo esc_html(_x( 'Filter', 'verb', 'delucks-seo' )); ?></button>
							<?php
						}
						?>
						
					</form>
					
				</div>
				
				<div class="job-contents">
					<?php
						if( have_posts() ){
							if ( file_exists( DPC_JOBS_PATH . '/templates/archive-jobs-content-table.php' ) && isset($this->settings['jobsView']) && $this->settings['jobsView'] != 'list' ) {
					            include(DPC_JOBS_PATH . '/templates/archive-jobs-content-table.php');
					        }elseif( file_exists( DPC_JOBS_PATH . '/templates/archive-jobs-content-list.php' ) && isset($this->settings['jobsView']) &&  $this->settings['jobsView'] != 'table' ){
					            include(DPC_JOBS_PATH . '/templates/archive-jobs-content-list.php');
					        }
						}else{
							include(DPC_JOBS_PATH . '/templates/archive-jobs-empty.php');
						}
					?>	
				</div>
				
						
			</div>
			<?php wp_link_pages(); ?>
				
		</main><!-- #main -->
	</div><!-- #primary -->

<?php get_footer(); ?>
