<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}
?>

<div id="post-<?php echo esc_html($post->ID); ?>" class="single-joboffer single-job-list-item">
	<div class="joboffer-title">
		<?php echo '<h3 class="entry-title"><a href="' . esc_url( get_permalink($post) ) . '" rel="bookmark">'. esc_html($post->post_title) . '</a></h3>'; ?>
	</div>
	<div class="job-offer-meta">
		<div class="joboffer-location">
			<span class="dashicons dashicons-location"></span> <?php echo esc_html($location_list); ?>
		</div>
		<div class="joboffer-section">
			<span class="dashicons dashicons-businessman"></span> <?php echo esc_html($section_list); ?>
		</div>
		<?php
			if( isset($this->settings['jobOverviewHiringDate']) && $this->settings['jobOverviewHiringDate'] === 'on' ){
				?>
				<div class="joboffer-date">
					<span class="dashicons dashicons-calendar"></span> <?php echo esc_html(sprintf(__( 'Hiring date %s', 'delucks-seo' ), isset($settings['hiring_date']) ? gmdate('d.m.Y', $settings['hiring_date']) : '')); ?>
				</div>
				<?php
			}

			if( isset($this->settings['jobOverviewDeadlineDate']) && $this->settings['jobOverviewDeadlineDate'] === 'on' ){
				?>
				<div class="joboffer-deadline">
					<span class="dashicons dashicons-calendar"></span> <?php echo esc_html(sprintf(__( 'Application deadline %s', 'delucks-seo' ), isset($settings['deadline']) ? gmdate('d.m.Y', $settings['deadline']) : '')); ?>
				</div>
				<?php
			}
		?>
		
	</div>
	
</div>