<?php
// Creating the rating widget
	class DelucksRating extends WP_Widget {

		function __construct() {
		    parent::__construct('DelucksRating', esc_html__('Rating', 'delucks-seo'), array( 'description' => esc_html__( 'The overall rating with the legend for your ratings', 'delucks-seo' ), ));
		}

		function widget( $args, $instance ) {
			global $plugin_dpc;

			echo $args['before_widget'];
			if ( ! empty( $instance['title'] ) ) {
				echo $args['before_title'] . apply_filters( 'widget_title', $instance['title'] ). $args['after_title'];
			}

			echo $plugin_dpc->getModuleInstance('professional', 'rating')->getLegende(get_the_ID());
			echo $args['after_widget'];
		}

		function update( $new_instance, $old_instance ) {
			$instance = array();
			$instance['title'] = ( ! empty( $new_instance['title'] ) ) ? wp_strip_all_tags( $new_instance['title'] ) : '';
			return $instance;
		}

		function form( $instance ) {
			if ( isset( $instance[ 'title' ] ) ) {
				$title = $instance[ 'title' ];
			}
		?>
			<p>
				<label for="<?php echo esc_attr($this->get_field_id( 'title' )); ?>"><?php echo esc_html(__( 'Title', '')); ?>:</label>
				<input class="widefat" id="<?php echo esc_attr($this->get_field_id( 'title' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'title' )); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" />
			</p>
		<?php
		}




	}
?>