var facebook	= '',
	googlePlus	= '',
	twitter		= '';

jQuery(document).ready(function($){
	"use strict";

	/**
	 * Social sites inputs & button links
	 */
	if($('input[name^="dpc[professional_sharing][facebookUrl]"]').length && $('input[name^="dpc[professional_sharing][facebookUrl]"]').val().length === 0){
		$('#professional_sharing_visit_facebook').addClass('disabled');
	}

	if($('input[name^="dpc[professional_sharing][googleUrl]"]').length && $('input[name^="dpc[professional_sharing][googleUrl]"]').val().length === 0){
		$('#professional_sharing_visit_googlePlus').addClass('disabled');
	}

	if($('input[name^="dpc[professional_sharing][twittername]"]').length && $('input[name^="dpc[professional_sharing][twittername]"]').val().length === 0){
		$('#professional_sharing_visit_twitter').addClass('disabled');
	}

	$('input[name^="dpc[professional_sharing][facebookUrl]"]').on("keyup change", function() {
   		var facebook = this.value;
   		$('#professional_sharing_visit_facebook').removeClass('disabled');
	}).blur(function(){
	    if($(this).val().length === 0) {
	        $('#professional_sharing_visit_facebook').addClass('disabled');
	    }
	});

	$('input[name^="dpc[professional_sharing][googleUrl]"]').on("keyup change", function() {
   		var googlePlus = this.value;
		$('#professional_sharing_visit_googlePlus').removeClass('disabled');
	}).blur(function(){
	    if($(this).val().length === 0) {
	        $('#professional_sharing_visit_googlePlus').addClass('disabled');
	    }
	});

	$('input[name^="dpc[professional_sharing][twittername]"]').on("keyup change", function() {
   		var twitter = this.value;
		$('#professional_sharing_visit_twitter').removeClass('disabled');
	}).blur(function(){
	    if($(this).val().length === 0) {
	        $('#professional_sharing_visit_twitter').addClass('disabled');
	    }
	});

	$('#professional_sharing_visit_facebook').click(function(){
		var facebook	= jQuery('input[name^="dpc[professional_sharing][facebookUrl]"]').val();
		if(!facebook.length){
			return false;
		}
		if(!facebook.match(/^[a-zA-Z]+:\/\//)) { facebook = 'http://' + facebook; }
		window.open(facebook);
		return false;
	})
	$('#professional_sharing_visit_googlePlus').click(function(){
		var googlePlus	= jQuery('input[name^="dpc[professional_sharing][googleUrl]"]').val();
		if(!googlePlus.length){
			return false;
		}
		if(!googlePlus.match(/^[a-zA-Z]+:\/\//)) { googlePlus = 'http://' + googlePlus; }
		window.open(googlePlus);
		return false;
	})
	$('#professional_sharing_visit_twitter').click(function(){
		var twitter		= jQuery('input[name^="dpc[professional_sharing][twittername]"]').val();
		if(!twitter.length){
			return false;
		}
		window.open('https://twitter.com/'+twitter);
		return false;
	})
	// END -- social sites

	function appendCustom(btn,icon,label,counter,index,value){
		if(typeof(value) === 'undefined' || typeof(value.label) === 'undefined' ){ return false; }

		$(btn).css({
			'background-color': value.label.background,
			'color': value.label.color
		});
		if(value.label.display != 'on'){
			$(label).css('display','none');
		}

		$(label).text(value.label.text.de);
		$(icon).css({
			'color': value['icon']['color']
		});

		if(value.icon.display != 'on'){
			$(icon).css('display','none');
		}

		$(counter).css({
			'background-color': value.counter.background,
			'color': value.counter.color
		});

		if(value.counter.display != 'on'){
			$(counter).css('display','none');
		}
	}

	var settings 	= dpc_professional_sharing_settings,
		activeNet	= settings['activeNetworks'],
		colorSet	= settings['networks'];

	if(typeof(colorSet) != 'undefined'){
		$.each(colorSet, function(index,value) {

			/**
			 * Init Settings
			 */
			var btnWrap	= $('.sharing-buttons').children().find('.dpc-btn-share.'+index),
				btn		= $(btnWrap).children().find('.dpc-label').parents().closest('.dpc-btn-wrap'),
				icon	= $(btnWrap).children().find('.dpc-icon'),
				label	= $(btnWrap).children().find('.dpc-label'),
				counter = $(btnWrap).children().find('.dpc-counter').parents().closest('.dpc-btn-wrap'),
				count	= $(btnWrap).children().find('.dpc-counter');

			if(value.default == 'on' && typeof(value) != 'undefined'){ /** Do nothing **/ }else{
				//BTN & Label
				if(typeof(value) != 'undefined' || typeof(value.label) != 'undefined'){
					appendCustom(btn,icon,label,counter,index,value)
				}
			}

			/**
			 * Activate default
			 */
			$('input[name^="dpc[professional_sharing][networks]['+index+'][default]"]').on('ifChecked', function(event){
				$(label).css('display','inline');
				$(icon).css('display','inline');
				$(counter).css('display','inline');
				if($('.dpc-section.professional_sharing.buttonColor_'+index).closest('.row').is(":visible")){
					var row 		= jQuery(this).parents().closest('.haswrap'),
						btn			= jQuery(row).children().find('.toggle-button'),
						toggle		= jQuery(btn).attr('data-toggle');

					jQuery(btn).parents().closest('.toggle-row').removeClass('active-row');
				}
			});

			/**
			 * Deactivate default
			 */
			$('input[name^="dpc[professional_sharing][networks]['+index+'][default]"]').on('ifUnchecked', function(event){
				appendCustom(btn,icon,label,counter,index,value)
			});

			/**
			 * Change Event
			 */
			$('input[name^="dpc[professional_sharing][networks]['+index+'][label][background]"]').colorpicker().on('changeColor', function(ev){
				$(btn).css('background-color', ev.color.toHex());
			});

			$('input[name^="dpc[professional_sharing][networks]['+index+'][label][color]"]').colorpicker().on('changeColor', function(ev){
				$(btn).css('color', ev.color.toHex());
				$(label).css('color', ev.color.toHex());
			});

			$('input[name^="dpc[professional_sharing][networks]['+index+'][label][text]"]').bind('paste keyup change', function(ev){
				$(label).text($(this).val());
			});

			$('input[name^="dpc[professional_sharing][networks]['+index+'][icon][color]"]').colorpicker().on('changeColor', function(ev){
				$(icon).css('color', ev.color.toHex());
			});

			$('input[name^="dpc[professional_sharing][networks]['+index+'][counter][color]"]').colorpicker().on('changeColor', function(ev){
				$(counter).css('color', ev.color.toHex());
			});

			$('input[name^="dpc[professional_sharing][networks]['+index+'][counter][background]"]').colorpicker().on('changeColor', function(ev){
				$(counter).css('background-color', ev.color.toHex());
			});

			$('input[name^="dpc[professional_sharing][networks]['+index+'][label][display]"]').on('ifChecked', function(event){
				$(label).css('display','inline')
			}).on('ifUnchecked', function(event){
				$(label).css('display','none')
			});

			$('input[name^="dpc[professional_sharing][networks]['+index+'][icon][display]"]').on('ifChecked', function(event){
				$(icon).css('display','inline')
			}).on('ifUnchecked', function(event){
				$(icon).css('display','none')
			});

			$('input[name^="dpc[professional_sharing][networks]['+index+'][counter][display]"]').on('ifChecked', function(event){
				$(counter).css('display','inline')
			}).on('ifUnchecked', function(event){
				$(counter).css('display','none')
			});

		});
	} else {
		/**
		 * Activate default
		 */
		$('.professional_sharing.sharing-buttons input[name$="[default]"]').each(function(){ });
	}

	if(typeof(activeNet) != 'undefined'){
		$.each(activeNet, function(index,value) {
			//Show active networks
			var input = $('.sharing-buttons').children().find('.'+value);
			$(input).parents().closest('.toggle-row').css('display','inline-block');
		});
	}

	$('[name^="dpc[professional_sharing][activeNetworks][]"]').multiselect({
		onChange: function(element, checked) {
			var network = element.val(),
				input 	= $('.sharing-buttons').children().find('.'+network);

			if(checked == true){
				$(input).parents().closest('.toggle-row').css('display','inline-block');
			}else{
				$(input).parents().closest('.toggle-row').css('display','none');
			}
			setMoreDirection();
		}
	});
	$('.collection > .toggle-row').each(function(){
		var row 	= $(this),
			check	= $(this).find('[id^="defaults-"]'),
			preview	= $(row).children().find('.dpc-btn-share');

		if($(check).prop('checked')){
			$(preview).addClass('default');
		} else {
			$(preview).removeClass('default');
		}

		$(check).on('ifChanged', function(event){
			$(this).on('ifChecked', function(event){
				$(preview).addClass('default');
				var origTitle = $(this).data('original-title');
				origTitle = origTitle.toLowerCase().replace(/\b[a-z]/g, function(letter) {
					return letter.toUpperCase();
				});
				$(preview).children().find('.dpc-label').text(origTitle)
			});
			$(this).on('ifUnchecked', function(event){
				$(preview).removeClass('default');
			});
		});

		if(row.data('new-row') == 1){
			check.attr('checked', 'checked');
		}
	});

	function setMoreDirection(){
		var button		= $('.dpc-btn-share.more');
		var row			= $(button).parents('.toggle-row');
		var direction	= $(row).find('.buttonSettings_more [name$="[direction]"]').val();

		$(row).siblings().addBack().removeClass('dpc-is-more');

		if(!$(row).is(':visible')){
			return false;
		}

		switch(direction){
			case 'before':
				$(row).prevAll().addBack().addClass('dpc-is-more');
				break;
			case 'after':
			default:
				$(row).nextAll().addBack().addClass('dpc-is-more');
				break;
		}
	}

	$('.buttonSettings_more [name$="[direction]"]').multiselect({
		onChange: function(element, checked) {
			setMoreDirection();
		}
	});

	$('.professional_sharing > .tosort-row').sortable({
		items: '.toggle-row',
		update: function (event, ui){
			setMoreDirection();
		}
	});

	setMoreDirection();
});