<?php
// Creating the rating widget
	class DPC_Widget_Sharing_Sharing extends WP_Widget {

		function __construct() {
			// Instantiate the parent object
		    parent::__construct('DPC_Widget_Sharing_Sharing', esc_html__('Sharing Widget', 'delucks-seo'), array( 'description' => esc_html__( 'Show your social sharing buttons', 'delucks-seo' ) ));
		}

		function widget( $args, $instance ) {
			global $plugin_dpc;
			echo $args['before_widget'];
			if ( ! empty( $instance['title'] ) ) {
				echo $args['before_title'] . apply_filters( 'widget_title', $instance['title'] ). $args['after_title'];
			}

			$plugin_dpc->getModuleInstance('professional', 'sharing')->showButtons();
			echo $args['after_widget'];
		}

		function update( $new_instance, $old_instance ) {
			$instance = array();
			$instance['title'] = ( ! empty( $new_instance['title'] ) ) ? wp_strip_all_tags( $new_instance['title'] ) : '';
			return $instance;
		}

		function form( $instance ) {
			$title = '';
			if ( isset( $instance[ 'title' ] ) ) {
				$title = $instance[ 'title' ];
			}
		?>
			<p>
				<label for="<?php echo esc_attr($this->get_field_id( 'title' )); ?>"><?php echo esc_html(__( 'Title', 'delucks-seo' )); ?></label>
				<input class="widefat" id="<?php echo esc_attr($this->get_field_id( 'title' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'title' )); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" />
			</p>
		<?php
		}




	}
?>