/**
 * Global vars
 */
var selectedKeywords 		= new Array(),
	focusKeyword			= false,
	wdfIdfReady				= false,
	competitorSearchReady	= false;

/**
 * fields
 */
var dpcKeyword 		= jQuery('#dpc-keyword'),
	dpcMetaTitle	= jQuery('input#dpc-meta-title'),
	dpcDescription	= jQuery("#dpc-textopt-description");

function getEditorStat(){
	var text = getEditorContent();
	return {
		chars: text.length,
		words: (text.split(/[\w\u2019\'-]+/).length < 0 ? 0 : text.split(/[\w\u2019\'-]+/).length - 1)
    };
}


function getEditorContent(type){
	if(typeof(type) == 'undefined'){ type = 'text'; }
    var content;
    var inputid = 'content';
    var editor = tinyMCE.get(inputid);
    var textArea = jQuery('textarea#' + inputid);

    if (textArea.length>0 && textArea.is(':visible')) {
    	if(type == 'html'){
    		content = '<div>'+textArea.val()+'</div>';
    	} else { content = textArea.val(); }
    } else {
    	return editor.getContent({format: type});
    }

	return content;
}


function makeid(){
    var text = "";
    var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";

    for( var i=0; i < 5; i++ )
        text += possible.charAt(Math.floor(Math.random() * possible.length));

    return text;
}

function checkRequirements() {
    setTimeout(function () {
    	chechWdfIdfRequirements();
    	checkRequirements();
    }, 2000);
}

function focusKeywordSet(){
	if(jQuery('.keyword-list-item.primary').length){
		return true;
	}
	return false;
}

function competitorSiteSet(){
	if(jQuery('.dpc-metabox-context-professional_textopt .competitor_sites .extendable:not(.dpc-draft)').length){
		return true;
	}
	return false;
}

function chechWdfIdfRequirements(){
	if(focusKeywordSet() && competitorSiteSet()){
		jQuery('#wdf_idf_start').removeClass('disabled');
		wdfIdfReady = true;
	} else {
		jQuery('#wdf_idf_start').addClass('disabled');
		wdfIdfReady = false;
	}
	if(focusKeywordSet()){
		jQuery('#wdf_idf_cral_google_sites').removeClass('disabled');
		competitorSearchReady = true;
	} else {
		jQuery('#wdf_idf_cral_google_sites').addClass('disabled');
		competitorSearchReady = false;
	}
}



jQuery(document).ready(function($){
	focusKeyword = $('.keyword-list-item.primary').text();
	checkRequirements();

	if(wdfIdfReady){
		setTimeout(function(){
			wdfIdfStartAnalysis();
		}, 5000);
	}

	/**
	 * wdf*idf feature
	 */
	if(typeof(dpc_professional_textopt_settings.activateWdfIdf) !== 'undefined'){
		var timingKeywordCheck = setTimeout(function(){
			wdfIdfCheckKeywords();
			wdfIdfCheckOptimizations();
		}, 2000);

		jQuery('textarea#content').on('keyup', function(e){ //this is for html mode
			clearTimeout($.data(this, 'timeout_wdf_idf_check_keywords'));
			var timingKeywordCheck = setTimeout(function(){
				wdfIdfCheckKeywords();
				wdfIdfCheckOptimizations();
			}, 2000);
			$(this).data('timeout_wdf_idf_check_keywords', timingKeywordCheck);
		});

		if (typeof tinymce != 'undefined'){
			if (null == tinymce.activeEditor){
				if (tinymce.majorVersion == '4'){
					tinymce.on('addEditor', function(e){
						e.editor.on('keyup', function(e){
							clearTimeout($.data(this, 'timeout_wdf_idf_check_keywords'));
							var timingKeywordCheck = setTimeout(function(){
								wdfIdfCheckKeywords();
								wdfIdfCheckOptimizations();
							}, 2000);
							$(this).data('timeout_wdf_idf_check_keywords', timingKeywordCheck);
						});
					});
				}else{
					tinyMCE.onAddEditor.add(function(mgr,ed) {
						ed.onKeyUp.add(function(){
							clearTimeout($.data(this, 'timeout_wdf_idf_check_keywords'));
							var timingKeywordCheck = setTimeout(function(){
								wdfIdfCheckKeywords();
								wdfIdfCheckOptimizations();
							}, 2000);
							$(this).data('timeout_wdf_idf_check_keywords', timingKeywordCheck);
						});
					});
				}
			}
		}
	}


	jQuery('.dpc_wdf_idf_results .content table .add_to_stopwords').live('click', function(e){
		element = jQuery(this);
		keyword = jQuery(element).parents('tr').data('keyword');
		$.ajax({
			url: 'admin-ajax.php?action=dpc_professional_textopt_wdf_idf_add_stopword',
			data: {
				keyword: keyword,
				post_id: $("#wdf_idf_start").data('post_id'),
				lang: (jQuery('select#icl_post_language').length ? jQuery('select#icl_post_language').val() : (jQuery('select#post_lang_choice').length ? jQuery('select#post_lang_choice').val() : ''))
			},
			dataType: 'json',
			success: function(response){
				jQuery(element).parents('tr').remove();
			}
		});
	});

	/**
	 * wdf*idf check for keywords
	 */
	function wdfIdfCheckKeywords(){
		if (focusKeyword.length == 0){
			return;
		}

		var content = getEditorContent();
		$('.dpc_wdf_idf_results .content table tbody tr').each(function(i, row){
			keyword = $(row).data('keyword');
			average_count = $(row).data('average_count');
			var count = (content.match(new RegExp(keyword, "gi")) || []).length;

			if(count > 0 && count >= average_count){
				$(row).data('found', 'true').find('.status .dashicons').removeClass('dashicons-no').removeClass('dashicons-marker').addClass('dashicons-yes');
			} else if(count > 0 && count < average_count){
				$(row).data('found', 'true').find('.status .dashicons').removeClass('dashicons-no').removeClass('dashicons-yes').addClass('dashicons-marker');
			} else {
				$(row).data('found', 'false').find('.status .dashicons').removeClass('dashicons-yes').removeClass('dashicons-marker').addClass('dashicons-no');
			}
		});
	}

	/**
	 * wdf*idf analysis
	 */
	function wdfIdfStartAnalysis(){
		$('.dpc_wdf_idf_results .content').html('');
		$('#googleCaptchaModal').html('');
		$('.dpc_wdf_idf_results .optimizer').css({ display: 'none' });
		$('.dpc_wdf_idf_results .loader').css({ display: 'block' });

		sites = $( '.extendable .dpc_textopt_site' ).map(function() {
			if($( this ).val().length){
				return $( this ).val();
			}
		}).get();

		$.ajax({
			url: 'admin-ajax.php?action=dpc_professional_textopt_wdf_idf_analysis',
			data: {
				keyword: focusKeyword,
				post_id: $("#wdf_idf_start").data('post_id'),
				sites: sites,
				lang: (jQuery('select#icl_post_language').length ? jQuery('select#icl_post_language').val() : (jQuery('select#post_lang_choice').length ? jQuery('select#post_lang_choice').val() : ''))
			},
			//dataType: 'json',
			success: function(response, state, responseObject){
				if(responseObject.getResponseHeader('Content-Type') == 'text/html'){
					$('.dpc_wdf_idf_results .loader').css({ display: 'none' });
					jQuery('#googleCaptchaModal').html(response).show(); //todo
				} else {
					$('.dpc_wdf_idf_results .loader').css({ display: 'none' });
					$('.dpc_wdf_idf_results .content').html('<table><thead><tr><th></th><th>Keyword</th><th>&#8709; '+dpc_professional_textopt_wdf_idf_translator['Frequency']+'</th><th>% '+dpc_professional_textopt_wdf_idf_translator['Frequency']+'</th><th></th></tr></thead></tbody><tbody></table>');
					$.each(response, function(i, item) {
						if(i == '__internal'){
							optimizer = $('.dpc-metabox-context-professional_textopt .optimizer');
							$('.word_count_check', optimizer).attr('data-best_word_count', item.best_word_count);
							$('.word_count_check .word_count_need', optimizer).text(item.best_word_count);
							$('.dpc_wdf_idf_results .optimizer').css({ display: 'block' });
						} else {
							$('.dpc_wdf_idf_results .content table tbody').append('<tr data-average_count="'+item.average_count+'" data-keyword="'+item.keyword+'" data-found="false" title="'+item.total+' '+dpc_professional_textopt_wdf_idf_translator.matches+' '+dpc_professional_textopt_wdf_idf_translator.on+' '+ item.urls.length +' '+dpc_professional_textopt_wdf_idf_translator.sites+' -> '+dpc_professional_textopt_wdf_idf_translator.wdfIdfScore+': '+item.wdf+'"><td class="status"><span class="dashicons dashicons-no"></span></td><td>'+item.keyword+'</td><td>'+item.average_count+'</td><td>'+item.average_count_percent+'</td><td><span class="add_to_stopwords" title="'+dpc_professional_textopt_wdf_idf_translator.AddToStopwords+'"></span></td></tr>');
						}
					});

					if($('.dpc_wdf_idf_results .content table tr').length > 1){
						$('.dpc_wdf_idf_results .content table tr').show();
					} else {
						$('.dpc_wdf_idf_results .content table tr').hide();
					}

					wdfIdfCheckKeywords();
					wdfIdfCheckOptimizations();
				}
			}
		});
	}

	/*
	$('#wdf_idf_copy_results').live('click', function(e){
		e.preventDefault();
		var text = '';
		$('.dpc_wdf_idf_results .content table tr').each(function(){
			text += $('td:eq(1)', this).text() + ', ';
		});
		text = text.substring(0,-2)
		window.prompt("Copy to clipboard: Ctrl+C, Enter", 'COPY TEXT');
	});
	*/



	function wdfIdfCheckOptimizations(){
		//if ($("#dpc-keyword").val().length == 0){
		//	return;
		//}
		optimizer		= $('.dpc-metabox-context-professional_textopt .optimizer');
		content_html	= getEditorContent('html');


		/*
		if(($('h1', content_html).length + $(content_html).filter('h1').length == 0) || content_html.length == 0){
			$('.h1_check .status', optimizer).removeClass('dashicons-no').addClass('dashicons-yes');
		} else {
			$('.h1_check .status', optimizer).removeClass('dashicons-yes').addClass('dashicons-no');
		}
		*/

		/*
		if($('h2, h3', content_html).length + $(content_html).filter('h2[id], h3[id]').length > 0 && content_html.length !== 0){
			$('.h2_h3_title_check .status', optimizer).removeClass('dashicons-no').addClass('dashicons-yes');
		} else {
			$('.h2_h3_title_check .status', optimizer).removeClass('dashicons-yes').addClass('dashicons-no');
		}
		*/

		if($('h2', content_html).length + $(content_html).filter('h2').length > 1 && content_html.length !== 0){
			$('.h2_check .status', optimizer).removeClass('dashicons-no').addClass('dashicons-yes');
		} else {
			$('.h2_check .status', optimizer).removeClass('dashicons-yes').addClass('dashicons-no');
		}

		if($('a', content_html).length + $(content_html).filter('a').length > 1  && content_html.length !== 0){
			$('.a_check .status', optimizer).removeClass('dashicons-no').addClass('dashicons-yes');
		} else {
			$('.a_check .status', optimizer).removeClass('dashicons-yes').addClass('dashicons-no');
		}

		if($('img', content_html).length + $(content_html).filter('img').length > 0  && content_html.length !== 0){
			$('.img_check .status', optimizer).removeClass('dashicons-no').addClass('dashicons-yes');
		} else if($('ul, ol', content_html).length + $(content_html).filter('ul, ol').length > 0  && content_html.length !== 0){
			$('.img_check .status', optimizer).removeClass('dashicons-no').addClass('dashicons-yes');
		} else if($('ul, ol', content_html).length + $(content_html).filter('ul, ol').length > 0  && content_html.length !== 0){
			$('.img_check .status', optimizer).removeClass('dashicons-no').addClass('dashicons-yes');
		} else {
			$('.img_check .status', optimizer).removeClass('dashicons-yes').addClass('dashicons-no');
		}

		/*
		if($('strong', content_html).length + $(content_html).filter('strong').length > 0  && content_html.length !== 0){
			$('.bold_italic .status', optimizer).removeClass('dashicons-no').addClass('dashicons-yes');
		} else if($('b', content_html).length + $(content_html).filter('b').length > 0  && content_html.length !== 0){
			$('.bold_italic .status', optimizer).removeClass('dashicons-no').addClass('dashicons-yes');
		} else if($('i', content_html).length + $(content_html).filter('i').length > 0  && content_html.length !== 0){
			$('.bold_italic .status', optimizer).removeClass('dashicons-no').addClass('dashicons-yes');
		} else {
			$('.bold_italic .status', optimizer).removeClass('dashicons-yes').addClass('dashicons-no');
		}
		*/

		//word count
		used_words				= getEditorStat().words;
		best_word_count			= parseInt($('.word_count_check', optimizer).attr('data-best_word_count'));
		word_count_tolerance	= parseInt(best_word_count / 100 * 20)
		min_word_count			= parseInt(best_word_count - word_count_tolerance);
		max_word_count			= parseInt(best_word_count + word_count_tolerance);

		$('.word_count_check .word_count_now', optimizer).text(used_words);
		if(focusKeyword.length){
			if(used_words < min_word_count){
				$('.word_count_check .status', optimizer).removeClass('dashicons-yes').addClass('dashicons-no');
				$('.word_count_check .current_state', optimizer).text(dpc_professional_textopt_wdf_idf_translator.short);
			} else if(used_words < best_word_count){
				$('.word_count_check .status', optimizer).removeClass('dashicons-no').addClass('dashicons-yes');
				$('.word_count_check .current_state', optimizer).text(dpc_professional_textopt_wdf_idf_translator.short);
			} else {
				$('.word_count_check .status', optimizer).removeClass('dashicons-no').addClass('dashicons-yes');
				$('.word_count_check .current_state', optimizer).text(dpc_professional_textopt_wdf_idf_translator.ideal);
			}
		}
	}

	jQuery('#wdf_idf_cral_google_sites').on('click', function(e){
		console.log(focusKeyword);
		e.preventDefault();
		googleUrl	= 'https://www.google'+dpc_professional_textopt_settings['wdf_idf']['searchEngine'][dpc_lang]+'/search?q='+focusKeyword;
		if(focusKeyword.length){
			var win = window.open(googleUrl, '_blank');
			win.focus();
		} else { console.log('No keyword set!'); return false; }
	});

	$('#wdf_idf_start').bind('click', function(){
		if (focusKeyword !== false){
			wdfIdfStartAnalysis();
		} else {
			alert(dpc_professional_textopt_translator.pleaseEnterKeyword);
		}
	});

	wdfIdfStart = null;

	jQuery('input.dpc_textopt_site').live('keyup', function(e){
		chechWdfIdfRequirements();
		clearTimeout(wdfIdfStart);
		focusKeyword = $('.keyword-list-item.primary').text();

		if(wdfIdfReady){
			wdfIdfStart = setTimeout(function(){
				if (focusKeyword !== false){
					wdfIdfStartAnalysis();
				} else {
					alert(dpc_professional_textopt_translator.pleaseEnterKeyword);
				}
			}, 3000);
		}
	});

});