<?php

//@todo: delete google search recursive
//@todo: delete site recursive

class DPC_Module_Professional_Textopt_Wdf_Idf {

	var $dpc					= null;
	var $settings				= array();
	var $global					= array();
	var $stopwords				= null;
	var $googleDomain			= '.de';
	var $keyword				= '';
	var $keywordMinLength		= 4;
	var $keywordMinCount		= 4;
	var $keywordMaxNum			= 5;
	var $siteResultCacheTime	= 300; //search result cache time in minutes

	function __construct(&$dpc){
		$this->dpc = $dpc;
		$this->settingsFileEdit = dirname(__FILE__) . '/edit.xml';

		wp_localize_script('dpc-professional-textopt-backend', 'dpc_professional_textopt_wdf_idf_translator', array(
		    'Keyword' 					=> esc_html__('Keyword', 'delucks-seo'),
		    'Density' 					=> esc_html__('Density', 'delucks-seo'),
		    'Frequency' 				=> esc_html__('Frequency', 'delucks-seo'),
		    'Copy results to clipboard' => esc_html__('Copy results to clipboard', 'delucks-seo'),
		    'matches' 					=> esc_html__('matches', 'delucks-seo'),
		    'on' 						=> esc_html__('on', 'delucks-seo'),
		    'sites' 					=> esc_html__('sites', 'delucks-seo'),
		    'wdfIdfScore'				=> esc_html__('wdf*idf score', 'delucks-seo'),
		    'AddToStopwords' 			=> esc_html__('Add to stopwords', 'delucks-seo'),
		    'short'						=> esc_html__('short', 'delucks-seo'),
		    'ideal'						=> esc_html__('ideal', 'delucks-seo')
		));
		#add_action('save_post',			array(&$this, 'savePost'));
		$this->settings = $this->dpc->getModuleSettings('professional_textopt');
		$this->settingsglobal = $this->settings;

		if(isset($this->settings['wdf_idf'])){
			$this->settings = $this->settings['wdf_idf'];
			$this->keywordMinLength = $this->settings['minimumKeywordLength'];
			$this->keywordMinCount = $this->settings['minimumKeywordCount'];
			$this->keywordMaxNum = $this->settings['maximumNumKeywords'];
			#$this->siteResultCacheTime = $this->settings['cacheTime'];
			$this->siteResultCacheTime = 0;
			$postLang = $this->dpc->oFunctions->getPostLang(isset($_GET['post_id']) ? intval($_GET['post_id']) : 0);
			
			if(is_array($postLang) && is_null($postLang['language_code']) && is_null($postLang['display_name'])){
			    //return because post dont have a language yet
                return;
			}

			if(is_array($postLang) && isset($postLang['language_code']) && strlen($postLang['language_code'])){
				$postLang = $postLang['language_code'];
			} elseif(isset($_GET['lang']) && strlen($_GET['lang'])){
			    $postLang = sanitize_text_field($_GET['lang']);
			}

			if(strpos($postLang, '_')){
				$postLang = substr($postLang, 0, strpos($postLang, '_'));
			}

			if(isset($this->settings['searchEngine'][$postLang])){
				$this->googleDomain = $this->settings['searchEngine'][$postLang];
			}
		}
		$this->dbSetup();
	}

	function clearCache(){
		global $wpdb;
		$wpdb->query("TRUNCATE TABLE `".$wpdb->prefix . 'dpc_wdf_idf_google_search'."`");
		$wpdb->query("TRUNCATE TABLE `".$wpdb->prefix . 'dpc_wdf_idf_sites'."`");
		$wpdb->query("TRUNCATE TABLE `".$wpdb->prefix . 'dpc_wdf_idf_keywords'."`");
	}

	function wdf_idf_add_stopword(){
	    if(strlen(sanitize_text_field($_GET['keyword']))){
	        $keyword = sanitize_text_field($_GET['keyword']);
			$postLang = $this->dpc->oFunctions->getPostLang(isset($_GET['post_id']) ? intval($_GET['post_id']) : 0);
			if(is_array($postLang) && isset($postLang['language_code']) && strlen($postLang['language_code'])){
				$postLang = $postLang['language_code'];
			}

			if(strpos($postLang, '_')){
				$postLang = substr($postLang, 0, strpos($postLang, '_'));
			}

			$this->addStopword($keyword, $postLang);
		}
		die();
	}

	function addStopword($stopword, $language){
		if(!strlen($language)){
			return;
		}
		$stopwordList = '';
		$settings = $this->dpc->getModuleSettings('professional_textopt');
		if(isset($settings['wdf_idf']) && isset($settings['wdf_idf']['stopwords']) && isset($settings['wdf_idf']['stopwords'][$language])){
			$stopwordList  = trim($settings['wdf_idf']['stopwords'][$language]);
		}
		$stopwordList .= (strlen($stopwordList) > 0 ? ',' . trim($stopword) : trim($stopword));
		$settings['wdf_idf']['stopwords'][$language] = $stopwordList;
		update_option('dpc_professional_textopt', $settings);
		$this->clearCache();
	}

	//wdf_idf
	function wdf_idf_analysis(){
		$this->clearCache();
		$sites = array();
		$structure = array();
		
		if(strlen(sanitize_text_field($_GET['keyword']))){
		    $this->keyword = sanitize_text_field($_GET['keyword']);
			if($this->updateRequired('google', $this->keyword)){
				if(isset($_GET['sites'])){
				    $sites =  array_map('esc_url_raw', $_GET['sites']);
				}
			} else {
				$sites = $this->dbGetGoogleSearchByKeyword($this->keyword, true);
			}

			if(count($sites)){
				$newSites = array();
				foreach($sites as $siteUrl){
					if(!$siteId = $this->dbGetWebsiteIdByUrl($siteUrl)){
						$this->dbInsertWebsite($siteUrl);
						$siteId		= $this->dbGetWebsiteIdByUrl($siteUrl);
						$this->dbInsertWebsiteToGoogleSearch($siteId, $this->keyword);
						$newSites[]	= $siteId;
					}

					if($this->updateRequired('site', $siteUrl) || in_array($siteId, $newSites)){
						$this->dbDeleteKeywordsBySiteId($siteId);
						$siteBody		= $this->getSiteBody($siteUrl);
						$structure['h2'] += count($siteBody->find('h2'));
						$structure['h3'] += count($siteBody->find('h3'));
						$structure['textlength'] += $this->getCharCount($siteBody);
						$siteKeywords	= $this->getTopKeywordsFromHtml($siteId, $siteBody);
						$this->dbInsertKeywords($siteId, $siteKeywords);
						$this->dbUpdateWebsite($siteId, array('word_count' => $this->getWordCount($siteBody), 'keyword_count' => $this->dbGetNumKeywords($siteId)));
					}
				}
			}
		}

		header('Content-Type: application/json');

		$res = array_merge($this->getTopKeywords(sanitize_text_field($_GET['keyword']), $this->keywordMaxNum), array('__internal' => array_merge($this->getBestWordCountValue())));
		
		if(isset($res['__internal'])){
		    $structure = array('h2' => ceil($structure['h2'] / ($res['__internal']['sites_total'] > 0 ? $res['__internal']['sites_total'] : 1)), 'h3' => ceil($structure['h3'] / ($res['__internal']['sites_total'] > 0 ? $res['__internal']['sites_total'] : 1)), 'textlength' => ($res['__internal']['sites_total'] > 1 ? ($structure['textlength'] / $res['__internal']['sites_total']) : $structure['textlength']), 'readability' => 0);
		    $res['__internal'] = array_merge($res['__internal'], $structure, $this->getOwnStructureDetails());
		}
		
		//add the custom keywords to the result list
		if(isset($_GET['ckeyword']) && count($_GET['ckeyword'])){
		    $customKeywords = array();
		    foreach(array_map('sanitize_text_field', $_GET['ckeyword']) as $keyword){
		        $customKeywords[trim($keyword)] = array('total' => '-', 'keyword' => $keyword, 'urls' => array(), 'wdf' => '-', 'density' => '-', 'average_count' => '-', 'average_count_percent' => '-');
		        array_pop($res);
		    }
		    $res = array_merge($customKeywords, $res);
		}

		echo wp_json_encode($res);
		die();
	}
	
	
	function getOwnStructureDetails(){
	    $postId = $_GET['post_id'];
	    $data = array('own_h2' => 0, 'own_h3' => 0, 'own_textlength' => 0, 'own_words' => '', 'own_wordcount' => 0, 'own_readability' => 0, 'own_readability_difficulty' => '');
	    if(!$postId){
	        return $data;
	    }
	    
	    $post = do_shortcode(get_the_content(null, false, $postId));
	    $html = str_get_html($post);

	    $data['own_h2'] = count($html->find('h2'));
	    $data['own_h3'] = count($html->find('h3'));
	    $data['own_textlength'] += $this->getCharCount($html);
	    $data['own_words'] = $this->getWordsArray($html);
	    if(count($data['own_words'])){
	        $data['own_wordcount'] = count($data['own_words']);
	        $data['own_words'] = implode(' ', $data['own_words']);
	    }
	    
	    require_once(dirname(__FILE__) . '/pattern.php');
	    require_once(dirname(__FILE__) . '/readability.php');
	    
	    
	    $pattern = new Pattern();
	    $readability = new Readability($pattern);
	    
	    $data['own_readability'] = $readability->ease_score(wp_strip_all_tags($post));
	    $difficulty = '';
	    if(is_int($data['own_readability']) || is_float($data['own_readability'])){
	        $data['own_readability'] = round($data['own_readability'], 2);
	        if($data['own_readability'] < 50){
	            $difficulty = __('Hard', 'delucks-seo');
	        } elseif($data['own_readability'] >= 50 && $data['own_readability'] < 70){
	            $difficulty = __('Middle', 'delucks-seo');
	        } else {
	            $difficulty = __('Easy', 'delucks-seo');
	        }
	        
	        $data['own_readability_difficulty'] = ' ('. $difficulty .')';
	    }

	    return $data;
	}
	

	function getBestWordCountValue(){
		$wordsTotal = 0;
		$sites = $this->dbGetGoogleSearchByKeyword(sanitize_text_field($_GET['keyword']));
		if(count($sites)){
			foreach($sites as $site){
				$wordsTotal += $site->word_count;
			}
		}
		return array('words_total' => $wordsTotal, 'sites_total' => count($sites), 'best_word_count' => intval($wordsTotal / (count($sites) ? count($sites) : 1)));
	}

	function getTopKeywords($keyword, $limit = 1000){
		$keywords = array();
		if(strlen($keyword)){
			$wordCountTotal = 0;
			$siteIds		= array();
			$searchResults	= $this->dbGetGoogleSearchByKeyword($keyword);
			foreach($searchResults as $searchResult){
				array_push($siteIds, $searchResult->url_id);
				$wordCountTotal += $searchResult->word_count;
			}

			foreach($siteIds as $siteId){
				#$keywords = array_merge($keywords, $this->dbGetKeywordsBySiteId($siteId)); //single values
				//merged values
				foreach($this->dbGetKeywordsBySiteId($siteId) as $keywordData){
					!isset($keywords[$keywordData->keyword]['total']) ? $keywords[$keywordData->keyword]['total'] = 0 : '';
					$keywords[$keywordData->keyword]['keyword']	= $keywordData->keyword;
					$keywords[$keywordData->keyword]['total']	+= $keywordData->keyword_count;

					$data = array('site_id' => $keywordData->site_id, 'url' => $this->dbGetWebsiteUrlById($keywordData->site_id), 'keyword_count' => $keywordData->keyword_count, 'word_count' => $this->dbGetWebsiteValueById('word_count', $keywordData->site_id));
					$data['density'] = round(($data['keyword_count'] / $data['word_count'] * 100), 3);
					$data['wdf'] = round(log($data['keyword_count']+1) / log($data['word_count']), 3);
					$keywords[$keywordData->keyword]['urls'][] = $data;
				}
				uasort($keywords, array($this, 'sortTopKeywordsByWordCount'));
			}

			//calculations
			foreach($keywords as $k => $v){
				$densityTotal = 0;
				$wdfTotal = 0;
				foreach($v['urls'] as $url_k => $url_v){
					$densityTotal += $url_v['density'];
					$wdfTotal += $url_v['wdf'];
				}
				$keywords[$k]['wdf'] = round($wdfTotal / count($v['urls']), 3);
				$keywords[$k]['density'] = round($densityTotal / count($v['urls']), 3);
				$keywords[$k]['average_count'] = round($v['total'] / count($v['urls']));
				$keywords[$k]['average_count_percent'] = round(($keywords[$k]['average_count'] / $wordCountTotal)*100, 2) ;
			}
			uasort($keywords, array($this, 'sortTopKeywordsByAverageWordCount'));
		}
		return array_slice($keywords, 0, $limit);
	}

	/**
	 * craw concret website
	 * @param stdClass $site
	 * @return void
	 */
	private function getSiteBody($site){
	    $url 		= $this->addhttp($site);
		$user_agent = 'Mozilla/5.0 (Windows NT 6.1; rv:8.0) Gecko/20100101 Firefox/8.0';

		$response = wp_remote_get($url, array(
		    'timeout' => 5,
		    'redirection' => 10,
		    'User-Agent' => 'Mozilla/5.0 (Windows NT 6.1; rv:8.0) Gecko/20100101 Firefox/8.0'
		));

		$content     = wp_remote_retrieve_body($response);
		$http_code    = wp_remote_retrieve_response_code($response);

		if ($http_code != 200) {
		    // todo remove from db
		    return;
		}

		$content = str_replace('><', '> <', $content);
		require_once(dirname(__FILE__) . '/simple_html_dom.php');
		$html = str_get_html($content);

		return $html;
	}

	function addhttp($url) {
	    if (!preg_match("~^(?:f|ht)tps?://~i", $url)) {
	        $url = "http://" . $url;
	    }
	    return $url;
	}

	/**
	 * save words of website
	 * @param stdClass $site
	 * @param string $html
	 */
	function getTopKeywordsFromHtml($siteId, $html){
		$text 		= $this->getWordsArray($html);
		$textArray 	= array_filter($text, array($this, 'skipStopwords'));
		$g 			= $this->groupWords($textArray);
		$bulkInsert = array();

		foreach ($g as $key => $times) {
			if($times < $this->keywordMinCount){
				continue;
			}
			$bulkInsert[] = array($key, $siteId, $times);
		}

		usort($bulkInsert, array($this, 'sortByWordCount'));
		return $bulkInsert;
	}

	/**
	 * check or item is stopword
	 * @param string $keyword
	 * @return boolean
	 */
	function skipStopwords($keyword){
		$keyword = trim($keyword);

		if (empty($keyword)) {
			return false;
		}

		// if number
		if ((string)(int)$keyword == $keyword) {
			return false;
		}

		// if to short
		if (strlen($keyword) < $this->keywordMinLength) {
			return false;
		}

		if (in_array(htmlentities($keyword), array('&middot;'))) {
			return false;
		}

		return !in_array($keyword, $this->getStopWords());
	}

	/**
	 * get stopwords. To have less DB queries, save to object.
	 * @return array
	 */
	private function getStopWords(){
		if(is_array($this->stopwords)){
			return $this->stopwords;
		}

		$urls_stopwordlist = array();
		$stopwordlist = array();
		$postLang = $this->dpc->oFunctions->getPostLang(isset($_GET['post_id']) ? $_GET['post_id'] : 0);

		if(is_array($postLang) && isset($postLang['language_code']) && strlen($postLang['language_code'])){
			$postLang = $postLang['language_code'];
		} elseif(isset($_GET['lang']) && strlen($_GET['lang'])){
		    $postLang = sanitize_text_field($_GET['lang']);
		}

		if(strpos($postLang, '_')){
			$postLang = substr($postLang, 0, strpos($postLang, '_'));
		}

		if(isset($this->settings['stopwords']) && $this->settings['stopwords'][$postLang]){
			$stopwordlist = explode(',', $this->settings['stopwords'][$postLang]);
		}

		if(isset($this->settings['includeUrlsStopwordList'])){
			$urls_settings		= $this->dpc->getModuleSettings('basic_urls');
			$urls_stopwordlist	= explode(',', $urls_settings[$postLang]['stopwordlist']);
			$stopwordlist		= array_merge($stopwordlist, $urls_stopwordlist);
		}

		$this->stopwords = $stopwordlist;
		return $stopwordlist;
	}

	/**
	 * explode string to array
	 * @param string $html
	 * @return array
	 */
	function getWordsArray($html){
		$text = preg_replace("/<([a-z][a-z0-9]*)[^>]*?(\/?)>/i",'<$1$2>', $html);
		$text = preg_replace('<!--(?!<!)[^\[>].*?-->', ' ', $text);
		$text = preg_replace(
				array(
						// Remove invisible content
						'@<head[^>]*?>.*?</head>@siu',
						'@<style[^>]*?>.*?</style>@siu',
						'@<script[^>]*?.*?</script>@siu',
						'@<object[^>]*?.*?</object>@siu',
						'@<embed[^>]*?.*?</embed>@siu',
						'@<applet[^>]*?.*?</applet>@siu',
						'@<noframes[^>]*?.*?</noframes>@siu',
						'@<noscript[^>]*?.*?</noscript>@siu',
						'@<noembed[^>]*?.*?</noembed>@siu',
						// Add line breaks before and after blocks
						'@</?((address)|(blockquote)|(center)|(del))@iu',
						'@</?((div)|(h[1-9])|(ins)|(isindex)|(p)|(pre))@iu',
						'@</?((dir)|(dl)|(dt)|(dd)|(li)|(menu)|(ol)|(ul))@iu',
						'@</?((table)|(th)|(td)|(caption))@iu',
						'@</?((form)|(button)|(fieldset)|(legend)|(input))@iu',
						'@</?((label)|(select)|(optgroup)|(option)|(textarea))@iu',
						'@</?((frameset)|(frame)|(iframe))@iu',
				),
				array(
						' ', 
						' ', 
						' ', 
						' ', 
						' ', 
						' ', 
						' ', 
						' ', 
						' ',
						"\n\$0", 
						//h:
						"\n\$0", 
						"\n\$0", 
						"\n\$0", 
						"\n\$0", 
						"\n\$0",
						"\n\$0", 
						"\n\$0",
				),
				$text );

		$text = wp_strip_all_tags($text);
		$text = html_entity_decode($text);
		$text = $this->_strtolower($text);
		$text = str_replace(array( /* html */'&#38;', '&amp;'), '&', $text);

		$text = str_replace(array( /* html */
				'&#183;', '&#064;', '&quot;', '&#8230;',
				'&euro;', '&nbsp;' , '&#160;', '&#32;', '&#33;', '&#34;',
				'&#35;', '&#36;', '&#37;', '&#64;',
				'&#39;', '&#40;', '&#48;', '&#150;',
				'&#49;', '&lt;', '&gt;', '&#8212;',
				'&#50;','&#51;','&#52;','&#53;',
				'&#54;','&#55;', '&#160;', '&#126;',
				'&#161;', '&#162;', '&#163;', '&#164;', '&#165;', '&#166;',
				'&#167;', '&#168;', '&#169;', '&#170;', '&#171;',
				'&#172;', '&#173;', '&#174;', '&#175;', '&nbsp;', '&iexcl;', '&cent;',
				'&pound;', '&curren;', '&yen;', '&brvbar;', '&rarr;',
				'&#8230;', '&hellip;', '&bull;',
				'&sect;', '&uml;', '&copy;', '&ordf;', '&shy;',
				'&laquo;', '&not;', '&shy;', '&reg;', '&macr',
				'&#56;','&#57;','&#58;','&#59;','&#60;','&#61;',
				'&#62;','&#63;', '&#41;', '&#42;', '&#43;', '&rsaquo;',
				'&#44;', '&#45;', '&#46;', '&#47;', '&raquo;', '&laquo;'
		), ' ', $text);
		$text = str_replace(array(
				'...', '..', '. ', ',', '-', '?', '!', ':', '(', ')', '"', '[', ']', '>', '<', '/', '\'\'', '#', 'Ã‚Â©',
				'Ã¢â‚¬â€�', 'Ã¢â‚¬Â²', 'Ã¢â‚¬Â³', 'Ã‹Å¡', ';', 'Ã¢â‚¬Å“', 'Ã¢â‚¬Å¾', 'Ã¢â‚¬â€œ', 'Ã¢â‚¬ï¿½', '*', '|', '@', '}', '{', '=', '%', '`'
		), ' ', html_entity_decode($text));
		$text = trim(preg_replace("/\s+/", " ", $text));

		$textArray = explode(" ", $text);

		foreach ($textArray as $key => $value) {
			$valueInHtml = htmlentities($value);
			$valueInHtml = str_replace(array(
					'&nbsp;', '&middot;', '&bull;', '&dagger;', '&reg;',
					'&Prime;', '&lt;', '&rdquo;', '&raquo;', '&quot;',
					'&prime;', '&ndash;', '&mdash;',
					'&ldquo;', '&gt;', '&copy;', '&bdquo;'
			), ' ', $valueInHtml);

			$valueInHtml = trim($valueInHtml);

			if (strlen($valueInHtml) == 0) {
				unset($textArray[$key]);
				continue;
			}

			$textArray[$key] = html_entity_decode($valueInHtml);
		}

		return $textArray;
	}

	/**
	 * group array of strings by the same string and get count of every string
	 * @param array $array
	 * @return array
	 */
	static function groupWords($array){
		$g = array();
		foreach ($array as $value) {
			if (!isset($g[$value])) {
				$g[$value] = 0;
			}
			$g[$value]++;
		}
		return $g;
	}

	function sortByWordCount($a, $b){
		return (int)($a[2] < $b[2]);
	}

	function sortTopKeywordsByWordCount($a, $b){
		return (int)($a['total'] < $b['total']);
	}

	function sortTopKeywordsByAverageWordCount($a, $b){
		return (int)($a['average_count'] < $b['average_count']);
	}

	/**
	 * convert string to lowercase
	 * @param string $string
	 * @return string
	 */
	static function _strtolower($string){
		if (extension_loaded('mbstring')) {
			return mb_strtolower($string, 'UTF-8');
		}

		return strtolower($string);
	}

	static function filterSingleCharValue($string){
		return strlen($string) > 1 ? true : false;
	}
	
	/**
	 * return word count in html
	 * @param string $html
	 * @return int
	 */
	static function getWordCount($html){
		$html = preg_replace('/<script\b[^>]*>(.*?)<\/script>/is', "", $html); //remove javascript
		$html = preg_replace('/<style\b[^>]*>(.*?)<\/style>/is', "", $html); //remove style
		$html = str_replace(array('&euro;', '&copy;'), ' ', $html); //remove special chars
		$html = html_entity_decode(wp_strip_all_tags($html)); //remove html
		$html = str_replace(array('.', ',', '-', '?', '!', '+', ':', '-', '&', '/', '*', '€', '(', ')', '„', '“'), ' ', $html); //remove special chars
		$html = preg_replace('/[0-9]+/', '', $html); //remove all numbers
		$html = preg_replace(array('/\s{2,}/', '/[\t\n]/'), ' ', $html); //remove multiple whitespace
		$html = preg_replace('/\s\s+/', ' ', $html);
		$html = strtolower($html);

		$wordsArray = explode(' ', $html);
		if(is_array($wordsArray)){
		    $wordsArray = array_filter($wordsArray);
		    $wordsArray = array_filter($wordsArray, array(__CLASS__, 'filterSingleCharValue') );
		}

		$total = count($wordsArray);
		return $total;
	}
	
	
	/**
	 * return char count in html
	 * @param string $html
	 * @return int
	 */
	static function getCharCount($html){
	    $html = preg_replace('/<script\b[^>]*>(.*?)<\/script>/is', "", $html); //remove javascript
	    $html = preg_replace('/<style\b[^>]*>(.*?)<\/style>/is', "", $html); //remove style
	    $html = str_replace(array('&euro;', '&copy;'), ' ', $html); //remove special chars
	    $html = html_entity_decode(wp_strip_all_tags($html)); //remove html
	    $html = str_replace(array('.', ',', '-', '?', '!', '+', ':', '-', '&', '/', '*', '€', '(', ')', '„', '“'), ' ', $html); //remove special chars
	    $html = preg_replace('/[0-9]+/', '', $html); //remove all numbers
	    $html = preg_replace(array('/\s{2,}/', '/[\t\n]/'), ' ', $html); //remove multiple whitespace
	    $html = preg_replace('/\s\s+/', ' ', $html);
	    $html = strtolower($html);
	    
	    $total = 0;
	    $wordsArray = explode(' ', $html);
	    if(is_array($wordsArray)){
	        $wordsArray = array_filter($wordsArray);
	        $wordsArray = array_filter($wordsArray, array(__CLASS__, 'filterSingleCharValue') );
	        $wordsArray = implode(' ', $wordsArray);
	        $total = strlen($wordsArray);
	    }
	    
	    return $total;
	}

	function dbSetup(){
		global $wpdb;

		//sites
		$table_name = $wpdb->prefix . 'dpc_wdf_idf_sites';
		$wpdb->query($wpdb->prepare("CREATE TABLE IF NOT EXISTS `%s` (
			`id` int(11) unsigned NOT NULL AUTO_INCREMENT,
			`url` varchar(255) CHARACTER SET utf8 NOT NULL,
			`word_count` int(11) unsigned NOT NULL,
			`keyword_count` int(11) unsigned NOT NULL,
			`updated` datetime DEFAULT NULL,
			PRIMARY KEY (`id`),
			UNIQUE KEY `url` (`url`)
		  ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci AUTO_INCREMENT=1;", array(
			  $table_name
		  )));

		//keywords
		$table_name = $wpdb->prefix . 'dpc_wdf_idf_keywords';
		$wpdb->query($wpdb->prepare("CREATE TABLE IF NOT EXISTS `%s` (
			`id` int(11) unsigned NOT NULL AUTO_INCREMENT,
			`site_id` int(11) unsigned NOT NULL,
			`keyword` varchar(255) CHARACTER SET utf8 NOT NULL,
			`keyword_count` int(11) unsigned NOT NULL,
			`updated` datetime DEFAULT NULL,
			PRIMARY KEY (`id`)
			) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci AUTO_INCREMENT=1;", array(
				$table_name
			)));

		//google search
		$table_name = $wpdb->prefix . 'dpc_wdf_idf_google_search';
		$wpdb->query($wpdb->prepare("CREATE TABLE IF NOT EXISTS `%s` (
			`id` int(11) unsigned NOT NULL AUTO_INCREMENT,
			`url_id` int(11) unsigned NOT NULL,
			`keyword` varchar(255) CHARACTER SET utf8 NOT NULL,
			`updated` datetime DEFAULT NULL,
			PRIMARY KEY (`id`)
			) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci AUTO_INCREMENT=1;", array(
				$table_name
			)));

		$wpdb->hide_errors();
	}

	function dbInsertWebsite($siteUrl, $wordCount = 0, $keywordCount = 0){
		global $wpdb;
		$table_name = $wpdb->prefix . 'dpc_wdf_idf_sites';
		$wpdb->insert($table_name, array(
				'url' => $siteUrl,
				'word_count' => $wordCount,
				'keyword_count' => $keywordCount,
				'updated' => current_time('mysql')
		));
	}

	function dbInsertWebsiteToGoogleSearch($siteId, $keyword){
		global $wpdb;
		$table_name = $wpdb->prefix . 'dpc_wdf_idf_google_search';
		$wpdb->insert($table_name, array(
				'url_id' => $siteId,
				'keyword' => $keyword,
				'updated' => current_time('mysql')
		));
	}

	function dbUpdateWebsite($id, $data){
		global $wpdb;
		$table_name = $wpdb->prefix . 'dpc_wdf_idf_sites';
		return $wpdb->update( $table_name, $data,	array("id" => $id ));
	}

	function dbGetWebsiteIdByUrl($siteUrl){
		global $wpdb;
        return $wpdb->get_var($wpdb->prepare("SELECT `id` FROM %s WHERE url = %s", array(
			$wpdb->prefix . 'dpc_wdf_idf_sites',
			$siteUrl
		)));
	}

	function dbGetWebsiteUrlById($siteId){
		global $wpdb;
		return $wpdb->get_var($wpdb->prepare("SELECT `url` FROM `%s` WHERE id = %s", array(
			$wpdb->prefix . 'dpc_wdf_idf_sites',
			$siteId
		)));
	}

	function dbGetWebsiteValueById($field, $siteId){
		global $wpdb;
		return $wpdb->get_var($wpdb->prepare("SELECT %s FROM `%s` WHERE id = %s", array(
			$field,
			$wpdb->prefix . 'dpc_wdf_idf_sites',
			$siteId
		)));
	}

	function dbGetNumKeywords($siteId){
		global $wpdb;
		return $wpdb->get_var($wpdb->prepare("SELECT SUM(keyword_count) FROM `%s` WHERE site_id = %s", array(
			$wpdb->prefix . 'dpc_wdf_idf_keywords',
			$siteId
		)));
	}

	function dbInsertKeywords($siteId, $keywords){
		global $wpdb;
		$table_name = $wpdb->prefix . 'dpc_wdf_idf_keywords';
		foreach($keywords as $keyword){
			$wpdb->insert($table_name, array(
					'site_id' => $siteId,
					'keyword' => $keyword[0],
					'keyword_count' => $keyword[2],
					'updated' => current_time('mysql')
			));
		}
	}

	function dbGetKeywordsBySiteId($siteId){
		global $wpdb;
		return $wpdb->get_results($wpdb->prepare("SELECT * FROM `%s` WHERE site_id = %s", array(
			$wpdb->prefix . 'dpc_wdf_idf_keywords',
			$siteId
		)));
	}

	function dbDeleteKeywordsBySiteId($siteId){
		global $wpdb;
		$table_name = $wpdb->prefix . 'dpc_wdf_idf_keywords';
		$wpdb->delete($table_name, array('site_id' => $siteId));
	}

	function dbGetGoogleSearchByKeyword($keyword, $urlOnly = false){
		$data = array();
		global $wpdb;
		$rows = $wpdb->get_results($wpdb->prepare("SELECT g.*, s.url, s.word_count FROM `%s` AS g LEFT JOIN {$wpdb->prefix}dpc_wdf_idf_sites AS s ON s.id = g.url_id WHERE g.`keyword`=%s LIMIT 10", array(
			$wpdb->prefix . 'dpc_wdf_idf_google_search',
			$keyword
		)));

		if($urlOnly){
			if(count($rows)){
				foreach($rows as $row){
					$data[] = $row->url;
				}
			}
			return $data;
		}
		return $rows;
	}

	function updateRequired($type, $selector = ''){
		return true;
		global $wpdb;

		switch($type){
			case 'site':
				$max = $wpdb->get_var($wpdb->prepare("SELECT MAX(updated) FROM `%s` WHERE `url` = %s", array(
					$wpdb->prefix . 'dpc_wdf_idf_sites',
					$selector
				)));
				break;
			case 'google':
				$max = $wpdb->get_var($wpdb->prepare("SELECT MAX(updated) FROM `%s` WHERE `keyword` = %s", array(
					$wpdb->prefix . 'dpc_wdf_idf_google_search',
					$selector
				)));
				break;
		}

		return strtotime($max)+60*$this->siteResultCacheTime < time();
	}

	function wdf_idf_metabox_callback($post) {
		$settings = get_post_meta( $post->ID, '_dpc-textopt-sites', true );
		echo '<input type="hidden" id="dpc_wdf_idf_post_id" value="'.esc_attr(get_the_ID()).'" />';


		echo '<span>'.esc_html__('Formats', 'delucks-seo').':</span>';

		/**
		 * Checklist
		 */
		echo '		<div class="row optimizer">';
		echo '			<div class="col-md-3 col-sm-12">';
		echo '				<span class="optimizer-list-element h2_check"><span class="status dashicons dashicons-no"></span> '. esc_html__('Min. two headlines 2 used', 'delucks-seo') .'</span>';
		echo '			</div>';
		echo '			<div class="col-md-3 col-sm-12">';
		echo '				<span class="optimizer-list-element a_check"><span class="status dashicons dashicons-no"></span> '. esc_html__('Min. two links inserted', 'delucks-seo') .'</span>';
		echo '			</div>';
		echo '			<div class="col-md-3 col-sm-12">';
		echo '				<span class="optimizer-list-element img_check"><span class="status dashicons dashicons-no"></span> '. esc_html__('List/ images used in content', 'delucks-seo') .'</span>';
		echo '			</div>';
		echo '			<div class="col-md-3 col-sm-12">';
		echo '				<span class="optimizer-list-element word_count_check" data-best_word_count="0"><span class="status dashicons dashicons-no"></span> '. esc_html($this->dpc->getText("Text %s (Target: %s words +/- %s, Is: %s words)", array('<span class="current_state">'.esc_html__('short', 'delucks-seo').'</span>', '<span class="word_count_need">?</span>', '20%', '<span class="word_count_now">?</span>'))).'</span>';
		echo '			</div>';
		echo '		</div>';
		#echo '	</div>';
		#echo '</div>';

		echo '<div style="clear: both"></div>';


		echo '<span>'.esc_html__('Relevance comparison', 'delucks-seo').':</span>';

		/**
		 * wdf*idf urls & results
		 */
		echo '<div class="row">';
		echo '	<div class="col-md-6 col-sm-12">';
		echo '		<div class="competitor_sites">';
						$this->dpc->guiSettings = false;
						$this->dpc->parseSettingsByXml($this->settingsFileEdit, 'sites-form', false, true, false, $settings);
		echo '			<div class="clear"></div><br/>';
		echo '			<div>
							<div class="col-md-6 col-sm-12 no-padding-left">
								<button id="wdf_idf_cral_google_sites" class="btn btn-default btn-md btn-block" name="dpc[realnames][wdf_idf_cral_google_sites]" value="">'. esc_html__('Search results', 'delucks-seo') .' </button>
							</div>
							<div class="col-md-6 col-sm-12 no-padding-right">
								<span id="wdf_idf_start" class="btn btn-info btn-md btn-block" data-post_id="'.esc_attr(get_the_ID()).'">'.esc_html__('Compare sites', 'delucks-seo').'</span>
							</div>
						</div>';
		echo '			<div class="clear"></div><br/>';
		echo '			<div>
							<div class="col-md-6 col-sm-12 no-padding-left">
								<a href="http://answerthepublic.com/" target="_blank" class="btn btn-default btn-md btn-block answerthepublic"><i class="fa fa-external-link-square"></i> '.esc_html__('Content questions', 'delucks-seo').'</a>
							</div>
							<div class="col-md-6 col-sm-12 no-padding-right">
								<a href="http://www.siteliner.com/" target="_blank" class="btn btn-default btn-md btn-block answerthepublic"><i class="fa fa-external-link-square"></i> '.esc_html__('Duplicate Content', 'delucks-seo').'</a>
							</div>
						</div>';


		echo '		</div>';
		echo '	</div>';

		echo '	<div class="col-md-6 col-sm-12 no-padding dpc_wdf_idf_results">';
		echo '		<div class="loader" style="display: none;"></div>';
		echo '		<div class="content"><div class="intro-description">'.esc_html__("Paste on the left URLs of your competitors for the same topic. Therefor click on the search results button and have a look of the competitors in Google. Check if their content or offer is similar to yours, copy their URLs then and paste them by clicking on the add site button. After you pasted all links to your competitors (at least 2 recommended), click on the compare sites button to see, which words Google expects in your content. The words which are highlighted with a red cross are not in your context yet and should be mentioned, if they fit in your text. If a word does not fit at all, add it to the stopword (ignore) list by clicking on the red icon on the right. All words which are orange, could be mentioned more often. All green words are already good.", 'delucks-seo').'</div></div>';
		echo '	</div>';

		echo '	<div class="clear"></div><br/>';


		/**
		 * Memo field
		 */

		if(isset($this->settingsglobal['memoField']) && $this->settingsglobal['memoField'] == 'on'){
			echo '<div class="col-md-12 col-sm-12">';
			echo '	<strong>'. esc_html__('Internal memo (invisible)', 'delucks-seo') .'</strong>';
			echo '	<div id="memofield">';
			echo '		<div>';
			echo '			<div class="memo-field-wrapper">';
			echo '				<div class="form-group">
									<div class="col-md-12">
										<textarea name="dpc-memo" cols="" rows="5" style="width: 100%;">'.esc_textarea(get_post_meta( $post->ID, '_dpc-memo', true )).'</textarea>
									</div>
								</div>';
			echo '			</div>';
			echo '		</div>';
			echo '	</div>';
			echo '	<div style="clear: both"></div>';
			echo '</div>';
		}

		echo '</div>';
	}
}
