jQuery(document).ready(function($){
	"use strict";

	function buildShareUrl(elem, url, params){
		if(typeof(dpc_professional_sharing_utm_params) == 'object'){
			params = params.concat(dpc_professional_sharing_utm_params);
		}

		var paramString = '';
		$(params).each(function(i, param){
			if(param.empty != true && param.value == ''){
				return;
			}
			if(i !== 0){ paramString += '&'; }
			paramString += param.key + '=' + param.value;
		});
		return url + paramString;
	}

	$('.dpc-btn-share.pinterest').click(function(e){
		e.preventDefault();
		var config			= $(this).data('config');
		var clickedButton 	= jQuery(this);
		var network 		= jQuery(this).attr('class').replace('delucksShareButton','').replace(' ', '');
		var images 			= [];
		var imagesSrc 		= [];

		var pinterstMinWidth = 0;
		var pinterstMinHeight = 0;

		if(typeof(config['min-width']) != 'undefined' && parseInt(config['min-width'])){
			pinterstMinWidth = parseInt(config['min-width']);
		}

		if(typeof(config['min-height']) != 'undefined' && parseInt(config['min-height'])){
			pinterstMinHeight = parseInt(config['min-height']);
		}

		jQuery('body').find('img').each(function(){
			if(jQuery(this).height() >= pinterstMinHeight && jQuery(this).width() >= pinterstMinWidth && !jQuery(this).hasClass('dpc-sharing-dont-share')){
				if(jQuery.inArray(jQuery(this).attr('src'), imagesSrc) == -1){ //duplicate check
					images.push(jQuery(this));
					imagesSrc.push(jQuery(this).attr('src'));
				}
			}
		});

		if(images.length){
			var imageUrl;
			jQuery('body').prepend('<div aria-hidden="false" aria-labelledby="dpcSharingModalPinterest" role="dialog" tabindex="-1" id="dpcSharingModalPinterest" class="modal fade in" style="display: block;"><div class="dpc-modaldialog"><div class="dpc-modalcontent"><div class="dpc-modalheader"><button data-dismiss="modal" class="close" type="button"><span aria-hidden="true">×</span><span class="sr-only">Close</span></button><h4 id="dpcModalTitle" class="dpc-modaltitle">Pin it!</h4></div><div id="dpc-modalbody" class="dpc-modalbody pinterest"></div><div class="dpc-modalfooter"><button data-dismiss="modal" class="btn btn-default" type="button">Abbrechen</button></div></div></div></div>');
			jQuery(images).each(function(){
				if(typeof(jQuery(this).parent().attr('href')) !== 'undefined' && jQuery(this).parent().attr('href').length){
					if(jQuery(this).parent().attr('href').match(/\.(jpeg|jpg|gif|png)$/) != null){
						imageUrl = jQuery(this).parent().attr('href');
					} else {
						imageUrl = jQuery(this).attr('src');
					}
				} else {
					imageUrl = jQuery(this).attr('src');
				}

				var shareUrl = buildShareUrl(clickedButton, 'http://pinterest.com/pin/create/button/?', [ {'key': 'url', 'value': $(clickedButton).data('post_url'), 'empty': false}, {'key': 'media', 'value': imageUrl, 'empty': false}, {'key': 'description', 'value': $(clickedButton).data('post_title'), 'empty': true} ]);
				var link = '<a target="_blank" href="'+shareUrl+'"><img src="'+jQuery(this).attr('src')+'" title="'+$(clickedButton).data('post_title')+'" alt="'+$(clickedButton).data('post_title')+'" /></a>';
				jQuery('.dpc-modalbody.pinterest').append(link);
			});

			jQuery('.dpc-modalbody.pinterest a, .dpc-modalbody.pinterest img').click(function(){
				jQuery('#dpcSharingModalPinterest').fadeOut(function(){
					jQuery(this).remove();
				});
			});
			jQuery('#dpcSharingModalPinterest').fadeIn(function(){
				jQuery('body').addClass('dpc-share-active');
				jQuery(this).click(function(){
					jQuery(this).fadeOut(function(){
						jQuery('body').removeClass('dpc-share-active');
						jQuery(this).remove();
					});
				});
			});
		}
	});
});